﻿<%
'------------------------------------------------------------------------------------------------------------------------------------------
' SOOP 2.0 - Phoenix (TNG)
'
' Revision 2.00 - initial 15/02/2008
'
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'------------------------------------------------------------------------------------------------------------------------------------------

class class_assetman ':: global, class_string, class_fso, class_languageParser, class_utils
	'
	public  arrBaseFolder
	public  arrBaseName
	public  assetSize
	public  assetTypes
	public  assetType
	public  assetMsg
	public  ffilter
	public  sContent
	public  sContentType
	public  bWriteFolderAdmin
	public  sOptions
	public  sFolder
	public  sFolder_py	
	public  currFolder
	public  currFolder_py
	public  sPath
	public  bAllowUploadButtons
	public  sUploadedFile
	public  oUpload
	public  oFile
	public  sFileToDelete
	public  pageDocType
	'
	private p_msg
	private p_mode
	'
	public  property let emsg(s)
		if s  = "" then exit property
		p_msg = p_msg & "<br />" & s
	end property

	public  property get emsg
		emsg = p_msg
	end property
	'
	public  property let imode(i)
		if cor.filter.checkInt(i) = 0 then exit property
		p_mode = cor.filter.checkInt(i)
	end property

	public  property get imode
		imode = p_mode
	end property
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	' Init class: set internal environment
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	public sub init(intMode)
		'
		cor.lng.includeSection("cor_xmlAssetman")
		if cor_bGuest Then cor.redirm lngAccessDenied, "msg.asp?emb=1"
		'
		p_mode = intMode
		'
		' relative paths (do NOT add first slash. DO add last slash)
		'	
		redim arrBaseFolder(4)
		redim arrBaseName(4)
		arrBaseName(0)		= lngAMMyFiles
'		arrBaseFolder(0)	= "uploads/" & cor.filter.validFilename(cor_sLoggedInUsername) & "/uploads/assets/"
'	there is an easier way to do this:
'		dim userFolder : userFolder = Len(cor_lUserID)
'		select case userFolder
'			case 1
'				arrBaseFolder(0) = "uploads/00000" & cor_lUserID & "/uploads/assets/"
'			case 2
'				arrBaseFolder(0) = "uploads/0000" & cor_lUserID & "/uploads/assets/"
'			case 3
'				arrBaseFolder(0) = "uploads/000" & cor_lUserID & "/uploads/assets/"
'			case 4
'				arrBaseFolder(0) = "uploads/00" & cor_lUserID & "/uploads/assets/"
'			case 5
'				arrBaseFolder(0) = "uploads/0" & cor_lUserID & "/uploads/assets/"
'			case 6
'				arrBaseFolder(0) = "uploads/" & cor_lUserID & "/uploads/assets/"
'		end select
		arrBaseFolder(0) = "uploads/" & Right(String(6,"0") & cor_lUserID, 6)
		arrBaseName(1)		= ""
		arrBaseFolder(1)	= ""
		'
		select case cor.filter.checkInt(cor.asset.imode)
		case 1 
			arrBaseName(1)		= lngAMCommonAvatars
			arrBaseFolder(1)	= "uploads/assets/avatars/"
		case 2
			arrBaseName(1)		= "System Assets"
			arrBaseFolder(1)	= "uploads/assets/"
		case 3
		case 4
		case 5
			arrBaseName(1)		= ""
			arrBaseFolder(1)	= ""
		end select
		arrBaseName(2)		= ""
		arrBaseFolder(2)	= ""
		arrBaseFolder(3)	= ""
		arrBaseName(3)		= ""
		'
		' Create folders via FSO if they don't exists for the concerned member
		' remove all invalid characters from username
		'
		call cor.obj.init("fso")
		'
		emsg = cor.util.createFoldersV(arrBaseFolder(0))
		if emsg <> "" then emsg = lngAMInvalidInput
		'	
		' init browser
		'
		cor.asset.ffilter = lcase(cor.io.q("ffilter"))
		'
		select case lcase(cor.io.q("ffilter"))
			case "image"
				assetSize		= cor_lUploadSizeImage
				assetTypes		= cor_lUploadTypesImage
				assetType		= "image"
				assetMsg		= lngAMUploadSize & ": " & formatNumber(assetSize/1000000,1) & " mb - " & lngAMTypes & ": " & assetTypes
			case "media"
				assetSize		= cor_lUploadSizeMedia
				assetTypes		= cor_lUploadTypesMedia
				assetType		= "audio"
				assetMsg		= lngAMUploadSize & ": " & formatNumber(assetSize/1000000,1) & " mb - " & lngAMTypes & ": " & assetTypes
			case "file"
				assetSize		= cor_lUploadSizeFile
				assetTypes		= cor_lUploadTypesFile
				assetType		= "misc"
				assetMsg		= lngAMUploadSize & ": " & formatNumber(assetSize/1000000,1) & " mb - " & lngAMTypes & ": " & assetTypes
			case "misc"
				assetSize		= cor_lUploadSizeMisc
				assetTypes		= cor_lUploadTypesMisc
				assetType		= "misc"
				assetMsg		= lngAMUploadSize & ": " & formatNumber(assetSize/1000000,1) & " mb - " & lngAMTypes & ": " & assetTypes
			case else
				assetSize		= 0
				assetTypes		= ""
				assetType		= ""
				assetMsg		= ""
		end select
		'
		set oUpload = new class_assetmanUpload 
		server.scriptTimeout = 7000
		'
		'--- Upload class and FSO configuration
		'
		oUpload.AllowedTypes = assetTypes
		oUpload.MaxFileSize  = assetSize
		'
		if oUpload.isUpload Then oUpload.init()	'init createObject()
		oUpload.recieve()
		'
		' Find current folder
		'
		call cor.obj.init("fso")
		'
		if oUpload.ErrNum = 1 Then 'default (form enctype is not multipart/form-data)
			ffilter 	= cor.io.r("ffilter")
			currFolder  = cor.io.r("inpCurrFolder")
			if  currFolder <> "" Then 
				if NOT cor.obj.fso.folderExists(server.mapPath(currFolder)) Then currFolder = arrBaseFolder(0)
			else
				currFolder = arrBaseFolder(0)
			end if	
			currFolder_py = server.mapPath(currFolder)
			'		
			if len(cstr(cor.io.r("inpFileToDelete"))) <> 0 then 			'delete file
				sFileToDelete = server.mappath(cstr(cor.io.r("inpFileToDelete")))
				if cor.obj.fso.FileExists(sFileToDelete) Then
					set oFile = cor.obj.fso.getFile(sFileToDelete)
					On error resume next
					oFile.Delete
					if err.number <> 0 then emsg = err.description : err.clear
					On error goto 0
					set oFile = nothing
				end if
			end if
		else
			ffilter = oUpload.requestValue("inpFilter")'ffilter
			'	
			' Upload processing
			'
			if len(cstr(oUpload.requestValue("inpCurrFolder")))=0 then	'opened folder
				currFolder = arrBaseFolder(0)
			else
				currFolder = oUpload.requestValue("inpCurrFolder")
			end if
			currFolder_py  = server.mapPath(currFolder)
			'
			if oUpload.ErrNum = 0 Then
				if  oUpload.requestFileStatus("uploadFile") Then
					sPath 	 = currFolder_py & "\" & oUpload.requestValue("uploadFile")
					sContent = oUpload.requestFileContent("uploadFile")
					On error resume next
					oUpload.saveFile sPath, sContent
					if err.number <> 0 then emsg = err.description : err.clear
					On error goto 0
					sUploadedFile = mid(sPath,instrRev(sPath,"\")+1)	'uploaded file name
				else
					emsg = lngAMFileTypeNotAllowed
				end if
			else 
				emsg =  oUpload.ErrMsg
			end if
			'
		end if
		set oUpload = nothing
		'
		' Assetman permissions
		'
		bWriteFolderAdmin = false
		if cor_bAdmin OR cor_bModerator Then bWriteFolderAdmin = true
		' Opened folder is member's personal folder and he/she can administer it
		if instr(lcase(currFolder), lcase(arrBaseFolder(0))) > 0  then bWriteFolderAdmin   = true
		' if certain conditions meet allow upload buttons
		if ffilter <> "" AND assetSize > 0 AND bWriteFolderAdmin then bAllowUploadButtons = true
		'
		pageDocType = "<!DOCTYPE HTML public  ""-//W3C//DTD HTML 4.01 Transitional//EN"">"
	end sub
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	' Event Process
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	public sub controller(byVal eventIn)
		dim iDo
	'
	'--- first handle any errors that may have occurred during init
		if emsg <> "" then exit sub
	'
		iDo = cor.filter.checkInt(eventIn) : if iDo = 0 Then exit sub
	'
	select case iDo
		'
		case cor_cDoNew
		'
		' post form
		'
			if  NOT cor_bPostback Then exit sub
			if  NOT cor.io.r("inpNewFolderName") = "" Then
				sFolder 	= cor.io.r("inpCurrFolder") & cor.io.r("inpNewFolderName")
				sFolder_py  = server.mapPath(sFolder)
				call cor.obj.init("fso")
				if  cor.obj.fso.FolderExists(sFolder_py) Then
					emsg = lngAMFolderExist
				else
					emsg = cor.util.createFoldersP(sFolder_py)
					if  emsg <> "" then
						emsg = lngAMInvalidInput
					else
						emsg = lngAMFolderCreated
					end if
				end if
			end if
		'
	case cor_cDoDelete
		'
		' post form
		'
			if  NOT cor_bPostback Then exit sub
			if  NOT cor.io.r("inpCurrFolder") = "" Then
				sFolder = server.mappath(cor.io.r("inpCurrFolder"))
				call cor.obj.init("fso")
				if  cor.obj.fso.FolderExists(sFolder) Then
					On error resume next 
					cor.obj.fso.DeleteFolder(sFolder)
					if err.number <> 0 then emsg = err.description : err.clear
					On error goto 0					
					if emsg = "" then emsg = lngAMFolderDeleted
				else
					emsg = lngAMFolderNotExist
				end if
			end if
			'
		case else ' (should never happen)
			 cor.redirm lngUnknownActivity, "msg.asp?emb=1"
		end select
		'
	end sub
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	' 
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	public  sub writeFolderSelections()
		str.wri "<select name='selCurrFolder' id='selCurrFolder' onchange='asset_changeFolder()' class='inpSel'>"

		if arrBaseFolder(1) = "" then
			response.write recursive(arrBaseFolder(0))
		elseif arrBaseFolder(2) = "" then
			recursive arrBaseFolder(0) 
			response.write recursive(arrBaseFolder(1))
		elseif arrBaseFolder(3) = "" then
			recursive arrBaseFolder(0)
			recursive arrBaseFolder(1)
			response.write recursive(arrBaseFolder(2))
		else
			recursive arrBaseFolder(0)
			recursive arrBaseFolder(1)
			recursive arrBaseFolder(2)
			response.write recursive(arrBaseFolder(3))
		end if
			
		str.wri "</select>"
	end sub
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	' 
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	public  sub writeMediaSelector()
		dim sAll, sMedia, sImage, sMisc, sFile
		'
		select case lcase(ffilter)
		case "" 	 : sAll		= " selected=""selected"""
		case "media" : sMedia	= " selected=""selected"""
		case "image" : sImage	= " selected=""selected"""
		case "file"  : sFile	= " selected=""selected"""
		case "misc"  : sMisc	= " selected=""selected"""
		end select	
		str.wri "<select name=selFilter id=selFilter class=inpSel onchange='asset_applyFilter()'>"
		'str.wri "<option value=''"	  & sAll   & ">" & lngAMAllFiles  & "</option>"
		str.wri "<option value='media'" & sMedia & ">" & lngAMMedia 	& "</option>"
		str.wri "<option value='image'" & sImage & ">" & lngAMImages 	& "</option>"
		str.wri "<option value='file'"  & sFile  & ">" & lngAMFiles 	& "</option>"
		str.wri "<option value='misc'"  & sMisc  & ">" & lngAMMisc 		& "</option>"
		str.wri "</select>"
	end sub
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	' 
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	public  sub writeFileSelections()
		dim oFolder, oFiles, oFile
		dim bDisplay, bFileFound, nIndex, sColor, sColorResult, iSelected, sIcon, sExt
		dim sFile_VirtualPath
		'	
		nIndex 		= 0
		bFileFound  = false
		bDisplay 	= false
		sColor 		= "#e7e7e7"	
		'
		set oFolder = cor.obj.fso.getFolder(currFolder_py)
		set oFiles  = oFolder.files
		'
		str.add "<div style='overflow:auto; height:250px; width:100%; margin-top:1px; margin-bottom:2px; border-bottom:1px solid #ccc; border-top:1px solid #ccc'>"
		str.add "<table summary='' border=0 cellpadding=2 cellspacing=0 style='width:100%;'>"
		'
		for each oFile in oFiles
			'
			'ffilter ~~~~~~~~~~
			sExt = lcase(getExt(oFile.path))
			if ffilter = "file" then
				if sExt = "zip"  OR sExt = "rar" OR sExt = "pdf" OR sExt = "pps" then bDisplay = true else bDisplay = false
			elseif ffilter = "media" then
				if sExt = "avi"  OR sExt = "wmv" OR sExt = "mpg" OR _
				   sExt = "mpeg" OR sExt = "wav" OR sExt = "wma" OR _
				   sExt = "mid"  OR sExt = "mp3" OR sExt = "swf" then bDisplay = true  else bDisplay = false
			elseif ffilter = "image" then
				if sExt = "gif"  OR sExt = "jpg" OR sExt = "png" then bDisplay = true else bDisplay = false
			else 'all
				bDisplay = false
			end if
			'
			if bDisplay then
				'
				sFile_VirtualPath = cor.butil.normPath(currFolder) & oFile.name
				'
				bFileFound = true
				nIndex	 = nIndex + 1
				if sColor  = "#efeff5" then sColor = "" else sColor = "#efeff5"
				'
				'icons
				select case lcase(sExt)
				case "asp"	: sIcon = "file-asp"
				case "bmp"	: sIcon = "file-bmp"
				case "css"	: sIcon = "file-css"
				case "doc"	: sIcon = "file-doc"
				case "exe"	: sIcon = "file-exe"
				case "gif"	: sIcon = "file-gif"
				case "htm"	: sIcon = "file-htm"
				case "html"	: sIcon = "file-htm"
				case "jpg"	: sIcon = "file-jpg"
				case "js"	: sIcon = "file-js"
				case "mdb"	: sIcon = "file-mdb"
				case "mov"	: sIcon = "file-mov"
				case "mp3"	: sIcon = "file-mp3"
				case "pdf"	: sIcon = "file-pdf"
				case "png"	: sIcon = "file-png"
				case "ppt"	: sIcon = "file-ppt"
				case "mid"	: sIcon = "file-sound"
				case "wav"	: sIcon = "file-sound"
				case "wma"	: sIcon = "file-sound"
				case "swf"	: sIcon = "file-swf"
				case "txt"	: sIcon = "file-txt"
				case "vbs"	: sIcon = "file-vbs"
				case "avi"	: sIcon = "file-video"
				case "wmv"	: sIcon = "file-video"
				case "mpeg"	: sIcon = "file-video"
				case "mpg"	: sIcon = "file-video"
				case "xls"	: sIcon = "file-xls"
				case "zip"	: sIcon = "file-zip"
				case else	: sIcon = "file-unknown"
				end select 
				if(lcase(oFile.name) = lcase(sUploadedFile))then
					sColorResult = "yellow"
					iSelected	= nIndex
				else
					sColorResult = sColor
				end if
				str.add "<tr style='background:" & sColorResult & "'>"
				str.add	"<td style='vertical-align:top;' class=""file-icons"">"'<img src='uploads/assets/soop/"&sIcon&"'>
				str.add "<span class=""" & sIcon & """>&nbsp;</span>"
				str.add	"<input type=hidden name=""inpFile" & nIndex & """ id=""inpFile" & nIndex & """ value=""" & sFile_VirtualPath & """ />"
				str.add	"</td>"

				str.add	"<td style='vertical-align:top; width:100%'><u id=""idFile"&nIndex&""" style='cursor:pointer;' onclick=""asset_selectFile(" & nIndex & ")"">" & oFile.name & "</u></td>"
				str.add	"<td style='vertical-align:top;' align=right nowrap=""nowrap"">" & formatNumber(oFile.size/1000,1) & " kb&nbsp;</td>"		
				if bWriteFolderAdmin then
				str.add	"<td style='vertical-align:top;' nowrap onclick=""asset_deleteFile(" & nIndex & ")""><u style='font-size:10px;cursor:pointer;color:crimson'>" & lngAMDel & "</u></td>"
				end if
				str.add "</tr>"
			end if
		next
		str.add "</table>"
		if  bFileFound = false then
			str.add "<div style='position:absolute;top:35%'><table style='height:100%; width:100%'><tr><td style='text-align:center'>" & lngAMEmpty & "</td></tr></table></div>"
		end if
		str.add "</div>"
		'
		str.add "<input type=hidden name=inpUploadedFile id=inpUploadedFile value='" & iSelected & "' />"
		str.add "<input type=hidden name=inpNumOfFiles id=inpNumOfFiles value='"	 & nIndex	& "' />"
		'
		response.write str.build
	end sub
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	' 
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	private function recursive(sFolderName)
		dim oFolder, pyFolderName, subfolder, selected
		'
		pyFolderName = server.mapPath(cor_sWebroot & sFolderName)
		if NOT cor.obj.fso.folderExists(pyFolderName) then exit function
		set oFolder  = cor.obj.fso.getFolder(pyFolderName)
		'
		if lcase(currFolder_py) = lcase(cstr(oFolder.path)) then selected = " selected"
		sOptions = sOptions & "<option value=""" & sFolderName & """" & selected & ">" & sFolderName & "</option>" & vbcrlf
		'
		for each subfolder in oFolder.SubFolders 
			recursive sFolderName & subfolder.name
		next
		set oFolder = nothing
		sOptions	= sOptions & vbcrlf
		recursive   = sOptions	
	end function
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	' 
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	private function getExt(sFile)
		dim sExt, item
		sExt = ""
		for each item In split(sFile,".")
			sExt = item
		next
		getExt   = sExt
	end function
	'   
	'--------------------------------------------------------------------------------------------------------------------------------
	'
	'
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	private sub class_initialize
		set str = new class_string
	end sub	
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	'
	'
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	private sub class_terminate
		set str = nothing
	end sub		
	'
	private str
	'
end class
'
'------------------------------------------------------------------------------------------------------------------------------------------
'
'
'
'------------------------------------------------------------------------------------------------------------------------------------------
class class_assetmanUpload ':: class_fso, class_languageParser
	'
	'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~	
	'	PUBLIC
	'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~	
	public  property get isUpload
		if instr(sContentType, "multipart/form-data") > 0 Then isUpload = true else isUpload = false
	end property

	public  property let AllowedTypes(sVal)
		sAllowedTypes = sVal
	end property

	public  property let MaxFileSize(nVal)
		nMaxFileSize = nVal
	end property

	public  property get ErrNum
		ErrNum = nErrNum
	end property
	
	public  property get ErrMsg
		ErrMsg = sErrMsg
	end property
	'~~~~~~~~~~~~	
	
	public  function requestValue(s)
		dim i
		for i=0 to nFileCount
			if  dictRequestFiles(i,0) = s Then
				requestValue = dictRequestFiles(i,1)
				exit function
			end if
		next
		requestValue = dictrequest(s)
	end function

	public  function requestFileContent(s)
		dim i
		if len(cstr(nFileCount)) = 0 then 
			requestFileContent = null
			exit function
		end if
		for i=0 To nFileCount
			if dictRequestFiles(i,0) = s Then
			
				requestFileContent = dictRequestFiles(i,2)
				exit function
			end if
		next
		requestFileContent = null
	end function
	
	public  function requestFileStatus(s)
		dim i
		if len(cstr(nFileCount)) = 0 then
			requestFileStatus = null
			exit function
		end if
		for i=0 to nFileCount
			if dictRequestFiles(i,0) = s Then
				requestFileStatus = dictRequestFiles(i,5)
				exit function
			end if
		next
	end function

	public  function requestFileType(s)
		dim i
		if len(cstr(nFileCount)) = 0 then 
			requestFileType = null
			exit function
		end if
		for i=0 To nFileCount
			if dictRequestFiles(i,0) = s Then
				requestFileType = dictRequestFiles(i,4)
				exit function
			end if
		next
		requestFileType = null
	end function
	
	public  function saveFile(sPath,sContent)
		dim sFile
		
		call cor.obj.init("fso")
		set sFile = cor.obj.fso.CreateTextFile(sPath, true) 'Hati2
		sFile.write(sContent)
		sFile.close	
	end function
	'
	public  sub recieve()
		dim lenBinData, sData, arrTemp, sBoundary, arrFieldValue, sBrowser, i
		dim fieldSeparate, fieldEnd, valueStart, valueEnd, sFieldRaw, sValue
		dim sLocal, posStart, sFileName
		'
		nErrNum = 0
		'
		if NOT isUpload Then
			nErrNum = 1
			sErrMsg = lngAMEncTypeNotMultipart
			exit Sub
		end if

		if  request.Totalbytes > nMaxFileSize then
			nErrNum = 2
			sErrMsg = lngAMPostedMaxAllowed & "&nbsp;(" & request.Totalbytes & "&nbsp;>&nbsp;" & nMaxFileSize & ")"
			exit Sub
		end if	
		
		On error resume next
		binData = request.BinaryRead(request.TotalBytes) '1
		if  err.number <> 0 then 
			nErrNum = 2
			sErrMsg = lngAMPostedMaxAllowed & lngAMPostedMaxAllowedIIS
			err.clear
			exit Sub
		end if
		On error goto 0
		
		lenBinData = lenB(binData)
		if lenBinData>0 Then
			adoRs.Fields.append "UploadData", 201, lenBinData
			adoRs.Open
			adoRs.AddNew
			adoRs("UploadData").appendChunk binData
			adoRs.Update
			sData = adoRs("UploadData")'Char
			adoRs.Close			
		end if	
		
		arrTemp 		= split(sContentType,";")
		sBoundary 		= split(trim(arrTemp(1)), "=")(1)
		arrFieldValue 	= split(sData,sBoundary)
		
		sBrowser = ucase(request.serverVariables("HTTP_USER_AGENT"))
				
		nFileCount = 0
		for i=0 To ubound(arrFieldValue)
			fieldSeparate = instr(arrFieldValue(i), Chr(13) & Chr(10) & Chr(13) & Chr(10))
			if fieldSeparate>0 Then
				fieldEnd	= fieldSeparate-3
				valueStart	= fieldSeparate+4
				valueEnd	= len(arrFieldValue(i)) - fieldSeparate - 4 - 3
				sFieldRaw	= mid(arrFieldValue(i), 3 , fieldEnd)
				sValue		= mid(arrFieldValue(i), valueStart , valueEnd)

				if instr(sFieldRaw,"filename=")>0 Then

					sLocal = getLocal(sFieldRaw)
					if instr(sBrowser,"WIN")>0 Then
						posStart = instrRev(sLocal, "\") + 1
						sFileName = mid(sLocal, posStart)
					end if					
					if instr(sBrowser,"MAC")>0 Then
						sFileName = sLocal
					end if					
						
					dictRequestFiles(nFileCount,0) = getFieldName(sFieldRaw)
					dictRequestFiles(nFileCount,1) = sFileName
					dictRequestFiles(nFileCount,2) = sValue 'or File Data
					dictRequestFiles(nFileCount,3) = sLocal
					dictRequestFiles(nFileCount,4) = getFileType(sFieldRaw)
					dictRequestFiles(nFileCount,5) = isAllowed(sFileName)
					
					select case lcase(cor.asset.assetType)
						case "image"
							if Not mid(getFileType(sFieldRaw),1,5) = "image" Then
								nErrNum = 3
								sErrMsg = lngAMPostedNotImage
							end if
						case "media"
							if Not mid(getFileType(sFieldRaw),1,5) = "audio" and Not mid(getFileType(sFieldRaw),1,29) = "application/x-shockwave-flash" Then
								nErrNum = 3
								sErrMsg = lngAMPostedNotAudio & " - (" & mid(getFileType(sFieldRaw),1,5) & ")"
							end if
						case "file"
							'if Not mid(getFileType(sFieldRaw),1,11) = "misc" Then
							'	nErrNum = 3
							'	sErrMsg = lngAMPostedNotApplication
							'end if
						case else
					end select
					
					nFileCount=nFileCount+1
				else
					dictrequest.Add getFieldName(sFieldRaw),sValue		
				end if
			end if
		next
	end sub

	'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~	
	'	PRIVATE
	'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~	
	private function getFieldName(s)
		dim posStart, posEnd, item
		
		posStart = instr(s, "name=") + 6 
		if instr(s,Chr(34) & ";")>0 Then 'Chr(34) = "		
			's => Content-Disposition: form-data; name="uploadFile";
			'	  Content-Type: text/plain
			posEnd = instr( posStart , s, Chr(34) & ";" )
		else
			's => Content-Disposition: form-data; name="inpNewFileName"
			posEnd = instr( posStart , s, Chr(34))		
		end if	
		getFieldName = mid(s, posStart , posEnd - posStart)
	end function

	private function getLocal(s)
		dim posStart, posEnd
		
		posStart = instr(s, "filename=") + 10
		posEnd 	 = instr(s, Chr(34) & Chr(13) & Chr(10))
		getLocal = mid(s, posStart, posEnd-posStart)
	end function

	private function getFileType(s)
		dim posStart, item
		posStart 	= instr(s, "Content-Type: ")
		GetFileType = mid(s, posStart + 14)
	end function
	
	private function isAllowed(sFileName)
		dim sExtention, item
		for each item in split(sFileName,".")
			sExtention = item
		next
		isAllowed = false
		for each item in split(sAllowedTypes,"|")
			if lcase(item) = lcase(sExtention) or lcase(item) = "*"  Then
				isAllowed = true
			end if
		next
	end function	

	public  sub init
		set adoRs 		= server.createObject("ADODB.Recordset")
		set dictrequest = server.createObject("Scripting.Dictionary")
	end sub
	
	private sub class_initialize
		sContentType	= lcase(request.serverVariables("HTTP_CONTENT_TYPE"))
		redim dictRequestFiles(5,6)
	end sub	

	private sub class_terminate
		if isObject(adoRs) 		 Then set adoRs 	  = nothing : adoRs 	  = empty
		if isObject(dictrequest) Then set dictrequest = nothing : dictrequest = empty
	end sub	
	'
	private adoRs
	private dictrequest	
	private sContentType	
	'
	private binData
	private nFileCount
	private dictRequestFiles()
	private sAllowedTypes
	private nMaxFileSize
	private nErrNum
	private sErrMsg
	'
end class

'<#late-binding hook
function boot_class_assetman : boot_class_assetman = true : end function
'/>
%>
