﻿<%
'------------------------------------------------------------------------------------------------------------------------------------------
' SOOP 2.0 - Phoenix (TNG)
'
' Revision 2.00 - initial 15/02/2008
'
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'------------------------------------------------------------------------------------------------------------------------------------------

'******************************************************************************************************************************************
'* Original author:			Nick DelMedico (www.pixel420.com)
'* Properties:
'*	.ElementID				- The name/id of the select element (default is "selCheckBox1")
'*	.ClassName				- Name of a CSS class to apply to the CheckBox (default is none)
'*	.CheckedValue			- The value of the option to show as selected (default is none)
'*	.DefaultText			- The text displayed for the default option (default is "- Please Select -")
'*	.Style					- CSS style to apply to the CheckBox (default is none)
'*	.DisplayDefault			- Boolean whether to display the default option (default is false)
'*	.CheckAllID

'*	.Disabled 				- Boolean whether the CheckBox is disabled (default is false)
'* Methods:
'*	.BuildCheckBoxFromFile		- Builds CheckBox from a file. (Arguments: Path to file)
'*	.BuildCheckBoxFromDB		- Builds CheckBox from DB query. (Arguments: Connection Object, SQL Query)
'*	.AddEvent				- Adds an event to the CheckBox. (Arguments: Event, Event Action)
'*	.CreateCheckBox			- Outputs CheckBox to browser (Arguments: None)
'*	.ReturnCheckBox			- Returns a string representation of the CheckBox (Arguments: None)
'*
'* Additonally extended for Phoenix:
'*	.BuildCheckBoxFromFolder		- Builds CheckBox from existing folder files
'*	.BuildCheckBoxFromDBIndent		- Builds CheckBox from existing DB with some indenting
'*	.Title property				- so we can use a generic jquery js function to do the needed jump
'*
'********************************************************************************************************************************************

class class_checkboxBuilder ':: class_string, class_baseUtils, class_filters, class_DAL, class_objectsPool

	private p_strElemID, p_strChecked, p_strDefaultText
	private p_strOutput, p_strDisabled, p_strIndented
	private p_strEvents, p_strClassName, p_strStyle, p_strTitle
	private p_strReturn
	private p_intColBound, p_intCheckBoxSize
	private p_arrThisOpt
	private p_blnDispDef
	private p_objReader, p_objRS
	private p_folder, p_files, p_array, file
	private p_usecheckall, p_checkallID,p_Scrollable
	private p_boxWidth, p_boxHeight

	private sub class_initialize()
		p_strElemID			= "ChkB1"
		p_strEvents			= ""
		p_strClassName		= ""
		p_strChecked		= ""
'		p_strDefaultText	= " - Please Select - "
		p_boxWidth			= "100%"
		p_boxHeight			= ""
		p_strDisabled		= ""
		p_strTitle			= ""
		p_strStyle			= ""
		p_blnDispDef		= true
		p_UseCheckAll		= false
		p_CheckAllID		= "ChkAll"
		p_Scrollable		= true

		set str = new class_string
	end sub

'* Properties -- all writable
	public property let ElementID(sElemID)
			p_strElemID = sElemID
	end property

	public property let boxWidth(sboxWidth)
		p_boxWidth 	= sboxWidth
	end property

	public property let boxHeight(sboxHeigh)
		p_boxHeight	= sboxHeigh
	end property

	public property let UseCheckAll(sUseCheckAll)
			p_UseCheckAll = sUseCheckAll
	end property

	public property let CheckAllID(sCheckAllID)
			p_CheckAllID = sCheckAllID
	end property

	public property let CheckedValue(sChkVal)
			p_strChecked = sChkVal
	end property

	public property let DefaultText(sDefTxt)
		p_strDefaultText = sDefTxt
	end property

	public property let ClassName(sClass)
		p_strClassName = " class=""" & sclass & """"
	end property
	
	public property let Title(sTitle)
		p_strTitle = " title=""" & sTitle & """"
	end property

	public property let Style(sStyle)
		p_strStyle = " style=""" & sStyle & """"
	end property

	public property let DisplayDefault(bDisplay)
		if bDisplay = true OR bDisplay = false Then
			p_blnDispDef = bDisplay
		end if
	end property

	public property let Disabled(bDisable)
		if bDisable = true Then
			p_strDisabled = " disabled=""disabled"""
		else
			p_strDisabled = ""
		end if
	end property

'	public sub AddCheckBox(sValue, sDisplay)
'		call addCheckBox(sValue, sDisplay, p_strChecked, "")
'	end sub

	public sub AddEvent(sEvent, sAction)
		p_strEvents = p_strEvents & " " & sEvent & "=""" & sAction & """"
	end sub


	public sub BuildCheckBoxFromFile(sFilePath)
		call cor.obj.init("fso")
		set p_objReader = cor.obj.fso.openTextFile(sFilePath, 1, false)
		Do Until p_objReader.atEndOfStream
			p_arrThisOpt = split(p_objReader.ReadLine, ",")
			strXMLlabel = cor.lng.getKey("cor_xmlCheckBoxs",p_arrThisOpt(ubound(p_arrThisOpt)))
			if isNull(strXMLlabel) OR strXMLlabel = "" Then strXMLlabel = p_arrThisOpt(ubound(p_arrThisOpt))
			call addCheckBox(p_arrThisOpt(0), strXMLlabel, p_strChecked, "")
		Loop
		erase p_arrThisOpt
		p_objReader.close
		set p_objReader = nothing
	end sub

	public sub BuildCheckBoxFromFolder(sFolder,sExtension,bStrip)
		call cor.obj.init("fso")
		set p_folder = cor.obj.fso.GetFolder(server.mappath(sFolder))
		set p_files  = p_folder.Files
		for each file in p_files
			if instr(file.name, sExtension) > 0 Then
			'strFirstLetter = ucase(left(arrUsers(1,u),1))
				p_arrThisOpt = iif(bStrip = True,split(lcase(replace(file.name, sExtension, "")),","),split(lcase(file.name),","))
				call addCheckBox(p_arrThisOpt(0), cor.butil.properCase(p_arrThisOpt(ubound(p_arrThisOpt))), p_strChecked, "")
			end if
		next
		set p_files  = nothing
		set p_folder = nothing
	end sub

	public sub BuildCheckBoxFromDB(sQuery)
		if isEmpty(sQuery) Then exit Sub
		cor.dal.open p_array, sQuery, array()
		if NOT cor.butil.eof(p_array) Then
			for p_intColBound = 0 To ubound(p_array,2)
				call addCheckBox(trim(p_array(0,p_intColBound)), cor.butil.htmlEncode(trim(p_array(1,p_intColBound))), p_strChecked, "")
			next
		end if
	end sub

	public sub CreateCheckBox()
		if p_UseCheckAll Then 
			str.add "<script language=""javascript""><!-- <![CDATA["
			str.add "	$(document).ready(function(){ $('#" & p_CheckAllID & "').checkgroup({groupName:'" & p_strElemID & "'}); });"
			str.add "// ]]> --></script>"
		end if
		str.adn "<div " & p_strClassName & " id=""" & p_strElemID & """ style=""overflow: auto;width:" & p_boxWidth & ";"
		if p_boxHeight <> "" then str.adn "height:" & p_boxHeight & ";"
		str.add """>"
		if p_UseCheckAll Then 
			str.add "<ul>"
			str.add "<li class=""chkAll""><input class=""checkbox"" type=""checkbox"" id=""" & p_CheckAllID & """ />&nbsp " & lngCheckAll & "</li>"
			str.add "</ul>"
		end if
		str.add "<ul>"
		str.add p_strOutput & "</ul></div>"
		response.write str.build
	end sub

	public function ReturnCheckBox()
		if p_UseCheckAll Then 
			str.add "<script language=""javascript""><!-- <![CDATA["
			str.add "	$(document).ready(function(){ $('#" & p_CheckAllID & "').checkgroup({groupName:'" & p_strElemID & "'}); });"
			str.add "// ]]> --></script>"
		end if
		str.adn "<div " & p_strClassName & " id=""" & p_strElemID & """ >"
		if p_UseCheckAll Then
			str.add "<ul>"
			str.add "<li class=""chkAll""><input class=""checkbox"" type=""checkbox"" id=""" & p_CheckAllID & """ />&nbsp " & lngCheckAll & "</li>"
			str.add "</ul>"
		end if
		str.add "<ul>"
		str.add p_strOutput & "</div>"
		ReturnCheckBox = str.build
	end function

	private sub addCheckBox(sValue, sDisplay, sChecked, sClass)
		dim strRepeat, x_i,sitem
		str.add "<li>"
		sItem = split(sChecked,",")
		if sclass = "" Then
			str.adn "<input class=""checkbox"" type=""checkbox"" id=""" & p_strElemID &sValue &  """ name=""" & p_strElemID & """ value=""" & sValue & """"
			For x_i =0 to Ubound(sItem)
				if trim(lcase(sValue))=trim(lcase(sItem(x_i))) Then str.adn " checked=""checked"""
			Next
			str.add " /> " & sDisplay & "</li>"
		else
			for x_i=0 To cor.filter.checkInt(sClass)-1
				strRepeat = strRepeat & "--"
			next
			str.adn "<input class=""checkbox"" type=""checkbox"" id=""" & p_strElemID & "_" & x_i & """ name=""" & p_strElemID & """ class=""" & "label" & cor.filter.checkInt(sClass) + 1 & """ value=""" & sValue & """"
			For x_i =0 to Ubound(sItem)
				if trim(lcase(sValue))=trim(lcase(sItem(x_i))) Then str.adn " checked=""checked"""
			Next
			str.add " />" & sDisplay & "</li>"
		end if
		p_strOutput = p_strOutput & str.build
	end sub

	private sub class_terminate()
		p_strOutput = empty
		p_strReturn = empty
		set str	= nothing
	end sub
	'
	private str
	private strXMLlabel
	'
end class

'<#late-binding hook
function boot_class_CheckBoxBuilder : boot_class_CheckBoxBuilder = true : end function
'/>

%>