<%
'------------------------------------------------------------------------------------------------------------------------------------------
' SOOP 2.0 - Phoenix (TNG)
'
' Revision 2.00 - initial 15/02/2008
'
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'------------------------------------------------------------------------------------------------------------------------------------------

class class_DAL ':: global
	'--- expose conn/rs objects for support of non-getrows()
	public ado
	public rs, rs1 'available for (disconnected) RS use
	'
	'-----------------
	' public Members
	'-----------------
	'
	public property get lastQuery()
		lastQuery = p_lastquery
	end property
	'
	public property get pages()
		pages = pagecnt
	end property
	'
	public sub open(byRef arr, sql, params)
		dim strField, i
		cor_iQueriesTotal		= cor_iQueriesTotal + 1
		'
		'FormattedDebugSQL(buildSQL(sql, params) )
		'Response.Write buildSQL(sql, params)
		call recycleRS("rs_")
		call openDB()
		with rs_
			.CursorLocation		= cor_cUseClient
			.cursorType			= cor_cOpenStatic
			.lockType			= cor_cLockReadOnly
			.activeConnection	= ado
			'FormattedDebugSQL(buildSQL(sql, params) )
			.open buildSQL(sql, params)
			if ado.errors.count > 0 then cor.err.HandleDBError  ado, Sql, Params, buildSQL(sql, params)
			if  .EOF Then
				'--- clear array
				redim arr(0,-1)
			else
				arr = .getRows()
			end if
		end with

		call closeDB()
		'
	end sub
	'
	public sub openPaged(byRef arr, byval page, pagesize, sql, params)
		dim strField, strFields, i
		cor_iQueriesTotal = cor_iQueriesTotal + 1
		if NOT isNumeric(page) Then page = 1
		if page = 0 Then page = 1
		'
		'FormattedDebugSQL(buildSQL(sql, params) )
		call recycleRS("rs_")
		call openDB()
		with rs_
			.CursorLocation		= cor_cUseClient
			.cursorType			= cor_cOpenStatic
			.lockType			= cor_cLockBatchOptimistic
			.activeConnection	= ado
			.cacheSize			= pagesize
			.open buildSQL(sql, params)
			.pagesize			= pagesize
			if ado.errors.count > 0 then cor.err.HandleDBError  ado, Sql, Params, buildSQL(sql, params)
			if  .EOF OR .BOF Then
				'--- clear array
				redim arr(0,-1)
			else
				pagecnt = .pageCount
				'--- ensure paging is always within bounds
				if page > pagecnt then page = pagecnt
				.absolutePage = page
				arr = .getRows(pagesize,0)
			end if
		end with
		if ado.errors.count > 0 then cor.err.HandleDBError  ado, Sql, Params, buildSQL(sql, params)
		call closeDB()
	end sub
	'
	public sub exec(sql, params)
		cor_iQueriesTotal = cor_iQueriesTotal + 1
		'
		
		'FormattedDebugSQL(buildSQL(sql, params) )
		call openDB()
		ado.execute buildSQL(sql, params),, 128
		if ado.errors.count > 0 then cor.err.HandleDBError  ado, Sql, Params, buildSQL(sql, params)
		call closeDB()
	end sub
	'
	public function getValue(sql, params)
		cor_iQueriesTotal = cor_iQueriesTotal + 1
		'
		'FormattedDebugSQL(buildSQL(sql, params) )
		call recycleRS("rs_")
		call openDB()
		with rs_
			.CursorLocation		= cor_cUseClient
			.cursorType			= cor_cOpenStatic
			.lockType			= cor_cLockReadOnly
			.activeConnection	= ado
			.open buildSQL(sql, params)
			if ado.errors.count > 0 then cor.err.HandleDBError  ado, Sql, Params, buildSQL(sql, params)
			if .EOF Then
				getValue		= ""
			else
				getValue		= .fields(0)
			end if
		end with
		call closeDB()
	end function
	'
	public sub getRows(byRef arr, rows, sql, params)
		dim strField, i
		cor_iQueriesTotal = cor_iQueriesTotal + 1
		select case lcase(cor_sDatabaseType)
		case "mysql"
			sql = sql & " LIMIT " & rows
		case "mssql", "access"
			sql = replace(sql, "SELECT", "SELECT TOP "& rows, 1,-1, 1)
		end select
		'
		'FormattedDebugSQL(buildSQL(sql, params) )
		call recycleRS("rs_")
		call openDB()
		with rs_
			.CursorLocation		= cor_cUseClient
			.cursorType			= cor_cOpenStatic
			.lockType			= cor_cLockReadOnly
			.activeConnection	= ado
			.open buildSQL(sql, params)
			if ado.errors.count > 0 then cor.err.HandleDBError  ado, Sql, Params, buildSQL(sql, params)
			if  NOT .EOF Then
				arr = .getRows()
			else
				'clear array
				redim arr(0,-1)
			end if
		end with
		call closeDB()
	end sub
	'
	'=============================
	' Compatibility mode (public)
	'=============================
	'
	public sub openRS(rsname, sql, params)
		cor_iQueriesTotal = cor_iQueriesTotal + 1
		'
		'FormattedDebugSQL(buildSQL(sql, params) )
		call recycleRS(rsname)
		call openDB()
		execute(rsname&".CursorLocation		= cor_cUseClient")
		execute(rsname&".cursorType			= cor_cOpenStatic")
		execute(rsname&".lockType			= cor_cLockReadOnly")
		execute(rsname&".activeConnection	= ado")
		execute(rsname&".open buildSQL(sql, params), ado")
		if ado.errors.count > 0 then cor.err.HandleDBError  ado, Sql, Params, buildSQL(sql, params)
		'Disconnect RS
		execute(rsname&".activeConnection	= nothing")
		call closeDB()
	end sub
	'
	' Open RS in paging mode
	public sub openRSp(rsname, byVal page, pagesize, sql, params)
		cor_iQueriesTotal = cor_iQueriesTotal + 1
		if NOT isNumeric(page) or page = 0 Then page = 1
		'
		'FormattedDebugSQL(buildSQL(sql, params) )
		call recycleRS(rsname)
		call openDB()
		execute(rsname&".CursorLocation		= cor_cUseClient")
		execute(rsname&".cursorType			= cor_cOpenStatic")
		execute(rsname&".lockType			= cor_cLockBatchOptimistic")
		execute(rsname&".activeConnection	= ado")
		execute(rsname&".cacheSize			= pagesize")
		execute(rsname&".open buildSQL(sql, params), ado")
		if ado.errors.count > 0 then cor.err.HandleDBError  ado, Sql, Params, buildSQL(sql, params)
		execute(rsname&".pagesize			= pagesize")
		if NOT eval(rsname&".EOF") Then
			execute(rsname&".absolutePage		= page")
		end if
		execute("pagecnt = "&rsname&".pageCount")
		'Disconnect RS
		execute(rsname&".activeConnection	= nothing")
		call closeDB()
	end sub
	'


	' this is for devs who are used to cleanup, but it's usually not necessary
	public sub closeRS(rsname)
		'Disconnect RS
		execute(rsname&".activeConnection	= nothing")
		call closeDB()
		if ado.errors.count > 0 then cor.err.HandleDBError  ado, Sql, Params, buildSQL(sql, params)
	end sub
	'
	'=============================
	' SQL formatting (public)
	'=============================
	'
	public function buildSQL(byVal ssql, params)
		dim i,j, strNewVal'
		if isarray(params) Then
			for j = 0 to ubound(params)
				if NOT isnull(params(i)) Then params(i) = replace(params(i),"{"& j &"}","{ " & j & " }")
			Next
			for i = 0 to ubound(params)
				if len(params(i)) = 0 Then
'					strNewVal = "''"
					strNewVal = "NULL "
				else
					if  isNumeric(params(i))  AND instr(params(i), ".") = 0 AND instr(params(i), ",") = 0 then
						strNewVal = params(i)
					else
						select case(varType(params(i)))
						case vbBoolean, vbDecimal, vbDouble, vbInteger, vbLong, vbSingle
							strNewVal = params(i)
						case else
							' Prefix an N to All stings for UTF-8 Compatibility MSSQL Server Only
							if lcase(cor_sDatabaseType)="mssql" then
								strNewVal = "N'" & escapeParam(params(i)) & "'"
							else
								strNewVal = "'" & escapeParam(params(i)) & "'"
							end if
						end select
					end if
				end if
				ssql = replace(ssql, "{" & i & "}", strNewVal)
			next
			for j = 0 to ubound(params)
				ssql = replace(ssql,"{ "& j &" }","{" & j & "}")
			next
		end if
		p_lastquery = ssql
		buildSQL	= ssql
		'FormattedDebugSQL(buildSQL(sql, params) )
		'response.flush 
		If cor_bAdmin and cor.filter.checkInt(Request.QueryString("debug")) = 1 Then response.write "<br />" & buildSQL & "<br />"
	end function
	'
	public function escapeParam(param)
		if  NOT isNull(param) AND NOT param = "" Then
			select case lcase(cor_sDatabaseType)
			case "mysql"
				param = replace(param, "\", "\\")
				param = replace(param, "'", "\'")
			case "mssql", "access"
				param = replace(param, "'", "''")
			end select
		else
			param = ""
		end if
		escapeParam = param
	end function
	'
	'-----------------
	' private Members
	'-----------------
	'
	private sub openDB()
		if isObject(ado) Then	' reuse connection
			if ado.state = cor_cStateClosed Then ado.open strConn
		else
			On error resume next
		set ado = server.createObject("ADODB.connection")
		ado.commandTimeout = server.scriptTimeout
		ado.open strConn
		if err.number <> 0 Then call cor.stopper("[ERR:class_DAL.OpenDB] ") ' & err.description
		if ado.errors.count > 0 then cor.err.HandleDBError  ado, Sql, Params, buildSQL(sql, params)
		'		cor.err.HandleError
		end if
		'ado.cursorLocation = cor_cUseClient
	end sub
	'
	private sub closeDB()
		'* if pooling disabled keep the same connection for whole page lifecycle
		if NOT poolingEnabled Then exit sub
		if isObject(ado) Then ' connection reused by pooling
			if ado.state = cor_cStateOpen Then ado.close()
			'* obj=empty ensures it's being de-referenced to a plain variable, so isObject() could catch it
			'* set to nothing does not affect pooling [http://www.sql-server-performance.com/articles/per/asp_ado_pooling_p2.aspx]
			set ado = nothing :	ado = empty
		end if
	end sub
	'
	'* recycling a single RS is enough even if additional RS objects are called in inner loops,
	'* because SooP2 uses mainly getrows(), so it always releases RS early.
	'* if using this code in compatibility mode however (exposed RS) the calling code needs to make sure
	'* no inner loops calls are performed on the same RS.
	private sub recycleRS(rsname)
		if eval("isObject("&rsname&")") Then
			'* close RS only if already open (ready for reuse)
			if eval(rsname&".state = cor_cStateOpen") Then execute(rsname&".close")
			'* Note that to avoid connection creep, CursorLocation should be set before a RS is (re)opened.
			'* After a RS is opened, CursorLocation does not and cannot change.
			'* http://msdn2.microsoft.com/en-us/library/ms810829.aspx
		else
			'* if not a RS, create one
			'set rs = server.createObject("adodb.recordset")
			execute("set "&rsname&" = server.createObject(""ADODB.recordset"")")
		end if
	end sub
	'
	private sub disposeRS(rsname)
		if eval("isObject("&rsname&")") Then
			if eval(rsname&".state = cor_cStateOpen") Then execute(rsname&".close")
			execute("set "&rsname&" = nothing : "&rsname&" = empty")
		end if
	end sub
	'
	private sub class_initialize
		strConn			= cor.connString
		poolingEnabled	= cor.enablePooling
		'
		if  strConn = "" then cor.stopper("[ERR:class_DAL] Missing connection string. Check your configuration")
		if  poolingEnabled Then
			'* Ensures pooling is enabled (usually only for MS-SQL and MS-Access)
			'* http://support.microsoft.com/kb/260856
			if instr(ucase(strConn), "OLEDB.") >0 Then strConn = strConn & "; OLE DB Services=-1"
		end if
	end sub
	'
	private sub class_terminate
		call disposeRS("rs_")
		call disposeRS("rs")
		call disposeRS("rs1")
		call closeDB()
	end sub
	'
	private rs_		'only for getrows() use
	private strConn
	private poolingEnabled
	private pagecnt
	private p_lastquery
end class
'
'<#late-binding hook
function boot_class_DAL : boot_class_DAL = true : end function
'/>

%>
