﻿<%
'----------------------------------------------------------------------------------------------------------------------
' SOOP 2.0 - Phoenix (TNG)
'
' Revision 2.00 - initial 15/02/2008
'
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'----------------------------------------------------------------------------------------------------------------------
'
class class_errorTrap 
	'---------------------------------------------------------------------------------
	'
	' Error Trap, for handling various ASP and DB errors
	'  Begun 2/4/2009 by charles.
	' 
	'----------------------------------------------------------------------------------
	'
	public blnError
	private sub class_initialize
	blnError = false
	'
	end sub
	'
	private sub class_terminate
	'
		call HandleError
	end sub

	public sub HandleError()
		dim strText
		if err.Number <> 0 then	'we have an error code.
			strText = "-----" & vbcrlf & cstr(now) & vbcrlf
			strText = strText & "Error No     : " & err.number & vbcrlf
			strText = strText & "  Description: " & err.Description & vbcrlf
			strText = strText & "  Source     : " & err.Source & vbcrlf
			strText = strText & "  Line       : " & err.Line & vbcrlf
			WriteError strText, "SooP.Error"
			blnError = true
		else
			 ' We're seeing no errors!
		end if		
	end sub
	public sub HandleDBError(byref objDBrs, byref strSql, byref arrParams, byval strBuiltSql)
		dim objError, strText
		'response.write "Error!"
		'objDBrs is the connection or RS that generated the error.
		'strSql is the unformatted sql statement delivered to the class_dal module
		'arrParams is an array of parameters to insert into the sql statement
		'strBuiltSql is the completed sql statement, merging strSQL and arrParams, performed by BuildSQL
		strText = "-----" & vbcrlf & cstr(now) & vbcrlf
		if objDBrs.errors.count > 0 then	'db or rs has an error
			for each objError in objdbrs.errors
				strText = strText & "Error No     : " & objError.number & vbcrlf
				strText = strText & "  Description: " & objError.Description & vbcrlf
				strText = strText & "  Source     : " & objError.Source & vbcrlf
				strText = strText & "  SQLState   : " & objError.SQLState & vbcrlf
				strText = strText & "  Native Err : " & objError.NativeError & vbcrlf	
			next
			strText = strText & "  SQL        : " & FormattedSQL(strBuiltSQL) 
			strText = strText & "  Source SQL : " & strSql & vbcrlf
			strText = strText & "  Params     : " & FormattedParams(arrParams)
			WriteError strText, "SooP.DBError"
			blnError = true
		else
			 ' We're seeing no errors!
		end if		
	end sub
	'	
	public sub LogCustomErrorText(strLogText)
		dim strText
		strText = "-----" & cbcrlf & cstr(now )& vbcrlf
		strText = strText & "Custom Error Generated." & vbcrlf
		strText = strText & vbtab & "Error Text   :   " & strLogText
		writeError strText, "Soop.Error"
		blnError = false
	end sub
	private	function FormattedSQL(byval sql)
		'clean up SQL Statement for readability.
		sql = replace(sql, "FROM ", vbcrlf & vbtab & " FROM ")
		sql = replace(sql, "INNER ", vbcrlf & vbtab & " INNER ")
		sql = replace(sql, "WHERE ", vbcrlf & vbtab & " WHERE ")
		sql = replace(sql, "AND ", vbcrlf & vbtab & " AND ")
		sql = replace(sql, "OR ", vbcrlf & vbtab & " OR ")
		sql = replace(sql, "GROUP ", vbcrlf & vbtab & " GROUP ")
		sql = replace(sql, "ORDER ", vbcrlf & vbtab & " ORDER ")
		sql = replace(sql, "SET ", vbcrlf & vbtab & " SET ")
		sql = replace(sql, "VALUES ", vbcrlf & vbtab & " VALUES ")
		FormattedSQL = vbcrlf & vbtab & sql & vbcrlf & vbcrlf
	end function
'	
	private function FormattedParams(byVal params)
		'rewrite the params array into user-readable text format.
		dim i, strNewVal, strOut
		strOut = ""
		if isarray(params) Then
			for i = 0 to ubound(params)
				if len(params(i)) = 0 Then
					strNewVal = vbtab & i & " : " & vbtab & "{NULL}" & vbcrlf
				else
					strNewVal = vbtab & i & " : " & vbtab & params(i) & vbcrlf	
				end if
				strOut = strOut & strNewVal
			next
		else
			if len(params) = 0 Then
				strOut = vbtab & vbtab & "{NULL}" & vbcrlf
			else
				strOut = params
			end if
		end if
		FormattedParams = vbcrlf & strOut
	end function
'
	private sub WriteError (byref strText, byval filename)
		' This sub will push an error message out to the cor_sLogsPath folder.
		cor_sLogsPath = trim(cor_sLogsPath)
		if right(cor_sLogsPath,1) <> "\" then cor_sLogsPath = cor_sLogsPath & "\"
		dim strLogFileName		:	strLogFileName = cor_sLogsPath & filename & getDateText & "txt"
		'dim objLogFSO			:	set objLogFSO = createObject("Scripting.FileSystemObject")
		call cor.obj.init("fso")
		dim objLogTs
		if objLogFSO.FileExists(strLogFileName) then
			set objLogTS = cor.obj.fso.OpenTextFile(strLogFileName, 8) 'for appending
		else
			set objLogTS = cor.obj.fso.CreateTextFile(strLogFileName)	'Create new file.
		end if
		cor.obj.fso.Writeline(strText)
		cor.obj.fso.close

	end sub
	'
	private function GetDateText
		'build a date/time formatted file name extension
		dim dtDate, arrDT(6), i
		dtDate = now
		arrDT(0) = year(dtDate)			:		arrDT(1) = month(dtDate)		:		arrDT(2) = day(dtDate)
		arrDT(3) = hour(dtDate)			:		arrDT(4) = minute(dtDate)		:		arrDT(5) = second(dtDate)
		GetDateText = "."
		for i = 0 to 5
			GetDateText = GetDateText & trim(cstr(arrDT(i)))
			if i = 2 then
				GetDateText = GetDateText & "."
			end if
		next
		getDateText = GetDateText & "."
	end function
end class

'
'
'<#late-binding hook
function boot_class_errorTrap : boot_class_errorTrap = true : end function
'/>
%>
