﻿<%
'------------------------------------------------------------------------------------------------------------------------------------------
' SOOP 2.0 - Phoenix (TNG)
'
'Revision 2.0001 - initial 26/02/2008
'
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'------------------------------------------------------------------------------------------------------------------------------------------
%>
<%
class class_filters ':: global
	'
	private regEx
	private blnFetchedWords
	private sub class_initialize()
		set regEx = new RegExp
		blnFetchedWords = false
	end sub
	'
	private sub class_terminate()
		set regEx = nothing
	end sub
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	' prepare saving an RTE encoded memo input field to the database
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	public function clnEditor(strValue)
		if isNull(strValue) or isEmpty(strValue) then exit function
		strValue	= trim(strValue)
		strValue	= replace(strValue, vbcrlf, "")
	 '  strValue	= replace(strValue, chr(10), " ")
	 '  strValue	= replace(strValue, chr(13), " ")
		clnEditor = strValue
	end function
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	' recall ing a memo field from table
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	public function escEditor(strValue)
		if isNull(strValue) OR isEmpty(strValue) then exit function
		dim escValue : escValue = trim(strValue)
		escValue	= replace(escValue, """", "\""")
		escValue	= replace(escValue, "'", "\'")
		escValue	= replace(escValue, "_", "\_")
		escValue	= replace(escValue,vbcrlf,"")
		escEditor = escValue
	end function
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	'

	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	public function stripHTMLTags(HTMLString)
		regEx.pattern		= "<[^>]+>"
		regEx.ignoreCase	= true
		regEx.global		= true
		stripHTMLTags		= regEx.replace(HTMLString&"", "")
	end function
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	'
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	public function validFilename(str)
		regEx.pattern		= "(\W+)|(AUX|PRN|NUL|COM\d|LPT\d)+\s*"
		regEx.ignoreCase	= true
		regEx.global		= true
		validFilename		= regEx.replace(str, "_")
	end function
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	'
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	public function validASPList(str)
		validASPList	= replace(str&"", """", "`")
	end function
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	' Basic protection against form-post tampering coming from alien domains
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	public sub validatePostEvent(bEnableRefer)
		if bEnableRefer=false then exit sub
		dim sReferrer :	sReferrer = cor_sReferer
		if inStr(cor_sScriptName, "mgmt_")<>0 AND inStr(sReferrer, cor_sPortalDomainPath)=0 Then
			If cor_bAdmin Then
				exit sub
			Else
				cor.redir cor_sWebroot
			End If
		End if
		if bEnableRefer AND cor_bPostback Then
			if isEmpty(sReferrer) OR isNull(sReferrer) Then cor.msg("[ERR:class_filters.validatePostEvent] " & lngSysReferProtectionFault)
			if inStr(sReferrer, cor_sPortalDomainPath)=0   Then cor.msg("[ERR:class_filters.validatePostEvent] " & lngSysReferProtectionFault)
		end if
	end sub
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	' Advanced protection against most SQL-injection attacks
	' Credits: Compiled and modded mostly from http://www.securityfocus.com/infocus/1768
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	private ptrn_sql
	public function sqlShield(inputStr, level)
		regEx.ignoreCase	= true
		regEx.global		= true
		'--- No need to filter staff members
		'if cor_bModerator OR NOT cor_cUseSqlShield Then level=cor_cShieldNone
		select case level
		case cor_cShieldNone
			sqlShield		= inputStr
		case cor_cShieldXSS
			regEx.pattern	= "(?:(?:\%3C)|<)([^\n]+)(?:(?:\%3E)|>)"
			sqlShield		= regEx.replace(inputStr, "$1")
		case cor_cShieldSql
			' Code change Jan 19, 2009 by charles to allow SQL keywords to become HTML coded words instead.
			'	Added by Hooded as a Test t allow for Hash # but still prevent injection
			regEx.pattern	= "(?:(#))"
			regEx.replace inputStr,"&#35;"
			regEx.pattern	= "(?:(\'))"
			regEx.replace inputStr,"&#39;"
			'Begin new code from charles for SQL Injection filtering.
			dim arrExtended, lngID
			arrExtended = array("INSERT", "SELECT", "DELETE", "UPDATE", "DROP", "CREATE", "MODIFY", "ALTER", "CAST", "EXEC", "REVOKE", "GRANT", "VARCHAR", "DECLARE", "CMD")
			for lngID = lBound(arrExtended) To ubound(arrExtended)
				inputStr = ReplaceWithCase(inputStr, arrExtended(lngID))
			Next
			sqlShield = inputStr
		case cor_cShieldSqlXSS
			inputStr		= sqlShield(inputStr, cor_cShieldXSS)
			sqlShield		= sqlShield(inputStr, cor_cShieldSql)
		end select
		'
	end function
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	public function checkStrSQL(byVal strString)
		if isNull(strString) then exit Function
		strString	= sqlShield(strString, cor_cShieldSql)
		strString	= replace  (strString, "'", "''")
		checkStrSQL = replace  (strString, "\", "\\")
	End Function
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	'
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	public function sqlstring(strValue)
		if isNull(strValue) then exit function
		sqlstring = replace(strValue,"'","''", 1, -1, 1)
	end function
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	'
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	public function removeHTML(strText)
		if isNull(strText) then exit function
		regEx.pattern	= "<[^>]*>"
		regEx.global	= true
		strText			= replace(strText, "<br />", chr(10), 1,-1, 1)
		RemoveHTML		= regEx.replace(strText, "")
	end function
	'
'------------------------------------------------------------------------------------------------------------------------------------------
	'
	'
	'
'------------------------------------------------------------------------------------------------------------------------------------------
	public function checkZero(num)
		if  NOT(isNumeric(num)) Then
			checkZero = 0
		elseif isNull(num) Then
			checkZero = 0
		elseif isEmpty(num) Then
			checkZero = 0
		elseif len(trim(num)) = 0 Then
			checkZero = 0
		else
			'			Since some nations uses Commas where US uses Decimal Points to split whole numbers from fractions, we should
			'				not use the replace below, as it could convert a small number into a large one.
			checkZero = num		'	replace(num, "," , "")
		end if
	end function
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	'
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	public function checkBol(inputVal)
		if  varType(inputVal) = vbBoolean		Then checkBol = cbool(inputVal) : exit Function
		if  varType(inputVal) = vbString		Then
			if trim(lcase(inputVal)) = "true"	Then checkBol = true			: exit Function
		End If
		If  checkZero(inputVal) <> 0			Then checkBol = true			: exit Function
		checkBol = False
	End Function
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	' Check a str for null, returns True for Null Values, False for everything Else
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	Public function checkNull(inputStr)
		if IsNull(inputStr) Or inputStr = "" or isEmpty(inputStr) Then checkNull = True : Exit Function
		checkNull = False
	End Function
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	' Check a str for a numeric value, returns True for Numeric Values, False for everything else
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	Public Function checkNumeric(inputStr)
		if IsNumeric(inputStr) Then checkNumeric = True : Exit Function
		checkNumeric = False
	End Function
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	' Note !! this function returns Zero if the input is not type interger, NOT BOOLEAN !!!!!
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	Public function checkInt(inputInt)
		if checkZero(inputInt) = 0 Then checkInt = 0 : exit function
		checkInt = cint(inputInt)
	End Function
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	' Note !! this function returns Zero if the input is not type interger, NOT BOOLEAN !!!!!
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	public function checkLng(inputLng)
		if checkZero(inputLng) = 0 Then checkLng = 0 : exit function
		checkLng = clng(inputLng)
	end function
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	'
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	public function checkDbl(inputDbl)
		if checkZero(inputDbl) = 0 Then checkDbl = 0 : exit Function
		checkDbl = cdbl(inputDbl)
	end Function
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	'
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	public function checkStr(inputStr)
		if  isNull(inputStr) Then
			checkStr = ""
		ElseIf isEmpty(inputStr) Then
			checkStr = ""
		ElseIf len(trim(inputStr)) = 0 Then
			checkStr = ""
		Else
			checkStr = inputStr
		end If
	end function
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	' simple encrypt/decrypt
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	public function decrypt(ByVal encryptedstring)
		dim x, i, tmp
		encryptedstring = StrReverse( encryptedstring )
		for i = 1 To len( encryptedstring )
			x = mid( encryptedstring, i, 1 )
			tmp = tmp & chr( asc( x ) - 1 )
		Next
		decrypt = tmp
	end function
	'
	public function encrypt(ByVal str)
		dim x, i, tmp
		for i = 1 To len( str )
			x = mid( str, i, 1 )
			tmp = tmp & chr( asc( x ) + 1 )
		Next
		tmp = StrReverse( tmp )
		encrypt = tmp
	end function
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	' Validation-friendly HTML encoding
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	Public function validhtml(byref str)
		If len(str)>0 Then validhtml = replace(str, "& ", "&amp; ")
	End Function
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	' get rid of anchor symbol (#)
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	public function noAnchor(byval str)
		if instr(str, "#")=0 Then noAnchor = str else noAnchor = split(str, "#")(0)
	end Function
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	'
	'	resembles iif() but for types
	'	if val1 has a non-empty ctype value, val1 is returned; otherwise val2
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	public function iift(val1, val2, ctype)
		select case checkInt(ctype)
		case cor_cInt
			val1 = checkInt(val1)
			val2 = checkInt(val2)
			iift = iif(val1 > 0,   val1, val2)
		case cor_cLng, cor_cAut
			val1 = checkLng(val1)
			val2 = checkLng(val2)
			iift = iif(val1 > 0,   val1, val2)
		case cor_cDbl
			val1 = checkDbl(val1)
			val2 = checkDbl(val2)
			iift = iif(val1 <> 0,   val1, val2)
		case cor_cStr
			val1 = checkStr(val1)
			val2 = checkStr(val2)
			iift = iif(val1 <> "", val1, val2)
		Case cor_cSoopBool
			val1 = checkInt(val1)
			val2 = checkInt(val2)
			iift = val1
		case cor_cStrEmpty
			val1 = checkStr(val1)
			val2 = checkStr(val2)
			iift = iif(NOT IsNull(val1), val1, val2)
		end select
	end function
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	private Function ReplaceWithCase(strText, strFind)
	'written Oct 14, 2008 by Charles added to SVN Jan 19, 2009,
	' This code is adapted from http://www.expertsforge.com/Web-Development/Tutorial-58.asp (with major changes)
	' Parameters:
	' strText - string to search in
	' strFind- string to look for
	' Example:
		' This will make all the instances of the word "select" into the word "s&#101;&#108;&#101;ct" which won't run as part of a SQL statement but will appear normal to the user.
		' ReplacePreserveCase(strSomeText, "select")
	Dim nPos
	Dim nLen
	Dim nLenAll
	Dim OldAlpha
	dim NewAlpha
	dim strLeft
	dim strRight
	dim nID
	dim Highlight
	dim FndWord(2)
	'we only need to replace certain key letters to kill just about any injection attempts here: 	Ee, Ll, Rr, Dd, Nn, Xx, Aa,
	OldAlpha = array("A", "a", "D", "d", "E", "e", "L", "l", "N", "n", "R", "r", "X", "x"  )
	newAlpha = array("&#65;", "&#97;", "&#68;", "&#100;", "&#69;", "&#101;", "&#76;", "&#108;", "&#78;", "&#110;", "&#82;", "&#114;", "&#88;", "&#120;"  )
	nLen = Len(strFind)
	Highlight = strText
	If nLen > 0 And Len(Highlight) > 0 Then
		nPos = InStr(1, Highlight, strFind, 1)
		Do While nPos > 0
			'split the string up to get the Find word pulled out apart from the rest of the string.
			strLeft = Left(Highlight, nPos - 1)
			strRight = Mid(Highlight, nPos + nLen)
			'fix the Find word.
			'Highlight =  Mid(Highlight, nPos, nLen)
			FndWord(0) =  Mid(Highlight, nPos, nLen)
			FndWord(1) =  Mid(Highlight, nPos, nLen)
			for nID = lBound(OldAlpha) To ubound(OldAlpha)
				'make the character swap.
				FndWord(1) = replace(FndWord(0), oldAlpha(nID), newAlpha(nID))
				if fndWord(0) <> fndWord(1) then exit for 		'only need to replace any 1 character for a safe string
			Next
			'set New pointer location
			nPos = len(strLeft) + len(FndWord(1) ) + 1
			'Combine everything 
			Highlight = strLeft & FndWord(1) & strRight
			'search again.
			nPos = InStr(nPos, FndWord(1), strFind, 1)
		Loop
	End If
	ReplaceWithCase = Highlight
	End Function
	public function ReverseHTMLAmpCodes(inText)
		'clean out the & codes for non-html text styles.
		dim h, c
		h = array("nbsp", "amp", "lt", "gt", "quot", "iexcl", "cent", "pound", "curren", "yen", "brvbar", "sect", "uml", "copy", _
				"ordf","laquo","not","shy","reg","macr","deg","plusmn","sup2","sup3","acute","micro","para","middot","cedil","sup1","ordm",_
				"raquo","frac14","frac12","frac34","iquest","Agrave","Aacute","Acirc","Atilde","Auml","Aring","AElig","Ccedil","Egrave","Eacute",_
				"Ecirc","Euml","Igrave","Iacute","Icirc","Iuml","ETH","Ntilde","Ograve","Oacute","Ocirc","Otilde","Ouml","times","Oslash","Ugrave",_
				"Uacute","Ucirc","Uuml","Yacute","THORN","szlig","agrave","aacute","acirc","atilde","auml","aring","aelig","ccedil","egrave",_
				"eacute","ecirc","euml","igrave","iacute","icirc","iuml","eth","ntilde","ograve","oacute","ocirc","otilde","ouml","divide",_
				"oslash","ugrave","uacute","ucirc","uuml","yacute","thorn","yuml","euro")
		c = array(" ", "&", "<", ">", """", chr(161), chr(162), chr(163), chr(164), chr(165), chr(166), chr(167), chr(168), chr(169),chr(170),_
				chr(171),chr(172),chr(173),chr(174),chr(175),chr(176),chr(177),chr(178),chr(179),chr(180),chr(181),chr(182),chr(183),chr(184),_
				chr(185),chr(186),chr(187),chr(188),chr(189),chr(190),chr(191),chr(192),chr(193),chr(194),chr(195),chr(196),chr(197),chr(198),_
				chr(199),chr(200),chr(201),chr(202),chr(203),chr(204),chr(205),chr(206),chr(207),chr(208),chr(209),chr(210),chr(211),chr(212),_
				chr(213),chr(214),chr(215),chr(216),chr(217),chr(218),chr(219),chr(220),chr(221),chr(222),chr(223),chr(224),chr(225),chr(226),_
				chr(227),chr(228),chr(229),chr(230),chr(231),chr(232),chr(233),chr(234),chr(235),chr(236),chr(237),chr(238),chr(239),chr(240),_
				chr(241),chr(242),chr(243),chr(244),chr(245),chr(246),chr(247),chr(248),chr(249),chr(250),chr(251),chr(252),chr(253),chr(254),_
				chr(255),chr(8364))
		dim i
		for i = 0 to ubound(h)
			inText = replace(inText, h(i), c(i))
		next
		ReverseHTMLAmpCodes
	end function
	
	public function ReverseHTMLCode(inText)
		'this function will reverse data that's passed through the above filter, converting HTML back to ASCII.
		Dim OldAlpha
		dim NewAlpha
		dim i
		OldAlpha = array("A", "a", "D", "d", "E", "e", "L", "l", "N", "n", "R", "r", "X", "x"  )
		newAlpha = array("&#65;", "&#97;", "&#68;", "&#100;", "&#69;", "&#101;", "&#76;", "&#108;", "&#78;", "&#110;", "&#82;", "&#114;", "&#88;", "&#120;"  )
		for i= 0 to ubound(newAlpha)
			inText = replace(inText,newAlpha(i),oldAlpha(i))
		next
		ReverseHTMLCode = inText
	end function
'
	public function badwordfilter(ByVal strText)
		dim arrBadwords, arrBadWord, objRegExp, i_x, i, replaceCache, bwCache, arrReplace
		if NOT cor.filter.checkBol(blnFetchedWords) Then
			cor.dal.open arrBadwords, "SELECT bw.bwfind, bw.bwreplace FROM " & cor_dbpre & "badwords AS bw ORDER BY bw.bwid DESC", empty
			if NOT cor.butil.eof(arrBadwords) then
				for i_x = 0 to ubound(arrBadwords,2)
					bwCache 	 = bwCache 		& arrBadwords(0,i_x) & ","
					replaceCache = replaceCache & arrBadwords(1,i_x) & ","
				next
				replaceCache = left(replaceCache, len(replaceCache)-1)
				bwCache 	 = left(bwCache, len(bwCache)-1)
				arrBadWord 	 = split(bwCache, ",")
				arrReplace 	 = split(replaceCache, ",")
			else 
				if isArray(arrBadWord) Then erase arrBadWord
				if isArray(arrReplace) Then erase arrReplace
			end if
			blnFetchedWords = true
		end if

		if isArray(arrBadWord) AND isArray(arrReplace) Then
			set objRegExp = New regexp
			objRegExp.Global = true
			objRegExp.IgnoreCase = true
				for i = 0 to ubound(arrBadWord)
				objRegExp.Pattern = "("&arrBadWord(i)&")"
				strText = objRegExp.replace(strText,arrReplace(i))
			next
		end if
		badwordfilter = strText 
	end function 

end class


'<#late-binding hook
function boot_class_filters : boot_class_filters = true : end function
'/>

%>