﻿<%
'------------------------------------------------------------------------------------------------------------------------------------------
' SOOP 2.0 - Phoenix (TNG)
'
'Revision 2.0001 - initial 26/02/2008
'
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'------------------------------------------------------------------------------------------------------------------------------------------
%>
<%
class class_fsoUpload ':: class_string (new), <class_collection, class_file> 

	private filesCol
	private formCol
	private maxFileSize
	private acceptedCT
	private blnOverWrite

	dim stringBuild
	public property get Form()
		set Form = formCol
	end property

	public property get Files()
		set Files = filesCol
	end property

	public property let FileSize(size)
		maxFileSize = size
	end property

	public property get FileSize()
		FileSize = maxFileSize
	end property

	public property let Overwrite(over)
		blnOverWrite = over
	end property

	public property get Overwrite()
		Overwrite = blnOverWrite
	end property

	public property let AcceptedContentTypes(CT)
		acceptedCT = CT
	end property

	private sub class_initialize()
		set stringBuild = new class_string
		set filesCol = new class_collection
		set formCol = new class_collection
		maxFileSize = 0
		blnOverWrite = false
	end sub

	private function ToPlain(Data)
		dim i
		stringBuild.clear
		for i = 1 To LenB(Data)
			stringBuild.add(Chr(AscB(MidB(Data, i, 1))))
		Next
		ToPlain = stringBuild.build()
		stringBuild.clear
	end function

	private Function ToBin(Data)
		dim i, test 
		stringBuild.clear
		for i = 1 to len(Data)
			test = test & ChrB(ascb(Mid(data, i, 1)))
		Next
		ToBin = test
		stringBuild.clear
	end function

	public sub Upload
		call GetFiles
	end sub

	private sub GetFiles
		dim bData, lngEnd, bcrlf, strBoundary, lngBoundaryPos, x, lngStart, strFieldName, lngFileNamePos, strFileName
		dim strContentType, strData, tmpFile

		bcrlf = ToBin(Chr(13))
		bData = request.BinaryRead(request.TotalBytes)

		lngEnd = instrB(1, bData, bcrlf)

		if lngEnd <> 0 Then
			strBoundary = Midb(bData, 1, lngEnd - 1)
			lngBoundaryPos = instrB(1, bData, strBoundary)
		end if

		Do Until lngBoundaryPos = instrB(bData, strBoundary & ToBin("--"))
			x = instrB(lngBoundaryPos, bData, ToBin("Content-Disposition"))
			x = instrB(x, bData, ToBin("name="))
			lngStart = x + 6
			lngEnd = instrB(lngStart, bData, ToBin(Chr(34)))
			strFieldName = ToPlain(MidB(bData, lngStart, lngEnd - lngStart))

			lngFileNamePos = instrB(lngBoundaryPos, bData, ToBin("filename="))

			if lngFileNamePos > 0 And lngFileNamePos < instrb(lngEnd, bData, strBoundary) Then
				lngStart = lngFileNamePos + 10
				lngEnd = instrB(lngStart, bData, ToBin(Chr(34)))
				strFileName = ToPlain(MidB(bData, lngStart, lngEnd - lngStart))

				x = instrB(lngEnd, bData, ToBin("Content-Type:"))
				lngStart = x + 14
				lngEnd = instrB(lngStart, bData, bcrlf)
				strContentType = ToPlain(MidB(bData, lngStart, lngEnd - lngStart))

				lngStart = lngEnd + 4
				lngEnd = instrB(lngStart, bData, strBoundary) - 2
				strData = MidB(bData, lngStart, lngEnd - lngStart)
				if strFileName <> "" and strData <> "" Then
					set tmpFile = new class_file
					tmpFile.Name = strFieldName
					tmpFile.Filename = strFileName
					tmpFile.contentType = strContentType
					tmpFile.FileData = strData
					tmpFile.FileSize = maxFileSize
					tmpFile.AcceptedContentTypes = acceptedCT
					tmpFile.OverWrite = blnOverWrite
					filesCol.Add strFileName, tmpFile
				end if
			else
				x = instrB(x, bData, bcrlf)
				lngStart = x + 4
				lngEnd = instrB(lngStart, bData, strBoundary) - 2
				strData = ToPlain(MidB(bData, lngStart, lngEnd - lngStart))
				formCol.Add strFieldName, strData

			end if
			lngBoundaryPos = instrB(lngBoundaryPos + LenB(strBoundary), bData, strBoundary)
		Loop
	end sub
end class


class class_collection

	private m_objDicItems

	private sub class_initialize()
		set m_objDicItems = server.createObject("Scripting.Dictionary")
		m_objDicItems.CompareMode = vbTextCompare
	end sub

	public property get Count()
		Count = m_objDicItems.Count
	end property

	public default function item(Index)
		dim arrItems
		if IsNumeric(Index) Then
			if m_objDicItems.Count > Index Then
				arrItems = m_objDicItems.Items
				if isObject(arrItems(Index)) Then
					set Item = arrItems(Index)
				else
					Item = arrItems(Index)
				end if
			else
				Item = ""
			end if
		else
			if m_objDicItems.Exists(Index) Then
				if isObject(m_objDicItems.Item(Index)) Then
					set Item = m_objDicItems.Item(Index)
				else
					Item = m_objDicItems.Item(Index)
				end if
			else
				Item = ""
			end if
		end if
	end function

	public sub add(Name, Value)
		if m_objDicItems.Exists(Name) Then
			m_objDicItems.Item(Name) = Value
		else
			m_objDicItems.Add Name, Value
		end if
	end sub

end class

class class_file
	private fname
	private ffilename
	private fcontentType
	private ffileData
	private ffilesize
	private facceptedcontenttypes
	private	foverwrite
	private objFSO

	private sub class_initialize()
		set objFSO = server.createObject("Scripting.FileSystemObject")
	end sub

	property let Name(str)
		fname = str
	end property

	property get Name()
		Name = fname
	end property

	property let Filename(str)
		ffilename = objFSO.GetFileName(str)
	end property

	property get Filename()
		Filename = ffilename
	end property

	property let ContentType(str)
		fcontentType = str
	end property

	property get ContentType()
		ContentType = fcontentType
	end property

	property let FileData(data)
		ffileData = data
	end property

	property let FileSize(size)
		ffilesize = size
	end property

	property let AcceptedContentTypes(ct)
		facceptedcontenttypes = ct
	end property

	property let OverWrite(over)
		foverwrite = over
	end property

	public function SaveFile(Path)
		dim objFile, i, filename, strpath, intseconds, blnAcceptedCt, arrCT
		filename = ffilename
		if len(facceptedcontenttypes) = 0 Then
			blnAcceptedCt = true
		else
			arrCT = Split(facceptedcontenttypes, ",")
			blnAcceptedCt = false
			for i = 0 To ubound(arrCT)
				if Lcase(fcontentType) = Lcase(arrCT(i)) Then
					blnAcceptedCt = true
				end if
			Next
		end if
		if blnAcceptedCt Then
			if clng(ffilesize) > clng(LenB(ffileData)) Or clng(ffilesize) = 0 Then
				strpath = objFSO.BuildPath(path, filename)
				if objFSO.FileExists(strpath) Then
					if foverwrite = false Then
						intseconds = dateDiff("s", "1970-01-01 00:00:00", now())
						filename = intseconds & filename
						ffilename = filename
						strpath = objFSO.BuildPath(path, filename)
					else
						objFSO.DeleteFile strpath, true
					end if
				end if
				set objFile = objFSO.CreateTextFile(strpath)
				for i = 1 to LenB(ffileData)
					objFile.write Chr(AscB(MidB(ffileData, i, 1)))
				Next
				objFile.close : set objFile = nothing
				SaveFile = "ok"
			else
				SaveFile = "too large"
			end if
		else
			SaveFile = "not accepted format"
		end if
		set objFSO = nothing
	end function

end class

'<#late-binding hook
function boot_class_fsoUpload : boot_class_fsoUpload = true : end function
'/>

%>
