﻿<%
'------------------------------------------------------------------------------------------------------------------------------------------
' SOOP 2.0 - Phoenix (TNG)
'
' Revision 2.00 - initial 15/02/2008
'
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'------------------------------------------------------------------------------------------------------------------------------------------
%>
<%
class class_hash1way
	'

    
    
    public function encode(strSecret)
    ' function takes an ASCII string less than 2^61 characters long and 
    ' one way hash encrypts it using 160 bit encryption into a 40 digit hex value.
    ' The encoded hex value cannot be decoded to the original string value.
    '
    ' This is the only function that you need to call for encryption.
    '
    ' Written By: Mark G. Jager
    ' Written Date: 8/10/2000
    '
    ' Free to distribute as long as code is not modified, and header is kept intact
    '
    ' The author makes no warranties as to the validity, and/or authenticity of this code.
    ' You may use any code found herein at your own risk.
    ' This code was written to follow as closely as possible the standards found in
    ' Federal Information Processing Standards Publication (FIPS PUB 180-1)
    ' http://csrc.nist.gov/fips/fip180-1.txt -- Secure Hash Standard SHA-1
    '
    ' This code is for private use only, and the security and/or encryption of the resulting
    ' hexadecimal value is not warrented or gaurenteed in any way.
    '
    		dim strEncode, strH(4)
    		dim intPos
    		
    		
    		if len(strSecret) = 0 or len(strSecret) >= 2^61 then
    		HashEncode = "0000000000000000000000000000000000000000"
    		exit function
    		end if
    		
    		
    		'Initial Hex words are used for encoding Digest.	
    		'These can be any valid 8-digit hex value (0 to F)
    		strH(0) = "FB0C14C2"
    		strH(1) = "9F00AB2E"
    		strH(2) = "991FFA67"
    		strH(3) = "76FA2C3F"
    		strH(4) = "ADE426FA"
    		
    		for intPos = 1 to len(strSecret) step 56
    		
    		strEncode = Mid(strSecret, intPos, 56) 'get 56 character chunks
    		strEncode = wordToBinary(strEncode) 'convert to binary
    		strEncode = padBinary(strEncode) 'make it 512 bites
    		strEncode = blockToHex(strEncode) 'convert to hex value
    		
    		'Encode the hex value using the previous runs digest
    		'if it is the first run then use the initial values above
    		strEncode = DigestHex(strEncode, strH(0), strH(1), strH(2), strH(3), strH(4))
    
    		'Combine the old digest with the new digest
    		strH(0) = hexAdd(left(strEncode, 8), strH(0))
    		strH(1) = hexAdd(mid(strEncode, 9, 8), strH(1))
    		strH(2) = hexAdd(mid(strEncode, 17, 8), strH(2))
    		strH(3) = hexAdd(mid(strEncode, 25, 8), strH(3))
    		strH(4) = hexAdd(right(strEncode, 8), strH(4))
    		
    		Next
    		
    		'This is the final Hex Digest
    		encode = strH(0) & strH(1) & strH(2) & strH(3) & strH(4)
    		
    end function
    
    
    
    public function hexToBinary(btHex)
    
    ' function Converts a single hex value into it's binary equivalent
    '
    ' Written By: Mark Jager
    ' Written Date: 8/10/2000
    '
    ' Free to distribute as long as code is not modified, and header is kept intact
    '
    
    		Select Case btHex
    		Case "0"
    				hexToBinary = "0000"
    		Case "1"
    				hexToBinary = "0001"
    		Case "2"
    				hexToBinary = "0010"
    		Case "3"
    				hexToBinary = "0011"
    		Case "4"
    				hexToBinary = "0100"
    		Case "5"
    				hexToBinary = "0101"
    		Case "6"
    				hexToBinary = "0110"
    		Case "7"
    				hexToBinary = "0111"
    		Case "8"
    				hexToBinary = "1000"
    		Case "9"
    				hexToBinary = "1001"
    		Case "A"
    				hexToBinary = "1010"
    		Case "B"
    				hexToBinary = "1011"
    		Case "C"
    				hexToBinary = "1100"
    		Case "D"
    				hexToBinary = "1101"
    		Case "E"
    				hexToBinary = "1110"
    		Case "F"
    				hexToBinary = "1111"
    		Case else
    				hexToBinary = "2222"
    		End Select
    end function
    
    public function binaryToHex(strBinary)
    
    ' function Converts a 4 bit binary value into it's hex equivalent
    '
    ' Written By: Mark Jager
    ' Written Date: 8/10/2000
    '
    ' Free to distribute as long as code is not modified, and header is kept intact
    '
    		Select Case strBinary
    		Case "0000"
    				binaryToHex = "0"
    		Case "0001"
    				binaryToHex = "1"
    		Case "0010"
    				binaryToHex = "2"
    		Case "0011"
    				binaryToHex = "3"
    		Case "0100"
    				binaryToHex = "4"
    		Case "0101"
    				binaryToHex = "5"
    		Case "0110"
    				binaryToHex = "6"
    		Case "0111"
    				binaryToHex = "7"
    		Case "1000"
    				binaryToHex = "8"
    		Case "1001"
    				binaryToHex = "9"
    		Case "1010"
    				binaryToHex = "A"
    		Case "1011"
    				binaryToHex = "B"
    		Case "1100"
    				binaryToHex = "C"
    		Case "1101"
    				binaryToHex = "D"
    		Case "1110"
    				binaryToHex = "E"
    		Case "1111"
    				binaryToHex = "F"
    		Case else
    				binaryToHex = "Z"
    		End Select
    end function
    
    public function wordToBinary(strWord)
    ' function Converts a 8 digit hex value into it's 32 bit binary equivalent
    '
    ' Written By: Mark Jager
    ' Written Date: 8/10/2000
    '
    ' Free to distribute as long as code is not modified, and header kept intact
    '
    	dim strTemp, strBinary 
    	dim intPos
    
    	for intPos = 1 To len(strWord)
    			strTemp = Mid(strWord, cint(intPos), 1)
    			strBinary = strBinary & intToBinary(Asc(strTemp))
    	Next
    
    	wordToBinary = strBinary
    
    end function
    
    public function hexToInt(strHex)
    ' function Converts a hex word to its base 10(decimal) equivalent
    '
    ' Written By: Mark Jager
    ' Written Date: 8/10/2000
    '
    ' Free to distribute as long as code is not modified, and header is kept intact
    '
    
    	dim intNew, intPos, intLen
    
    	intNew = 0
    	intLen = CDbl(len(strHex)) - 1
    	
    	for intPos = CDbl(intLen) to 0 step -1
    			Select Case Mid(strHex, CDbl(intPos) + 1, 1)			 
    			Case "0"
    			intNew = CDbl(intNew) + (0 * 16^CDbl(intLen - intPos))
    			Case "1"
    					intNew = CDbl(intNew) + (1 * 16^CDbl(intLen - intPos))
    			Case "2"
    					intNew = CDbl(intNew) + (2 * 16^CDbl(intLen - intPos))
    			Case "3"
    					intNew = CDbl(intNew) + (3 * 16^CDbl(intLen - intPos))
    			Case "4"
    					intNew = CDbl(intNew) + (4 * 16^CDbl(intLen - intPos))
    			Case "5"
    					intNew = CDbl(intNew) + (5 * 16^CDbl(intLen - intPos))
    			Case "6"
    					intNew = CDbl(intNew) + (6 * 16^CDbl(intLen - intPos))
    			Case "7"
    					intNew = CDbl(intNew) + (7 * 16^CDbl(intLen - intPos))
    			Case "8"
    					intNew = CDbl(intNew) + (8 * 16^CDbl(intLen - intPos))
    			Case "9"
    					intNew = CDbl(intNew) + (9 * 16^CDbl(intLen - intPos))
    			Case "A"
    					intNew = CDbl(intNew) + (10 * 16^CDbl(intLen - intPos))
    			Case "B"
    					intNew = CDbl(intNew) + (11 * 16^CDbl(intLen - intPos))
    			Case "C"
    					intNew = CDbl(intNew) + (12 * 16^CDbl(intLen - intPos))
    			Case "D"
    					intNew = CDbl(intNew) + (13 * 16^CDbl(intLen - intPos))
    			Case "E"
    					intNew = CDbl(intNew) + (14 * 16^CDbl(intLen - intPos))
    			Case "F"
    					intNew = CDbl(intNew) + (15 * 16^CDbl(intLen - intPos))
    		End Select
    
    	Next
    
    	hexToInt = CDbl(intNew)
    	
    end function
    
    public function intToBinary(intNum)
    
    ' function Converts an integer number to it's binary equivalent
    '
    ' Written By: Mark Jager
    ' Written Date: 8/10/2000
    '
    ' Free to distribute as long as code is not modified, and header is kept intact
    '
    		dim strBinary, strTemp
    		dim intNew, intTemp
    		dim dblNew
    		
    		intNew = intNum
    		
    		Do While intNew > 1
    				dblNew = CDbl(intNew) / 2
    				intNew = Round(CDbl(dblNew) - 0.1, 0)
    				if CDbl(dblNew) = CDbl(intNew) Then
    						strBinary = "0" & strBinary
    				else
    						strBinary = "1" & strBinary
    				end if
    
    		Loop
    		
    		strBinary = intNew & strBinary
    		
    		intTemp = len(strBinary) mod 8
    		
    		for intNew = intTemp To 7
    				strBinary = "0" & strBinary
    		Next
    		
    		intToBinary = strBinary
    		
    end function
    
    public function padBinary(strBinary)
    
    ' function adds 0's to a binary string until it reaches 448 bits.
    ' The lenghth of the original string is incoded into the last 16 bits.
    ' The end result is a binary string 512 bits long
    '
    ' Written By: Mark Jager
    ' Written Date: 8/10/2000
    '
    ' Free to distribute as long as code is not modified, and header is kept intact
    '
    
    	dim intPos, intLen
    	dim strTemp
    			
    	intLen = len(strBinary)
    			
    	strBinary = strBinary & "1"
    			
    	for intPos = len(strBinary) To 447
    			strBinary = strBinary & "0"
    	Next
    			
    	strTemp = intToBinary(intLen)
    			
    	for intPos = len(strTemp) To 63
    			strTemp = "0" & strTemp
    	Next
    			
    	strBinary = strBinary & strTemp
    			
    	padBinary = strBinary
    			
    end function
    
    public function blockToHex(strBinary)
    
    ' function Converts a 32 bit binary string into it's 8 digit hex equivalent
    '
    ' Written By: Mark Jager
    ' Written Date: 8/10/2000
    '
    ' Free to distribute as long as code is not modified, and header is kept intact
    '
    	dim intPos
    	dim strHex
    
    	for intPos = 1 To len(strBinary) Step 4
    			strHex = strHex & binaryToHex(Mid(strBinary, intPos, 4))
    	Next
    
    	blockToHex = strHex
    
    end function
    
    public function DigestHex(strHex, strH0, strH1, strH2, strH3, strH4)
    
    ' Main encoding function.	Takes a 128 digit/512 bit hex value and one way encrypts it into
    ' a 40 digit/160 bit hex value.
    '
    ' Written By: Mark Jager
    ' Written Date: 8/10/2000
    '
    ' Free to distribute as long as code is not modified, and header is kept intact
    '
    	dim strWords(79), adoConst(4), strTemp, strTemp1, strTemp2, strTemp3, strTemp4
    	dim intPos
    	dim strH(4), strA(4), strK(3)
    
    	'Constant hex words are used for encryption, these can be any valid 8 digit hex value
    		strK(0) = "5A827999"
    		strK(1) = "6ED9EBA1"
    		strK(2) = "8F1BBCDC"
    		strK(3) = "CA62C1D6"
    		
    		'Hex words are used in the encryption process, these can be any valid 8 digit hex value
    		strH(0) = strH0
    		strH(1) = strH1
    		strH(2) = strH2
    		strH(3) = strH3
    		strH(4) = strH4
    		
    		'divide the Hex block into 16 hex words
    	for intPos = 0 To (len(strHex) / 8) - 1
    			strWords(cint(intPos)) = Mid(strHex, (cint(intPos)*8) + 1, 8)
    	Next
    
    
    		'encode the Hex words using the constants above
    		'innitialize 80 hex word positions
    	for intPos = 16 To 79
    			strTemp = strWords(cint(intPos) - 3)
    			strTemp1 = hexBlockToBinary(strTemp)
    			strTemp = strWords(cint(intPos) - 8)
    			strTemp2 = hexBlockToBinary(strTemp)
    			strTemp = strWords(cint(intPos) - 14)
    			strTemp3 = hexBlockToBinary(strTemp)
    			strTemp = strWords(cint(intPos) - 16)
    			strTemp4 = hexBlockToBinary(strTemp)
    			strTemp = binaryXOR(strTemp1, strTemp2)
    			strTemp = binaryXOR(strTemp, strTemp3)
    			strTemp = binaryXOR(strTemp, strTemp4)
    			strWords(cint(intPos)) = blockToHex(binaryShift(strTemp, 1))
    	Next
    
    		'initialize the changing word variables with the initial word variables
    	strA(0) = strH(0)
    	strA(1) = strH(1)
    	strA(2) = strH(2)
    	strA(3) = strH(3)
    	strA(4) = strH(4)
    
    	'Main encryption loop on all 80 hex word positions
    	for intPos = 0 To 79
    			strTemp = binaryShift(hexBlockToBinary(strA(0)), 5)
    			strTemp1 = hexBlockToBinary(strA(3))
    			strTemp2 = hexBlockToBinary(strWords(cint(intPos)))
    			
    			Select Case intPos
    			
    			Case 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19
    					strTemp3 = hexBlockToBinary(strK(0))
    					strTemp4 = binaryOR(binaryAND(hexBlockToBinary(strA(1)), _
    				hexBlockToBinary(strA(2))), binaryAND(binaryNOT(hexBlockToBinary(strA(1))), _
    				hexBlockToBinary(strA(3))))
    			Case 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39
    					strTemp3 = hexBlockToBinary(strK(1))
    					strTemp4 = binaryXOR(binaryXOR(hexBlockToBinary(strA(1)), _
    				hexBlockToBinary(strA(2))), hexBlockToBinary(strA(3)))
    			Case 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59
    					strTemp3 = hexBlockToBinary(strK(2))
    					strTemp4 = binaryOR(binaryOR(binaryAND(hexBlockToBinary(strA(1)), _
    				hexBlockToBinary(strA(2))), binaryAND(hexBlockToBinary(strA(1)), _
    				hexBlockToBinary(strA(3)))), binaryAND(hexBlockToBinary(strA(2)), _
    				hexBlockToBinary(strA(3))))
    			Case 60, 61, 62, 63, 64, 65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79
    					strTemp3 = hexBlockToBinary(strK(3))
    					strTemp4 = binaryXOR(binaryXOR(hexBlockToBinary(strA(1)), _
    				hexBlockToBinary(strA(2))), hexBlockToBinary(strA(3)))
    			End Select
    			
    			strTemp = blockToHex(strTemp)
    			strTemp1 = blockToHex(strTemp1)
    			strTemp2 = blockToHex(strTemp2)
    			strTemp3 = blockToHex(strTemp3)
    			strTemp4 = blockToHex(strTemp4)
    			
    			strTemp = hexAdd(strTemp, strTemp1)
    			strTemp = hexAdd(strTemp, strTemp2)
    			strTemp = hexAdd(strTemp, strTemp3)
    			strTemp = hexAdd(strTemp, strTemp4)
    			
    			strA(4) = strA(3)
    			strA(3) = strA(2)
    			strA(2) = blockToHex(binaryShift(hexBlockToBinary(strA(1)), 30))
    			strA(1) = strA(0)
    			strA(0) = strTemp
    			
    	Next
    
    	'Concatenate the final Hex Digest
    	DigestHex = strA(0) & strA(1) & strA(2) & strA(3) & strA(4)
    
    end function
    
    public function hexAdd(strHex1, strHex2)
    ' function adds to 8 digit/32 bit hex values together Mod 2^32
    '
    ' Written By: Mark Jager
    ' Written Date: 8/10/2000
    '
    ' Free to distribute as long as code is not modified, and header is kept intact
    '
    		dim intCalc
    		dim strNew
    		
    		intCalc = 0
    		intCalc = CDbl(CDbl(hexToInt(strHex1)) + CDbl(hexToInt(strHex2)))
    		Do While CDbl(intCalc) > 2^32
    		intCalc = CDbl(intCalc) - 2^32
    		Loop
    			 
    		strNew = intToBinary(CDbl(intCalc))
    		Do While len(strNew) < 32
    				strNew = "0" & strNew
    		Loop
    		strNew = blockToHex(strNew)
    		
    		if instr(strNew, "00") = 1 and len(strNew) = 10 then
    		strNew = right(strNew, 8)
    		end if
    		
    		hexAdd = strNew
    
    end function
       
    public function getDecHex(strHex)
    ' function Converts a single decimal value(0 - 15) into it's hex equivalent
    '
    ' Written By: Mark Jager
    ' Written Date: 8/10/2000
    '
    ' Free to distribute as long as code is not modified, and header is kept intact
    '
    		Select Case cint(strHex)
    		Case 0
    			 getDecHex = "0"
    		Case 1
    			 getDecHex = "1"
    		Case 2
    			 getDecHex = "2"
    		Case 3
    			 getDecHex = "3"
    		Case 4
    			 getDecHex = "4"
    		Case 5
    			 getDecHex = "5"
    		Case 6
    			 getDecHex = "6"
    		Case 7
    			 getDecHex = "7"
    		Case 8
    			 getDecHex = "8"
    		Case 9
    			 getDecHex = "9"
    		Case 10
    			 getDecHex = "A"
    		Case 11
    			 getDecHex = "B"
    		Case 12
    			 getDecHex = "C"
    		Case 13
    			 getDecHex = "D"
    		Case 14
    			 getDecHex = "E"
    		Case 15
    			 getDecHex = "F"
    		Case else
    			 getDecHex = "Z"
    		End Select
    end function
    
    public function binaryShift(strBinary, intPos)
    ' function circular left shifts a binary value n places
    '
    ' Written By: Mark Jager
    ' Written Date: 8/10/2000
    '
    ' Free to distribute as long as code is not modified, and header is kept intact
    '
    		binaryShift = Right(strBinary, len(strBinary) - cint(intPos)) & _
    		left(strBinary, cint(intPos))
    
    end function
    
    public function binaryXOR(strBin1, strBin2)
    ' function performs an exclusive or function on each position of two binary values
    '
    ' Written By: Mark Jager
    ' Written Date: 8/10/2000
    '
    ' Free to distribute as long as code is not modified, and header is kept intact
    '
    		dim strBinaryFinal
    		dim intPos
    		
    		for intPos = 1 To len(strBin1)
    				Select Case Mid(strBin1, cint(intPos), 1)
    				
    				Case Mid(strBin2, cint(intPos), 1)
    						strBinaryFinal = strBinaryFinal & "0"
    				Case else
    						strBinaryFinal = strBinaryFinal & "1"
    				End Select
    		Next
    		
    		binaryXOR = strBinaryFinal
    		
    end function
    
    public function binaryOR(strBin1, strBin2)
    ' function performs an inclusive or function on each position of two binary values
    '
    ' Written By: Mark Jager
    ' Written Date: 8/10/2000
    '
    ' Free to distribute as long as code is not modified, and header is kept intact
    '
    		dim strBinaryFinal
    		dim intPos
    		
    		for intPos = 1 To len(strBin1)
    				if Mid(strBin1, cint(intPos), 1) = "1" Or Mid(strBin2, cint(intPos), 1) = "1" Then
    						strBinaryFinal = strBinaryFinal & "1"
    				else
    						strBinaryFinal = strBinaryFinal & "0"
    				end if
    		Next
    		
    		binaryOR = strBinaryFinal
    end function
    
    public function binaryAND(strBin1, strBin2)
    ' function performs an AND function on each position of two binary values
    '
    ' Written By: Mark Jager
    ' Written Date: 8/10/2000
    '
    ' Free to distribute as long as code is not modified, and header is kept intact
    '
    		dim strBinaryFinal
    		dim intPos
    		
    		for intPos = 1 To len(strBin1)
    				if Mid(strBin1, cint(intPos), 1) = "1" And Mid(strBin2, cint(intPos), 1) = "1" Then
    						strBinaryFinal = strBinaryFinal & "1"
    				else
    						strBinaryFinal = strBinaryFinal & "0"
    				end if
    		Next
    		
    		binaryAND = strBinaryFinal
    end function
    
    public function binaryNOT(strBinary)
    ' function makes each position of a binary value from 1 to 0 and 0 to 1
    '
    ' Written By: Mark Jager
    ' Written Date: 8/10/2000
    '
    ' Free to distribute as long as code is not modified, and header is kept intact
    '
    		dim strBinaryFinal
    		dim intPos
    		
    		for intPos = 1 To len(strBinary)
    				if Mid(strBinary, cint(intPos), 1) = "1" Then
    						strBinaryFinal = strBinaryFinal & "0"
    				else
    						strBinaryFinal = strBinaryFinal & "1"
    				end if
    		Next
    		
    		binaryNOT = strBinaryFinal
    		
    end function
    
    public function hexBlockToBinary(strHex)
    ' function Converts a 8 digit/32 bit hex value to its 32 bit binary equivalent
    '
    ' Written By: Mark Jager
    ' Written Date: 8/10/2000
    '
    ' Free to distribute as long as code is not modified, and header is kept intact
    '
    		dim intPos
    		dim strTemp
    		
    		for intPos = 1 To len(strHex)
    				strTemp = strTemp & hexToBinary(Mid(strHex, cint(intPos), 1))
    		Next
    		
    		hexBlockToBinary = strTemp
    		
    end function

end class

'<#late-binding hook
function boot_class_hash1way : boot_class_hash1way = true : end function
'/>

%>
