﻿<%
'------------------------------------------------------------------------------------------------------------------------------------------
' SOOP 2.0 - Phoenix (TNG)
'
' Revision 2.00 - initial 15/02/2008
'
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'------------------------------------------------------------------------------------------------------------------------------------------
class class_imageSizer ':: class_objectsPool

    '	This routine will attempt to identify any filespec passed	
    '	as a graphic file (regardless of the extension). This will 
    '	work with BMP, GIF, JPG and PNG files.
    '	Based on ideas presented by David Crowell
    '	Copyright *c* MM,	Mike Shaffer
    '	ALL RIGHTS RESERVED WORLDWIDE
    '	Permission is granted to use this code
    '	in your projects, as long as this
    '	copyright notice is included
    '
    '	This function gets a specified number of bytes from any
    '	file, starting at the offset (base 1)
    '
    '	Passed:
    '		 flnm => Filespec of file to read
    '		 offset => Offset at which to start reading
    '		 bytes => How many bytes to read
    '
    public function GetBytes(flnm, offset, bytes)
    	'On error resume next
    	dim objFTemp
    	dim objTextStream
    	dim lngSize
    	dim strBuff

    	call cor.obj.init("fso")
    	set objFTemp = cor.obj.fso.GetFile(flnm)
    	lngSize = objFTemp.Size
    	set objFTemp = nothing
    	set objTextStream = cor.obj.fso.openTextFile(flnm, cor_cForReading)
    	if offset > 0 then
    		strBuff = objTextStream.Read(offset - 1)
    	end if
    	if bytes = -1 then		' Get All!
    		GetBytes = objTextStream.Read(lngSize)	'ReadAll
    	else
    		GetBytes = objTextStream.Read(bytes)
    	end if
    	objTextStream.close
    	set objTextStream = nothing
    	'On error goto 0
   end function
  
   public function gfxSpex(flnm, width, height, depth, strImageType)
    	dim strPNG 
    	dim strGIF
    	dim strBMP
    	dim strType
    	dim strBuff
    	dim lngSize
    	dim lngPos
    	dim flgFound
    	dim strTarget
    	dim exitLoop
    	dim lngMarkerSize
    	strType = ""
    	strImageType = "(unknown)"
    	gfxSpex = false
    	strPNG = chr(137) & chr(80) & chr(78)
    	strGif = "GIF"
    	strBMP = chr(66) & chr(77)
    	strType = GetBytes(flnm, 0, 3)
    	if strType = strGif then ' is GIF
    		strImageType = "GIF"
    		Width = lngConvert(GetBytes(flnm, 7, 2))
    		Height = lngConvert(GetBytes(flnm, 9, 2))
    		Depth = 2 ^ ((asc(GetBytes(flnm, 11, 1)) and 7) + 1)
    		gfxSpex = true
    	elseif left(strType, 2) = strBMP then ' is BMP
    		strImageType = "BMP"
    		Width = lngConvert(GetBytes(flnm, 19, 2))
    		Height = lngConvert(GetBytes(flnm, 23, 2))
    		Depth = 2 ^ (asc(GetBytes(flnm, 29, 1)))
    		gfxSpex = true
    	elseif strType = strPNG then ' Is PNG
    		strImageType = "PNG"
    		Width = lngConvert2(GetBytes(flnm, 19, 2))
    		Height = lngConvert2(GetBytes(flnm, 23, 2))
    		Depth = getBytes(flnm, 25, 2)
    		select case asc(right(Depth,1))
    			case 0
    				Depth = 2 ^ (asc(left(Depth, 1)))
    				gfxSpex = true
    			case 2
    				Depth = 2 ^ (asc(left(Depth, 1)) * 3)
    				gfxSpex = true
    			case 3
    				Depth = 2 ^ (asc(left(Depth, 1))) '8
    				gfxSpex = true
    			case 4
    				Depth = 2 ^ (asc(left(Depth, 1)) * 2)
    				gfxSpex = true
    			case 6
    				Depth = 2 ^ (asc(left(Depth, 1)) * 4)
    				gfxSpex = true
    			case else
    				Depth = -1
    		end select
    	else
    		strBuff = GetBytes(flnm, 0, -1) ' Get all bytes from file
    		lngSize = len(strBuff)
    		flgFound = 0
    		strTarget = chr(255) & chr(216) & chr(255)
    		flgFound = instr(strBuff, strTarget)
    		if flgFound = 0 then
    			 exit function
    		end if
    		strImageType = "JPG"
    		lngPos = flgFound + 2
    		exitLoop = false
    		do while exitLoop = false and lngPos < lngSize
    			do while asc(mid(strBuff, lngPos, 1)) = 255 and lngPos < lngSize
    				lngPos = lngPos + 1
    			loop
    			if asc(mid(strBuff, lngPos, 1)) < 192 or asc(mid(strBuff, lngPos, 1)) > 195 then
    				lngMarkerSize = lngConvert2(mid(strBuff, lngPos + 1, 2))
    				lngPos = lngPos + lngMarkerSize	+ 1
    			else
    				exitLoop = true
    			end if
    		loop
    		if exitLoop = false then
    			Width = -1
    			Height = -1
    			Depth = -1
    		else
    			Height = lngConvert2(mid(strBuff, lngPos + 4, 2))
    			Width = lngConvert2(mid(strBuff, lngPos + 6, 2))
    			Depth = 2 ^ (asc(mid(strBuff, lngPos + 8, 1)) * 8)
    			gfxSpex = true
    		end if
    	end if
    end function
    


    private function lngConvert(strTemp)
    	lngConvert = clng(asc(left(strTemp, 1)) + ((asc(right(strTemp, 1)) * 256)))
    end function
    
    private function lngConvert2(strTemp)
    	lngConvert2 = clng(asc(right(strTemp, 1)) + ((asc(left(strTemp, 1)) * 256)))
    end function

end class

'<#late-binding hook
function boot_class_imageSizer : boot_class_imageSizer = true : end function
'/>


%>
