﻿<%
'------------------------------------------------------------------------------------------------------------------------------------------
' SOOP 2.0 - Phoenix (TNG)
'
' Revision 2.00 - initial 15/02/2008
'
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'------------------------------------------------------------------------------------------------------------------------------------------

class class_io ':: global, class_filters, class_objectsPool
	'
	public property get isUpload()
		if instr(sContentType, "multipart/form-data") > 0 Then isUpload = true else isUpload = false
	end property
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	' Request obj short-hands with increased security
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	public function q(qItem)
		' use special marker to recognize full querystring
		if qItem <> cQueryString Then qVal = trim(request.querystring(qItem)) else qVal = trim(request.querystring)
		q = dictIO(pre_q&qItem, qVal, shieldType)
	end function
	'
	public function qa()
		qa = q(cQueryString)
	end function
	'
	public function f(qItem)
		if isUpload Then exit function 'disable if binary upload currently being used 
		if qItem <> cForm Then qVal = request.form(qItem) else qVal = request.form
		f = dictIO(pre_f&qItem, qVal, shieldType)
	end function
	'
	public function f_rtf(qItem)
		'--- relax filter to allow HTML tags
		shieldType = cor_cShieldSql
		f_rtf = f(qItem)
		'--- tight to default again
		shieldType = cor_cShieldSqlXSS
	end function
	'
	public function fa()
		fa = f(cForm)
	end function
	'
	' first q then f
	public function r(qItem)
		if  qItem = cQueryString OR len(request.querystring(qItem)) >0  Then 
			r = q(qItem)
		elseif NOT isUpload Then
			if request.form(qItem) <> "" Then r = f(qItem)
		end if	
	end function
	'
	' first f then q
	public function fq(qItem)
		if  cor_bPostback Then
			if request.form(qItem) <> "" Then fq = f(qItem)	: exit function		
		end if
		fq = q(qItem)
	end function
	'
	public function ra()
		ra = r(cQueryString)
	end function
    '
    '------------------------------------------------------------------------------------------------------------------------------------------
    '
	' form OR value selector, depending on their value type
	' form values take precedence
    '
    '------------------------------------------------------------------------------------------------------------------------------------------
	' short-hands
	public function qv(name, val, ctype)
		qv = cor.filter.iift (q (name), val, ctype)
	end function
	'
	public function fv(name, val, ctype)
		fv = cor.filter.iift (f (name), val, ctype)
	end function
	'
	public function rv(name, val, ctype)
		rv = cor.filter.iift (r (name), val, ctype)
	end function
	'
	public function fv_rtf(name, val, ctype)
		fv_rtf = cor.filter.iift (f_rtf (name), val, ctype)
	end function
	'
	private function dictIO(idx, val, lev)
		if NOT cor.obj.dict.exists(pre&idx) Then cor.obj.dict.add pre&idx, cor.filter.sqlShield(val, lev)
		dictIO = cor.obj.dict.item(pre&idx)
	end function
	'
	private sub class_initialize()
		set regEx 	  = new RegExp
		' init reusable dict
		call cor.obj.init("dict")
		' used to distinguish elems of this class when in a same dict obj with others
		pre 		  = "io___"
		' used to mark use of serialized querystring/form arrays
		cQueryString  = "qa___"
		cForm 		  = "fa___"
		' used to distinguish querystring/form variables as may be same named but different valued
		pre_q		  = "q___"
		pre_f		  = "f___"
		sContentType  = lcase(request.serverVariables("HTTP_CONTENT_TYPE"))	
		shieldType	  = cor_cShieldSqlXSS
	end sub
	'
	private pre, pre_q, pre_f, regEx, FSO, qVal, strtmp, pattern, cQueryString, cForm, sContentType, shieldType
end class

'<#late-binding hook
function boot_class_io : boot_class_io = true : end function
'/>

%>
