﻿<%
'------------------------------------------------------------------------------------------------------------------------------------------
' SOOP 2.0 - Phoenix (TNG)
'
' Revision 2.00 - initial 15/02/2008
'
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'------------------------------------------------------------------------------------------------------------------------------------------
%>
<%
class class_languageParser ':: global, class_baseUtils, class_objectsPool

	public function start(lang)
		dim lngFile_core, lngFile_mods
		dim oStream, oRegEx
		dim sLngXML
		'
		if  NOT cor_cUseLangCache OR isEmpty(cor.butil.getCache("LanguageCache_"&lang)) Then
			lngFile_core 	= server.mappath(cor_sWebroot & "core/languages/" & lang &".xml")
			lngFile_mods 	= server.mappath(cor_sWebroot & "mods/languages/" & lang &".xml")
			'
			set oStream 	= server.createObject("ADODB.Stream")
			oStream.Type 	= cor_cTypeText
			oStream.charset = cor_sCharset
			'--- load choosen language file for core
			oStream.open
			oStream.loadFromFile lngFile_core
			sLngXML 		= oStream.readText
			oStream.close
			'--- load choosen language file for mods
			oStream.open
			oStream.loadFromFile lngFile_mods
			sLngXML 		= sLngXML & oStream.readText
			oStream.close
			set oStream 	= nothing
			'
			'--- clean (redundant) header tags
			set oRegEx 		= New Regexp
			oRegEx.ignoreCase = true
			oRegEx.global 	= true
			oRegEx.pattern 	= "(<\?xml(.|\n)+?>)|(<lang>)|(</lang>)"
			sLngXML 		= oRegEx.replace(sLngXML,"")
			set oRegEx 		= nothing
			'
			'--- add header tags again to pass XML parser validation
			sLngXML = "<?xml version=""1.0"" encoding=""utf-8""?><lang>" & sLngXML & "</lang>"
            '
            'ML
            'cor_bEnableAudit = true
            'cor.audit.writeLogFile "Language Parser called for default CORE and MODs language XML files", "textes.txt"
            '
			'
			'---
			cor.butil.updCache "LanguageCache_"&lang, sLngXML, "lang"
		end if
		'
		call cor.obj.init("lngxml")
		'
		'--- for higher performance, most of these settings below should be disabled
		'--- http://msdn2.microsoft.com/en-us/library/ms950760.aspx#xml0221_topic2
		cor.obj.lngxml.validateOnParse 	= false
		cor.obj.lngxml.resolveExternals 	= false
		cor.obj.lngxml.preserveWhiteSpace 	= true
		'
		cor.obj.lngxml.async = false
		if  cor_cUseLangCache Then
			start = cor.obj.lngxml.loadXML(cor.butil.getCache("LanguageCache_"&lang))
		else
			start = cor.obj.lngxml.loadXML(sLngXML)
		end if
		'
		'--- error found during parsing
		if NOT start Then cor.stopper _
			  "[ERR:class_languageParser] Parsing error in language file. Check " _
			& "<a href='mods/languages/" & lang & ".xml'>this</a> and " _
			& "<a href='core/languages/" & lang & ".xml'>this</a>."
        '
        '
	end function

	public sub includePlugin(byval folderPlugin, byval lang)
		'
		dim lngFile_core, lngFile_mods
		dim oStream, oRegEx
		dim sLngXML
		dim lngPlugin

		lngFile_core 	= server.mappath(cor_sWebroot & "core/languages/" & lang &".xml")
		lngFile_mods 	= server.mappath(cor_sWebroot & "mods/languages/" & lang &".xml")
		lngPlugin 	    = server.mappath(cor_sWebroot & "mods/languages/" & folderPlugin & "/" & lang &".xml")
		'
		set oStream 	= server.createObject("ADODB.Stream")
		oStream.Type 	= cor_cTypeText
		oStream.charset = cor_sCharset
		'--- load choosen language file for core
		oStream.open
		oStream.loadFromFile lngFile_core
		sLngXML 		= oStream.readText
		oStream.close
		'--- load choosen language file for mods
		oStream.open
		oStream.loadFromFile lngFile_mods
		sLngXML 		= sLngXML & oStream.readText
		oStream.close
 		'
		'--- load plugin language file
		oStream.open
		oStream.loadFromFile lngPlugin
		sLngXML 		= sLngXML & oStream.readText
		oStream.close
		set oStream 	= nothing
		'
		'--- clean (redundant) header tags
		set oRegEx 		= New Regexp
		oRegEx.ignoreCase = true
		oRegEx.global 	= true
		oRegEx.pattern 	= "(<\?xml(.|\n)+?>)|(<lang>)|(</lang>)"
		sLngXML 		= oRegEx.replace(sLngXML,"")
		set oRegEx 		= nothing
		'
		'--- add header tags again to pass XML parser validation
		sLngXML = "<?xml version=""1.0"" encoding=""utf-8""?><lang>" & sLngXML & "</lang>"
        '
		cor.butil.updCache "LanguageCache_"&lang, sLngXML, "lang"
		call cor.obj.init("lngxml")
		'
		cor.obj.lngxml.validateOnParse 	= false
		cor.obj.lngxml.resolveExternals 	= false
		cor.obj.lngxml.preserveWhiteSpace 	= true
		'
		cor.obj.lngxml.async = false
		if  cor_cUseLangCache Then
			cor.obj.lngxml.loadXML(cor.butil.getCache("LanguageCache_"&lang))
		else
			cor.obj.lngxml.loadXML(sLngXML)
		end if
		'
	end sub

	public sub includeSection(byval sectionName)
		dim objNodes, objNode, intNodes, aSectionNames, i
		'
		if cor.butil.isEmptyStr(sectionName) Then exit sub
		'--- normalize and split
		sectionName   = replace(sectionName, " ", "")
		aSectionNames = split(sectionName, ",")
		'--- include sections
		for i=0 to ubound(aSectionNames)
			'--- do not include a section twice
            'response.write aSectionNames(i) & "<br />"
			if  aSectionNames(i) <> "" AND NOT cor.butil.varExist(aSectionNames(i)) Then
				executeGlobal aSectionNames(i) & "= true"
				'
				set objNodes = cor.obj.lngxml.selectNodes("/lang/s[@n='"& aSectionNames(i) &"']/*")
				On error resume next
				for intNodes = 0 to objNodes.Length-1
					set objNode = objNodes.nextNode()
					if  cor.butil.varExist(objNode.Attributes(0).Text) then
						cor.stopper("[ERR:class_languageParser] variable """ & objNode.Attributes(0).Text & """ already declared. Please check language file")
					end if
					executeGlobal objNode.Attributes(0).Text & "=""" & replace(objNode.Text, """", """""") & """"
					if err.number <> 0 then cor.stopper("[ERR:class_languageParser.asp] " & objNode.Attributes(0).Text & "=""" & objNode.Text & """")
				next
				'On error goto 0
			end if
		next
	end sub

	public sub includeSectionForced(byval sectionName, byval language)
		dim objNodes, objNode, intNodes, aSectionNames, i
		'
		if cor.butil.isEmptyStr(sectionName) Then exit sub
		'--- normalize and split
		sectionName   = replace(sectionName, " ", "")
		aSectionNames = split(sectionName, ",")
		'---
		start(language)
		'--- include sections
		for i=0 to ubound(aSectionNames)
			executeGlobal aSectionNames(i) & "= true"
			'
			set objNodes = cor.obj.lngxml.selectNodes("/lang/s[@n='"& aSectionNames(i) &"']/*")
			On error resume next
			for intNodes = 0 to objNodes.Length-1
				set objNode = objNodes.nextNode()
				executeGlobal objNode.Attributes(0).Text & "=""" & replace(objNode.Text, """", """""") & """"
				if err.number <> 0 then cor.stopper("[ERR:class_languageParser.asp] " & objNode.Attributes(0).Text & "=""" & objNode.Text & """")
			next
			On error goto 0
		next
	end sub

	public function getKey(byval sectionName, byval keyName)
		dim objNodes, objNode, intNodes
		'
		set objNodes = cor.obj.lngxml.selectNodes("/lang/s[@n='"& sectionName &"']/l[@n='"& keyName &"']")
		for intNodes = 0 to objNodes.Length-1
			set objNode = objNodes.nextNode()
			getKey = objNode.Text
		next
	end function

end class

'<#late-binding hook
function boot_class_langParser : boot_class_langParser = true : end function
'/>

%>
