﻿<%
'-----------------------------------------------------------------------------------------------------------------------------------
' SOOP 2.0 - Phoenix (TNG)
'
' Revision 2.00 - initial 15/02/2008
'
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'------------------------------------------------------------------------------------------------------------------------------------
%>
<%
class class_login ':: global, class_baseUtils, class_DAL, class_io, class_filters, class_menu_acc, class_menu_phh, class_stats, class_utils
	'
	'-------------------------------------------------------------------------------------------------------------------------------
	'
	' Attributes
	'
	'-------------------------------------------------------------------------------------------------------------------------
	public  io_login
	Public  io_lang
	Public  io_skin
	Public  io_url
	Public  io_qli
	'
	public  io_muser
	public  io_mpass
	public  io_mautologin
	public  io_mshowactive
	'
	Public  eMsg
	Public  iMsg 
	'
	public  util				' Utility obj 
	public  iBuildListEvery		' (minutes) time lapse before rebuilding the Members Online list from DB
	public  iMemberIsActive		' (minutes) determines the lapse of the last page load during which a member is still considered active
	'
	private aParam
	private sMsg
	private p_sql
	private sURL
	private sQS
	'
	'
	'----------------------------------------------------------------------------------------------------------------------------
	'
	' Init class: get I/O params and set startup internal environment
	'
	' As this is a boot-level class, always fired during core init, 
	' we need the eventIn entry point at init_io, not the controller, as is usual
	'
	'----------------------------------------------------------------------------------------------------------------------
	private sub class_initialize
		set util = new class_login_utils
		iBuildListEvery = 5		'minutes
		iMemberIsActive = 15	'minutes
		sURL			= request.serverVariables("URL")
		sQS				= replace(request.serverVariables("QUERY_STRING"),"&","&amp;",1,-1,1)
	end sub
	'
	public Sub init_io(eventIn)
		'
		io_login		= cor.filter.checkInt(eventIn)
		io_lang			= cor.io.q("lang")
		io_skin			= cor.io.q("skin")
		io_url			= iif(len(sQS)>1, sURL&"?"&sQS, sURL)
		'
		if cor_bPostback AND io_login > 0 Then
			'
			'--- member login
			io_muser		= cor.io.f("muser")
			io_mpass		= cor.io.f("mpass")
			io_mautologin	= cor.filter.checkInt(cor.io.f("mautologin"))
			io_mshowactive	= cor.filter.checkInt(cor.io.f("mshowactive"))
			io_qli			= cor.filter.checkInt(cor.io.f("qli"))
			'
		ElseIf cor.filter.checkStr(request.cookies(cor_sCookieName&"login")("muser")) <> "" Then
			'
			'--- member is returning back
			io_muser		= cor.filter.decrypt(request.cookies(cor_sCookieName&"login")("muser"))
			io_mpass		= request.cookies(cor_sCookieName&"login")("mpass")
			io_mautologin	= cor.filter.checkInt(request.cookies(cor_sCookieName&"login")("mautologin"))
			io_mshowactive	= cor.filter.checkInt(request.cookies(cor_sCookieName&"login")("mshowactive"))
		end if
		'
		' Global pre-conditions
		'
		'--- set visitor's skin and language preferences
		doSetMySkin(io_skin)
		doSetMyLanguage(io_lang)
		'
		'--- set common language section for all pages
		cor.lng.includeSection("cor_xmlCore")
	end sub
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	'
	' Event Process (map inbound events to activities)
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	public sub controller()
			'
		select case io_login
			'
		Case cor_cLoginCheck, cor_cLogin
		eMsg = ""
		cor.str.wri "<script type=""text/javascript"">$('label[class^=errorfrm error]').remove();</script>"
		cor.str.wri "<script type=""text/javascript"">$('input[type=""text""]').removeClass('errorfrm');</script>"
			if io_login = cor_cLoginCheck Then
				If io_qli = 1 Then
					If not cor.butil.checkSecurityCode(cor.io.f("securityCodeq"), cor.io.f("sessionName")) Then
						'cor.redirm lngSecurityFailed, cor.butil.stripq(io_url, "lg="&cor_cLogin)
						eMsg = eMsg & "<script type=""text/javascript"">$('#securityCodeq').addClass('errorfrm');</script>"
						iMsg = iMsg & lngSecurityFailed2 & "<br />"
						cor.str.wri "<script type=""text/javascript"">$('a.secureImg').click();</script>"
					End If
				Else
					If not cor.butil.checkSecurityCode(cor.io.f("securityCode"), cor.io.f("sessionName")) then
					'cor.redirm lngSecurityFailed, cor.butil.stripq(io_url, "lg="&cor_cLogin)
					eMsg = eMsg & "<script type=""text/javascript"">$('<label class=""errorfrm error"">" & lngSecurityFailed2 & "</label>').insertAfter('#securityCode');</script>"
					cor.str.wri "<script type=""text/javascript"">$('a.secureImg').click();</script>"
					End If
				End If
			end If
			If io_qli = 1 Then
				If io_muser = "" or isnull(io_muser) Then 
					eMsg = eMsg & "<script type=""text/javascript"">$('#wu_muser').addClass('errorfrm');</script>"
					iMsg = iMsg & lngNameErr & "<br />"
				End If
				If io_mpass = "" Or IsNull(io_mpass) Then 
					eMsg = eMsg & "<script type=""text/javascript"">$('#wu_mpass').addClass('errorfrm');</script>"
					iMsg = iMsg & lngPassErr & "<br />"
				End If
			Else
				If io_muser = "" or isnull(io_muser) 	Then eMsg = eMsg & "<script type=""text/javascript"">$('<label class=""errorfrm error"">" & lngNameErr & "</label>').insertAfter('#muser');</script>"
				If io_mpass = "" Or IsNull(io_mpass) 	Then eMsg = eMsg & "<script type=""text/javascript"">$('<label class=""errorfrm error"">" & lngPassErr & "</label>').insertAfter('#mpass');</script>"
			End If
			'
			'--- login is a POST event only, return back to context 
			if NOT cor_bPostback Then cor.redir io_url
			'
			cor.butil.checkNotVoid("[cor.login:cor_cLogin], io_muser, io_mpass")
			sMsg = doLogin()
			'
			If eMsg <> "" Then
				cor.str.wri eMsg
				Call cor.butil.errorMsg(lngFormNotSubmitted,lngSystemMessage,True,3000,False,"",0,False)
				if io_qli = 1 Then Call cor.butil.errorMsg(iMsg,lngSystemMessage,False,0,False,"",0,False)
				doLogout()
				Response.end
			Else
			'--- strip off event tag from page context URL, to avoid reentering it back in an endless loop
				If InStr(io_url, "member_login.asp")>0 Then
					Call cor.butil.successMsg(lngLogInOk,lngSystemMessage,True,3000,True,cor_sWebRoot,4000,False)
				Else
					Call cor.butil.successMsg(lngLogInOk,lngSystemMessage,True,3000,True,cor.butil.stripq(io_url, "lg="&cor_cLogin),4000,False)
				End If
			Response.end
			End If
			'cor.redirm sMsg, cor.butil.stripq(io_url, "lg="&cor_cLogin)
		case cor_cLogout
			'
			doLogout()
			'
			'--- strip off event tag from page context URL, to avoid reentering it back in an endless loop
			cor.redirm lngLogOutOk, cor.butil.stripq(io_url, "lg="&cor_cLogout)
			'
		case else ' just a browsing visitor
			'
			'--- perform some special settings for logged members only
			if io_muser <> "" AND io_mpass <> "" Then 
				sMsg = doSetMember()
				if sMsg <> "" Then cor.msg(sMsg)
			end if
			'--- update menus if visitor is changing their preferred language
			if io_lang <> "" then cor.util.updateMenus()
			'
		end Select
	end sub
	'
	'---------------------------------------------------------------------------------------------------------------------------------
	' Activities (atomical)
	'--------------------------------------------------------------------------------------------------------------------------------
	private function doLogin()
		if NOT cor_bPostBack Then exit function
		dim mpassEnc, mpassRaven
		dim arrLogin
		'
		'----------------0------1--------2-------------3-------------4----------------5-------------6--------------7----------8--------------9----------
		p_sql = "SELECT m.MemberID, m.mpass, m.mpassraven, m.msaltraven, m.mmigratedpass, m.mautologin, m.mshowactive, m.mactive, m.mbanned, mlastlogin FROM " & cor_dbpre & "members AS m WHERE m.muser={0}"
		cor.dal.open arrLogin, p_sql, array(io_muser)
		if cor.butil.eof(arrLogin) Then 
			If io_qli = 1 Then
				If io_muser <> "" Then 
					eMsg = eMsg & "<script type=""text/javascript"">$('#wu_muser').addClass('errorfrm');</script>"
					iMsg = iMsg & lngInvalidUsername2 & "<br />"
				End If
			Else
				If io_muser <> "" Then eMsg = eMsg & "<script type=""text/javascript"">$('<label class=""errorfrm error"">" & lngInvalidUsername2  & "</label>').insertAfter('#muser');</script>"
			End If
			doLogout()
			Exit Function
		End If
		'
		'---if user inactive do not continue
		if cor.filter.checkInt(arrLogin(7,0)) = 0 Then 'eMsg = lngMemberInactive : doLogout() : exit Function
			Call cor.butil.errorMsg(lngMemberInactive,lngSystemMessage,True,3000,True,cor_sWebRoot & "member_form.asp?do=3",4000,False)
			doLogout()
			Response.end
		End If
		'---if user banned do not continue
		if cor.filter.checkInt(arrLogin(8,0)) > 0 Then 'eMsg = lngMemberIsBanned : doLogout() : exit function
			Call cor.butil.errorMsg(lngMemberIsBanned,lngSystemMessage,True,3000,True,cor_sWebRoot,4000,False)
			doLogout()
			Response.end
		End If
		' 
		' seamless migration of SooP 1.x account to SooP 2.0 Phoenix
		'
		if cor.filter.checkInt(arrLogin(4,0)) = 1 Then ' already migrated
			'
			'--- check entered password against phoenix encrypted one in DB
			mpassEnc = cor.sha.enc256(io_mpass)
			if mpassEnc <> arrLogin(1,0) Then 'doLogin = lngInvalidPassword : doLogout() : exit function
				If io_qli = 1 Then
					eMsg = eMsg & "<script type=""text/javascript"">$('#wu_mpass').addClass('errorfrm');</script>"
					iMsg = iMsg & lngInvalidPassword & "<br />"
				Else
					eMsg = eMsg & "<script type=""text/javascript"">$('<label class=""errorfrm error"">" & lngInvalidPassword  & "</label>').insertAfter('#mpass');</script>"
				End If
			doLogout()
			Exit Function
		End If
			'
		else' old account still uses SooP 1.x encryption, but we only need to do this once per account
			'
			'--- dynload SooP 1.x encryption lib only when needed, avoiding a bulky page #include
			call cor.util.loadFile( "class_hash1way.asp", "core/classes/" )
			dim hash : set hash = new class_hash1way
			'
			'--- check entered password against SooP 1.x encrypted one in DB
			mpassRaven = lcase(trim(mid(io_mpass, 1, 15)))
			if hash.encode(mpassRaven & arrLogin(3,0)) <> arrLogin(2,0) Then doLogin = lngInvalidPasswordRaven : doLogout() : exit function
			'
			mpassEnc = cor.sha.enc256(io_mpass)
			'
			'--- save entered password encrypted into the SooP 2.0 field and set migration marker field as done
			p_sql = "UPDATE " & cor_dbpre & "members SET mpass={0}, mmigratedpass={1}, mpassraven={2}, msaltraven={3} WHERE muser={4}"
			cor.dal.exec p_sql, array(mpassEnc, 1, "", "", io_muser)
		end if
		'
		'--- delete entry for our guest in activeusers since he/she has already logged in (shall insert for member later)
		p_sql = "UPDATE " & cor_dbpre & "activeusers SET alastrequest={0} WHERE amid={1}"
		cor.dal.exec p_sql, array(cor.butil.cvUxTime(dateAdd("n", -iMemberIsActive, now)), clng(session.sessionID))
		'
		'--- set when member last logged in, and also set if autologin or do not report in activelist have been checked
		p_sql = "UPDATE " & cor_dbpre & "members SET mlastlogin={0}, mautologin={1}, mshowactive={2} WHERE MemberID={3}"
		cor.dal.exec p_sql, array(cor.butil.cvUxTime(now()), io_mautologin, io_mshowactive, arrLogin(0,0))
		'
		'--- set a cookie if member autologin or show in active list is enabled
		if cor.filter.checkint(arrLogin(5,0)) > 0 OR cor.filter.checkint(arrLogin(6,0)) > 0 then
			'--- use simple encryption to encode potentially invalid symbols to serialize
			cor.butil.saveCookieAr "login", "muser",		cor.filter.encrypt((arrLogin(0,0)))
			cor.butil.saveCookieAr "login", "mpass",		mpassEnc
			cor.butil.saveCookieAr "login", "mautologin",	arrLogin(5,0)
			cor.butil.saveCookieAr "login", "mshowactive",	arrLogin(6,0)
		end if
	end function
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	'
	'
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	private sub doLogout()
		' 
		'--- update the member not longer active
		if cor_lUserID <> 2 then
			p_sql = "UPDATE " & cor_dbpre & "activeusers SET alastrequest={0} WHERE amid={1}"
			cor.dal.exec p_sql, array( cor.butil.cvUxTime(dateAdd("n", -iMemberIsActive, now)), cor_lUserID )
		end if
		cor.butil.delCookie(cor_sCookieName&"login")
	end sub
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	'
	'
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	private function doSetMember()
		dim arrMember
		'
		'----------------0-----------1--------2--------3------------4--------5-----------6-------7-------------8------------9--------------10--------11---------12---------13---------
		p_sql = "SELECT m.MemberID, m.mskin, m.muser, m.mlanguage, m.mpass, m.mshowsig, m.mgid, m.mlastlogin, m.mtimezone, m.mricheditor, m.mmail,  m.mactive, m.mbanned, m.mnoofposts FROM " & cor_dbpre & "members AS m WHERE (m.MemberID = {0}) AND m.mpass = {1}"
		cor.dal.open arrMember, p_sql, array(io_muser, io_mpass)
		'
		'--- user seems to have changed password. Reset as guest
		if cor.butil.eof(arrMember) Then doSetMember = lngStoredPassNotMatch  : doLogout() : exit function
		'
		'--- unauthorized (inactive or banned)
		if cor.filter.checkInt(arrMember(11,0)) =0 Then doSetMember = lngMemberInactive	 : doLogout() : exit function
		if cor.filter.checkInt(arrMember(12,0))<>0 Then doSetMember = lngMemberIsBanned		 : doLogout() : exit function
		'
		' set member defaults
		'
		cor_sLoggedInUsername	= arrMember(2,0)
		cor_lUserID				= cor.filter.checkLng(arrMember(0,0)) : if cor_lUserID  = 0 Then cor_lUserID  = 2
		cor_iGroupID			= cor.filter.checkInt(arrMember(6,0)) : if cor_iGroupID = 0 Then cor_iGroupID = 2 ' as a security precaution
		cor_dLastLogin			= arrMember(7,0)
		cor_dTimeZone			= cor.filter.checkInt(arrMember(8,0))
		cor_bUseRichEditor		= iif(cor.filter.checkInt(arrMember(9,0)) > 0, true, false)
		cor_sLoggedInUserEmail	= arrMember(10,0)
		cor_dLastVisit			= arrMember(7,0)
		'
		if cor.perm.isAdmin() Then
			cor_bAdmin		= true
			cor_bModerator	= true
		elseif cor.perm.isModerator() Then 
			cor_bModerator = true
		end if
		if cor_iGroupID <> 2 Then cor_bGuest = false
		if cor_lUserID  <> 2 Then cor_bMember = true
		'
		'--- check if user group needs to be altered per post count
		'
		if not cor_bAdmin and not cor_bGuest then
			call doCheckLadder(cor_lUserID,cor_iGroupID,cor.filter.checkInt(arrMember(13,0)))
		end if
		'
		'--- store if member has changed preferred skin
		if arrMember(1,0) <> cor_sSkin Then
			cor.dal.exec "UPDATE " & cor_dbpre & "members SET mskin={0} WHERE MemberID={1}", array(cor_sSkin, arrMember(0,0))
		end if
		'
		'--- store if member has changed preferred language
		if arrMember(3,0) <> cor_sLanguage  Then
			cor.dal.exec "UPDATE " & cor_dbpre & "members SET mlanguage={0} WHERE MemberID={1}", array(cor_sLanguage, arrMember(0,0))
		end if
	end function
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	'
	'
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	private sub doSetMySkin(byVal sSkin)
		'
		call cor.obj.init("fso")
		'--- try from passed param (usually IO)
		if sSkin <> "" then			'we already have skin set.
			cor.butil.saveCookieAr "", "mskin", sSkin
		elseif request.cookies(cor_sCookieName)("mskin") <> "" then		'get skin from cookie
				sSkin 			= request.cookies(cor_sCookieName)("mskin")
				if NOT cor.obj.fso.fileExists(server.mapPath(cor_sWebroot  & "skins/" & sSkin & "/" & sSkin & ".css")) Then
					'if the users' cookie references a non-existent skin, drop to default skin.
					sSkin 			= cor.cfg("DefaultSkin")
				end if
'			end if
		else						'pick up the default skin for the site
			sSkin 			= cor.cfg("DefaultSkin")
		end if
		if sSkin <> "" Then		'do we have a skin selected?
			'Does the skin css file actually exist?
			if NOT cor.obj.fso.fileExists(server.mapPath(cor_sWebroot  & "skins/" & sSkin & "/" & sSkin & ".css")) Then
				' sSkin not assigned, oozing flesh with nothing to hold it in.  Kinda gross, so we stop here!
				sSkin = "" 		'Guess not
				cor.butil.delCookie("mskin")
				cor.stopper "[ERR:class_login] Default skin not found. Check your configuration"		
			end if
		end if
		if sSkin <> request.cookies(cor_sCookieName)("mskin") then 	cor.butil.saveCookieAr"", "mskin", sSkin
		cor_sSkin		= sSkin
		cor_sSkinPath	= cor_sWebroot & "skins/"  & cor_sSkin & "/"
		cor_sSkinImg	= cor_sWebroot & "skins/"  & cor_sSkin & "/img/"
		cor_sSkinCss	= cor_sSkinPath & cor_sSkin & ".css"
	end sub
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	'
	'
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	private sub doSetMyLanguage(byVal sLanguage)
		'
		'--- try from passed param (usually IO)
		if sLanguage <> "" Then
			if cor.lng.start(sLanguage) Then
				cor_sLanguage = sLanguage
				cor.butil.saveCookieAr "", "mlanguage", cor_sLanguage
				exit sub
			end if
		end if
		'
		'--- try from cookie
		sLanguage = request.cookies(cor_sCookieName)("mlanguage")
		if sLanguage <> "" Then
			if cor.lng.start(sLanguage) Then
				cor_sLanguage = sLanguage
				exit sub
			end if
		end if
		'
		'--- defaults
		sLanguage = cor_sDefaultLang
		if cor.lng.start(sLanguage) Then
			cor_sLanguage = sLanguage
			cor.butil.saveCookieAr "", "mlanguage", cor_sLanguage
		else
			cor.stopper "[ERR:class_login] Default language not found. Check your configuration"
		end if
	end sub
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	'
	' check the current user group to see if the user needs to be eleveated by their post count
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	private function doCheckLadder(luser,lgroup,lposts)
		if cor_bAdmin then exit function
		dim arrGroups, g_i, g_sql, g_check, g_newgid
		'
		' check if user is in a none ladder group
		g_check = cor.dal.getvalue("SELECT g.gnonladder FROM " & cor_dbpre & "groups AS g WHERE g.gid = {0}",array(lgroup))
		If cor.filter.checkInt(g_check) = 1 then exit function
		'
		g_sql = "SELECT g.gid FROM " & cor_dbpre & "groups AS g WHERE g.gminimum <= {0} And g.gnonladder = {1} ORDER BY g.gminimum DESC"
		cor.dal.getRows arrGroups, 1, g_sql, array(lposts,0)
		if not cor.butil.eof(arrGroups) then g_newgid = cor.filter.checkInt(arrGroups(0,0))
		'
		if isEmpty(g_newgid) or isnull(g_newgid) then exit function
		'cor.str.wri "New Gid:" & g_newgid & "<br />Old Gid:" & lgroup & "<br />Posts:" & lposts
		if g_newgid <> lgroup then
			cor.dal.exec "UPDATE " & cor_dbpre & "members SET mgid={0} WHERE MemberID={1}", array(g_newgid, luser)		
		end if
	end function
	'
end class
'
'-------------------------------------------------------------------------------------------------------------------------
'
' Utility class 
'
'-------------------------------------------------------------------------------------------------------------------------
class class_login_utils
	'
	' build of horizontal/vertical menus (if any enabled from configuration) 
	' (yep, uses 1 db call per menu, but for the sake of clarity)
	'
	public function buildMenuH(bEnableHorizMenu)
		dim amid, atype, arrMenu
		'
		if NOT bEnableHorizMenu then exit function
		'
		amid = iif(cor_bMember, cor_lUserID, clng(session.sessionID))
		atype = iif(cor_bMember, 1, 0)
		p_sql = "SELECT au.amenuH FROM " & cor_dbpre & "activeusers AS au WHERE au.amid={0} AND au.atype={1}"
		cor.dal.open arrMenu, p_sql, array(amid, atype)
		if cor.butil.eof(arrMenu) Then
			buildMenuH = cor.menuphh.buildMenu()
		else
			buildMenuH  = arrMenu(0,0)
			cor_bCached = true
		end if
	end function
	'
'	public function buildMenuV(bEnableVertMenu)
'		dim amid, atype, arrMenu
'		'
'		if NOT bEnableVertMenu then exit function
'		'
'		amid  = iif(cor_bMember, cor_lUserID, clng(session.sessionID))
'		atype = iif(cor_bMember, 1, 0)
'		p_sql = "SELECT au.amenuV FROM " & cor_dbpre & "activeusers AS au WHERE au.amid={0} AND au.atype={1}"
'		cor.dal.open arrMenu, p_sql, array(amid, atype)
'		if cor.butil.eof(arrMenu) Then
'			buildMenuV  = cor.menuacc.buildMenu()
'		else
'			buildMenuV  = arrMenu(0,0)
'			cor_bCached = true
'		end if
'	end Function
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	'
	' build activeusers related lists
	'
	'------------------------------------------------------------------------------------------------------------------------------
	public function buildActiveMembersList()
		dim amid, atype, ashow
		dim arrActiveUsers, bIsDue
		dim strActiveMembersList
		dim strUrl, arrIgnore
		'
		' set a system timer that dues on the chosen lapse for all users 
		' (but only if cor_cUseSysCache is enabled, otherwise always the query is performed)
		if cor_cUseSysCache Then
			if (minute(now) mod cor.login.iBuildListEvery) = 0 then bIsDue = true
		Else
			bIsDue = True
		end if
		'
		'--- Cleansing of activeUsers table from old entries
		if bIsDue Then
			p_sql = "DELETE FROM " & cor_dbpre & "activeusers WHERE alastrequest < {0}" 
			cor.dal.exec p_sql, array(cor.butil.cvUxTime(dateAdd("n", -cor.login.iMemberIsActive, now)))
		end if
		'
		' Insert or update an active user (member or guest) on each page load
		'
		amid   = iif(cor_bMember, cor_lUserID, clng(session.sessionID))
		atype  = iif(cor_bMember, 1, 0)
		ashow  = iif(cor_bMember, cor.filter.checkInt(request.cookies(cor_sCookieName&"login")("mshowactive")), 1) 
		'strUrl = cor_sServerProtocol & request.serverVariables("HTTP_HOST") & iif(request.serverVariables("QUERY_STRING")<>"", "?" & request.serverVariables("QUERY_STRING"), "")
		'
		strUrl = cor_sServerProtocol & cor_sServerName & cor_sScriptName & iif(request.serverVariables("QUERY_STRING")<>"", "?" & request.serverVariables("QUERY_STRING"), "")
		'
		p_sql = "SELECT au.amid FROM " & cor_dbpre & "activeusers AS au WHERE au.amid={0} AND au.atype={1}"
		cor.dal.open arrActiveUsers, p_sql, array(amid, atype)
		if cor.butil.eof(arrActiveUsers) Then
			If Not ignoreCheck(cor_sScriptName) Then
			p_sql = "INSERT INTO "  & cor_dbpre & "activeusers (amid, atype, alastrequest, aurl, aip, ashow, amenuH, amenuV) VALUES ({0},{1},{2},{3},{4},{5},{6},{7})"
			cor.dal.exec p_sql, array(amid, atype, cor.butil.cvUxTime(now), strUrl, request.serverVariables("REMOTE_ADDR"), ashow, cor_sMenuH, cor_sMenuV)
			End If
			p_sql = "UPDATE " & cor_dbpre & "members SET mlastactive={0} WHERE MemberID={1}"
			cor.dal.exec p_sql, array(cor.butil.cvUxTime(now), amid)
		else'
			If Not ignoreCheck(cor_sScriptName) Then
			'--- Just update what may have changed until the record would be still valid
			p_sql = "UPDATE "		& cor_dbpre & "activeusers SET alastrequest={0}, aurl={1}, aip={2}, ashow={3} WHERE amid={4}"
			cor.dal.exec p_sql, array(cor.butil.cvUxTime(now), strUrl, request.serverVariables("REMOTE_ADDR"), ashow, amid)
			End If
			p_sql = "UPDATE " & cor_dbpre & "members SET mlastactive={0} WHERE MemberID={1}"
			cor.dal.exec p_sql, array(cor.butil.cvUxTime(now), amid)
		end If
		'
		' Scheduled fetch of active members (not guests, not hide) list and build of a string with them
		' (mind that on application start there shall be no members displayed until the first lapse overdues) 
		'
		if bIsDue Then
			p_sql = "SELECT m.MemberID, m.muser FROM " & cor_dbpre & "activeusers AS au INNER JOIN " & cor_dbpre & "members AS m ON au.amid=m.MemberID WHERE au.atype={0} AND au.alastrequest > {1} AND m.mshowactive={2}" 
			cor.dal.open arrActiveUsers, p_sql, array(1, cor.butil.cvUxTime(dateAdd("n", -cor.login.iMemberIsActive, now)), 1)
			if NOT cor.butil.eof(arrActiveUsers) Then
				strActiveMembersList = cor.butil.serialRows(arrActiveUsers)
				cor.butil.updCache "ActiveMembersList", strActiveMembersList, "sys"
			end if
		else
			strActiveMembersList = cor.butil.getCache("ActiveMembersList")
		end if
		'
		buildActiveMembersList = strActiveMembersList
	end Function
	'
	'------------------------------------------------------------------------------------------------------------------------------
	'
	' function to check if the current scriptname is in the active users ignore list
	'
	'-----------------------------------------------------------------------------------------------------------------------------
	Public Function ignoreCheck(sScriptname)
		Dim i
		Dim arrIg
		Dim sn
		sn = lcase(sScriptname)
		If Not cor.butil.isEmptyStr(cor.cfg.item("activeIgnore")) Then
		arrIg = Split(trim(cor.cfg.item("activeIgnore")),",")
			For i = 0 To ubound(Split(cor.cfg("activeIgnore"),","))
				If inStr(sn,lcase(arrIg(i))) > 0 Then
					ignoreCheck = True
					Exit Function
				End If
			Next
			ignoreCheck = False
		Else
			ignoreCheck = False
		End If
	 End Function
	'
	Private p_sql
end Class
'
'<#late-binding hook
function boot_class_login : boot_class_login = true : end function
'/>

%>
