﻿<%
'------------------------------------------------------------------------------------------------------------------------------------------
' SOOP 2.0 - Phoenix (TNG)
'
'Revision 2.0001 - initial 13/04/2008
'
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'------------------------------------------------------------------------------------------------------------------------------------------

'
' The 'dual-IO' concept of this Controller class:
'
' There's a single function [doMemberIOdata] that handles internal IO variables
' coming from GET/POST requests AND from db calls, to cover the following scenarios at once:
'
' - Calling doMemberIOdata before any form init, populates io_* variables with data of DB
' - Calling doMemberIOdata after postback, io_* variables get populated from POST variables;
' however, remaining IO variables not initialized during POST are filled by their stored in the DB values instead.
'
' This way calling doMemberIOdata shall always return an up-to-date pool of io_* variables for further manipulation.
'
class class_members ':: global, class_baseUtils, class_filters, class_dal, class_io, class_configHandler,
	'					class_sha256, class_utils, class_sendmail
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	' Attributes
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	public  sCurrentPass
	public  sNewPass
	public  sNewPass2
	Public  sSecurityCode
	Public  sessionName
	public  iMailsent
	'
	public  bCaptcha
	'
	public  io_mid
	public  io_muser
	public  io_mpass
	public  io_mpassraven
	public  io_msaltraven
	public  io_mactive
	public  io_mactivatecode
	public  io_mname
	public  io_mmail
	public  io_mgid
	public  io_mskin
	public  io_mlanguage
	public  io_mlocation
	public  io_mlocationname
	public  io_mlocationdomain
	public  io_mtitle
	public  io_mdateofbirth
	public  io_msign
	public  io_mreggad
	public  io_mtimezone
	public  io_mavatar
	public  io_mgender
	public  io_mhomepage
	public  io_mmsn
	public  io_micq
	public  io_myahoo
	public  io_maim
	public  io_mmigratedpass
	public  io_mshowactive
	public  io_mbanned
	public  io_mwarnings
	public  io_mshowmail
	public  io_mautologin
	public  io_mshowsig
	public  io_mricheditor
	public  io_mhtmlemail
	public  io_mpmnotify
	public  io_mreplynotify
	public  io_mnoofposts
	private io_mlastlogin
	'
	public  io_mgname
	'
	public  html			' HTML widgets obj
	'
	private arrActivity
	private p_sql
	private p_activatecode
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	' Init class: get I/O params and set startup internal environment
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	private sub class_initialize
		set html = new class_members_html
		bCaptcha = true
	end sub
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	'
	'
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	private sub class_terminate
		set html = nothing
	end sub
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	'
	'
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	public sub init_io()
		'
		if NOT cor_bPostback Then
			'
			io_mid				= cor.filter.checkLng(cor.io.q("mid"))
			io_mactivatecode	= cor.io.q("ac")
			'
		else'
			'
			io_mid				= cor.filter.checkLng(cor.io.f("mid"))
			io_mactivatecode	= cor.io.f("mactivatecode")
			'
			sCurrentPass		= cor.io.f("currentpass")
			sNewPass			= cor.io.f("newpass")
			sNewPass2			= cor.io.f("newpass2")
			iMailsent			= cor.filter.checkInt(cor.io.f("mailsent"))
			sSecurityCode		= cor.io.f("securityCode")
			sessionName			= cor.io.f("sessionName")
			'
		end if
		'
	end sub
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	'
	'
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	public sub init_members()
		'
		'--- determine if catcha enabled in cfg
		bCaptcha = iif(cor.filter.checkInt(cor.cfg("register"))>0, true, false)
		'
	end sub
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	' Event Process (map inbound events to activities)
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	public sub controller(byVal eventIn)
		dim iDo : iDo = cor.filter.checkInt(eventIn) : if iDo = 0 Then exit Sub
		'
		if not cor_bPostback then
		Select Case cor_lUserID
			Case 2
				Select Case iDo
					Case cor_cDoMemberNewPass, cor_cDoMemberActivate
						iDo = cor.filter.checkInt(eventIn)
						bAcceptTerms = True
					Case Else
						bAcceptTerms = cor.filter.checkint(cor.io.fq("ter"))
						if bAcceptTerms=0 AND NOT cor_bPostback Then
							bAcceptTerms = false
							intDo = cor_cDoMemberTerms
						elseIf bAcceptTerms=1 AND NOT cor_bPostback Then
							bAcceptTerms = True
							iDo = cor.filter.checkInt(eventIn)
						Else
							bAcceptTerms = False
							iDo = cor_cDoMemberTerms' cor.filter.checkInt(eventIn)
						End If
				End Select
			Case Else
				iDo = cor.filter.checkInt(eventIn)
		End Select
		end if
		'
		select case iDo
		case cor_cDoMemberView
		'cor.str.wri "Do View Member"
			'
			' guests are not allowed to view member's details
			' by default we get data for currently logged member,
			' but members could switch to view others' profile
			'
			if cor_bGuest Then cor.msg(lngNotAuthorized)
			
			if io_mid=0 Then io_mid = cor_lUserID
			'--- populate profile from DB
			if NOT doMemberIOdata(cor_cSelect, cor_cSql, "MemberID", io_mid) Then cor.msg(lngMemberNotFound)
			'
		case cor_cDoMemberNew
		'cor.str.wri "Do New Member"
			'
			if NOT cor_bPostback Then
				'
				' init form
				'
				'--- set some defaults
				io_mgid			= cor.cfg.item("DefaultUserGroup")
				io_mtitle		= cor.cfg.item("DefaultUserTitle")
				io_mskin		= cor.cfg.item("DefaultSkin")
				io_mlanguage	= cor.cfg.item("DefaultLang")
				io_mshowmail	= 1
				io_mhtmlemail	= 1
				io_mautologin	= 1
				io_mshowactive	= 1
				io_mpmnotify	= 1
				io_mreplynotify = 1
				io_mtimezone	= cor.cfg.item("DefaultTimeZone")
			Else
				'
				' post form
				'
				' remove any old validation error messages
				cor.str.wri "<script type=""text/javascript"">$('label[class^=errorfrm error]').remove();</script>"
				'
				' added for server side validation
				Dim strErrmsg : strErrmsg = ""
				'
				'--- populate new member attributes by form postback
				call doMemberIOdata("", cor_cForm, "", "")
				'
				' initiate some cumulative check-ups
				'
				'--- Just in case the JS form validation hasn't stopped invalid forms
				cor.butil.checkNotVoid("[cor.member:cor_cDoMemberNew], io_muser, io_mpass, io_mmail")
				If  len(io_mpass) < cor_cMinPassLen Or len(io_mpass) > cor_cMaxPassLen Then 
					strErrmsg = strErrmsg & "<script type=""text/javascript"">$('<label class=""errorfrm error"">" & lngMemberIncorrectPasswordLength & "</label>').insertAfter('#mpass');</script>"
				Else
					If io_mpass <> cor.io.f("newpass") Then
						strErrmsg = strErrmsg & "<script type=""text/javascript"">$('<label class=""errorfrm error"">" & lngMemberPassMismatch & "</label>').insertAfter('#mpass').insertAfter('#newpass');</script>"
					End If
				End If
				'
				'--- check captcha matching, if feature enabled and NOT an admin doing registrations
				if  bCaptcha AND NOT cor_bAdmin Then
					If Not cor.butil.checkSecurityCode(sSecurityCode, sessionName) Then 
						strErrmsg = strErrmsg & "<script type=""text/javascript"">$('<label class=""errorfrm error"">" & lngMemberSecuritycodeIncorrect & "</label>').insertAfter('#securityCode');</script>"
					end If
				end If
				'
				' check if username or email already exists
				' and username does not contain any kind of SQL injection attempts
				'
				if  cor.filter.checkStrSQL(io_muser) <> io_muser Then
					call cor.audit.writeLogDb(1,"Invalid username registration attempt: " & io_muser)
					strErrmsg = strErrmsg & "<script type=""text/javascript"">$('<label class=""errorfrm error"">" & lngMemberUsernameInvalid & "</label>').insertAfter('#muser');</script>"
				end If
				'
				p_sql = "SELECT COUNT(m.MemberID) FROM " & cor_dbpre & "members AS m WHERE m.muser={0}"
				If cor.filter.checkInt(cor.dal.getValue(p_sql, array(io_muser))) > 0 Then 
					strErrmsg = strErrmsg & "<script type=""text/javascript"">$('<label class=""errorfrm error"">" & lngMemberUsernameExists & "</label>').insertAfter('#muser');</script>"
				End If
				If io_muser = "" Or IsNull(io_muser) Then 
					strErrmsg = strErrmsg & "<script type=""text/javascript"">$('<label class=""errorfrm error"">" & lngMemberUsernameNull & "</label>').insertAfter('#muser');</script>"
				End If
				'
				p_sql = "SELECT COUNT(m.MemberID) FROM " & cor_dbpre & "members AS m WHERE m.mmail={0}"
				If cor.filter.checkInt(cor.dal.getValue(p_sql, array(io_mmail))) > 0 Then 
					strErrmsg = strErrmsg & "<script type=""text/javascript"">$('<label class=""errorfrm error"">" & lngMemberEmailExists & "</label>').insertAfter('#mmail');</script>"
				End If
				If io_mmail = "" Or IsNull(io_mmail) Then 
					strErrmsg = strErrmsg & "<script type=""text/javascript"">$('<label class=""errorfrm error"">" & lngMemberEmailNull & "</label>').insertAfter('#mmail');</script>"
				End If
				'
				'
				'--- Set a default group if one not already provided (note: only admins can set different groups in members_mgmt)
				io_mgid	= iif(io_mgid=""   OR NOT cor_bAdmin, cor.cfg.item("DefaultUserGroup"), io_mgid)
				'
				'--- check if default user title has been changed (usually by admin)
				io_mtitle	= iif(io_mtitle="" OR NOT cor_bAdmin, cor.cfg.item("DefaultUserTitle"), io_mtitle)
				'
				'--- ensure a default skin
				io_mskin	= iif(io_mskin="", cor.cfg.item("DefaultSkin"), io_mskin)
				'
				'--- ensure a default language
				io_mlanguage = iif(io_mlanguage="", cor.cfg.item("DefaultLang"), io_mlanguage)
				'
				'--- remember when the user first joined the community
				io_mreggad   = cor.butil.cvUxTime(now())
				'
				'--- normalize date for DB
				io_mdateofbirth	= cor.butil.cvUxTime(io_mdateofbirth)
				'
				' if the above check-ups were successful, create the new membership with posted data and shall show a system message down the page
				'
				if strErrmsg = "" Then
					'
					' set some defaults
					'
					io_mpass		= cor.sha.enc256(io_mpass)
					io_mactive		= 0
					io_mmigratedpass = 1
					io_mbanned		= 0
					io_mwarnings	= 0
					io_mricheditor	= iif(cor_bUseRichEditor, 1, 0)
					io_mnoofposts	= 0
					io_mskin		= iif(cor.butil.isEmptyStr(io_mskin), cor_sSkin, io_mskin)
					io_mlanguage	= iif(cor.butil.isEmptyStr(io_mlanguage), cor_sDefaultLang, io_mlanguage)
					' (MySQL Access fix)
					io_mtimezone	= cor.filter.checkDbl(replace(io_mtimezone, "." ,""))
					io_mtimezone	= cor.filter.checkDbl(replace(io_mtimezone, "," ,""))
					'
					doMemberNew()
					'
					'--- post-processing
					io_mgname		= iif(io_mgname<>"", io_mgname, cor.dal.getValue("SELECT g.gname FROM " & cor_dbpre & "groups AS g WHERE g.gid={0}", array(io_mgid)))
					'
					cor.str.wri "<script type=""text/javascript"">$('html, body').animate({scrollTop:0}, 3000);</script>"
					Call succesMsg(lngMemberNeedActivationMsg,cor_sWebroot)
					Response.End
				Else
					cor.str.wri strErrmsg
					cor.str.wri "<script type=""text/javascript"">$('html, body').animate({scrollTop:0}, 3000);</script>"
					Call errorMsg(lngErrorDisplayLine1)
					Response.End
				end If
				'
			end if
			'
		case cor_cDoMemberActivateAdm
		'cor.str.wri "Do Member Activate Admin"
			'
			strErrmsg = ""
			'--- only admin can activate this way
			if NOT cor_bAdmin Then
			Call errorMsg(lngNotAuthorized)
			Response.end
			End If
			cor.butil.checkNotVoid("[cor.member:cor_cDoMemberActivateAdm], io_mid")
			'
			'---- dual-IO during form init/post and db
			if NOT doMemberIOdata(cor_cSelect, cor_cForm1Sql2, "MemberID", io_mid) Then 
			Call errorMsg(lngMemberInvalidMid)
			Response.end
			end if
			
			'
			if  NOT cor_bPostback Then
				if io_mactive > 0 Then 
				call errorMsg(lngMemberActivatedAlready)
				Response.end
				End If
			else'
				'--- Manual activation checkbox was selected
				if  io_mactive > 0 then
					Call succesMsg(iif(doMemberActivate(""), lngMemberActivatedByAdmin, lngMemberInvalidMid),"mgmt_members.asp")
					Response.end
				else'
					' reissue of an activation code to member by email was chosen
					' (admin might also have edited the registered email in this same step)
					'
					Call succesMsg(doReissueActivationCode(io_mmail),"mgmt_members.asp")
					Response.end
				end if
			end If
			'
		case cor_cDoMemberActivate
		'cor.str.wri "Do Member Activate"
			'
			' membership activation is a bit trickier to streamline because it has varied entry points;
			' we have scoped it to the following expected scenarios:
			' a) the page is hit by direct link (GET) from activation email and gets activated (default)
			' b) new member prefers or needs to activate the account manually (POST):
			' - Manual activation #1. Member enters activation code into the box, hits submit and gets activated
			' - Manual activation #2. If no activation code available, member is required to provide a valid email
			'   (already in DB) and a new activation code gets reissued toward this email.
			' c) nothing to do as the membership was already activated
			'
			'-------------------------------------------------------------------------------------------------
			' direct activation from hyperlink (GET) or
			' manual activation by filled activation code in form (POST)
			'
			if io_mactivatecode <> "" then
				'--- extract direct activation code received
				p_activatecode = extractActivateCodeMid(io_mactivatecode, io_mid)
				'--- if we cannot find an account by activation code alone then such code is invalid
				if NOT doMemberIOdata(cor_cSelect, cor_cSql, "mactivatecode", p_activatecode) Then
					Call errorMsg(lngMemberInvalidActivationCode)
					Response.end
				End If
				'--- member already activated
				if cor.filter.checkInt(io_mactive) > 0 Then 
					Call succesMsg(lngMemberAlreadyActivated,cor_sWebroot)
					Response.end
				End If
				'--- perform activation and redir to clear get params
				Call succesMsg(iif(doMemberActivate(p_activatecode), lngMemberActivatedGreet, lngMemberInvalidActivationCode), cor_sWebroot)
				Response.end
			end If
			'
			'--- alternate email method requested: reissue a new activation code (POST)
			if cor_bPostback Then
				'--- populate attributes from form postback
				call doMemberIOdata("", cor_cForm, "", "")
				'--- check if email exists and send an email to its owner
				If io_mmail<> "" then
					If doMemberIOdata(cor_cSelect, cor_cForm1Sql2, "mmail", io_mmail) Then
						Call succesMsg(doReissueActivationCode(io_mmail),cor_sWebroot)
						Response.end
					else
						Call errorMsg(lngMemberInvalidEmail)
						Response.end
					end if
				end if
			end if
			'
		case cor_cDoMemberUpdate
		'cor.str.wri "Do Member Update"
			'
			' init form
			'
			if cor_bGuest then cor.msg(lngNotAuthorized)
			'
			if NOT cor_bPostback Then

				'
				'--- Admin updates member or self
				if  io_mid <> cor_lUserID AND cor_bAdmin Then
					if NOT doMemberIOdata(cor_cSelect, cor_cSql, "MemberID", io_mid) Then cor.msg(lngMemberNotFound)
				else'
					'--- Member updates self
					if NOT doMemberIOdata(cor_cSelect, cor_cSql, "MemberID", cor_lUserID) Then cor.msg(lngMemberNotFound)
				end if
				'
			else'
				' post form
				'
				'-- remove any old validation error messages
				cor.str.wri "<script type=""text/javascript"">$('label[class^=errorfrm error]').remove();</script>"
				'
				'-- added for server side validation
				strErrmsg = ""
				'
				'--- get updated form data and remaining prepopulated from DB - 4
				if NOT doMemberIOdata(cor_cSelect, cor_cForm1Sql2, "MemberID", io_mid) Then 
					strErrmsg = strErrmsg & lngMemberNotFound
				End If
				'
				'-- if this is admin, check for a username change and validate against existing usernames
				If cor_bAdmin Then
				p_sql = "SELECT p.muser FROM " & cor_dbpre & "members AS p WHERE p.MemberID = {0}"
					If cor.filter.checkStr(cor.dal.getValue(p_sql, Array(io_mid))) <> io_muser Then
						p_sql = "SELECT COUNT(m.MemberID) FROM " & cor_dbpre & "members AS m WHERE m.muser={0}"
						If cor.filter.checkInt(cor.dal.getValue(p_sql, array(io_muser))) > 0 Then 
							strErrmsg = strErrmsg & "<script type=""text/javascript"">$('<label class=""errorfrm error"">" & lngMemberUsernameExists & "</label>').insertAfter('#muser');</script>"
						End If
						If io_muser = "" Or IsNull(io_muser) Then 
							strErrmsg = strErrmsg & "<script type=""text/javascript"">$('<label class=""errorfrm error"">" & lngMemberUsernameNull & "</label>').insertAfter('#muser');</script>"
						End If
					End If
				End If
				'
				'-- check if email has been changed and validate against existing email addresses
				p_sql = "SELECT m.mmail FROM " & cor_dbpre & "members AS m WHERE m.MemberID = {0}"
				If cor.filter.checkStr(cor.dal.getValue(p_sql, Array(io_mid))) <> io_mmail Then
					p_sql = "SELECT COUNT(m.MemberID) FROM " & cor_dbpre & "members AS m WHERE m.mmail={0}"
					If cor.filter.checkStr(cor.dal.getValue(p_sql, array(io_mmail))) > 0 Then 
						strErrmsg = strErrmsg & "<script type=""text/javascript"">$('<label class=""errorfrm error"">" & lngMemberEmailExists & "</label>').insertAfter('#mmail');</script>"
					End If
					If io_mmail = "" Or IsNull(io_mmail) Then 
						strErrmsg = strErrmsg & "<script type=""text/javascript"">$('<label class=""errorfrm error"">" & lngMemberEmailNull & "</label>').insertAfter('#mmail');</script>"
					End If
				End If
				'
				'--- member may have chosen a new skin
				if  io_mskin <> "" AND lcase(io_mskin) <> lcase(request.cookies(cor_sCookieName)("mskin")) Then
					cor.butil.saveCookieAr "", "mskin", io_mskin
					cor_sSkin	= io_mskin
					cor_sSkinImg = cor_sWebroot & "skins/" & cor_sSkin & "/"
					cor_sSkinCss = cor_sSkinImg & cor_sSkin & ".css"
				end if
				'
				'--- member may have chosen another language
				if  io_mlanguage <> "" AND lcase(io_mlanguage) <> lcase(request.cookies(cor_sCookieName)("mlanguage")) Then
					cor.butil.saveCookieAr "", "mlanguage", io_mlanguage
				end if
				'
				'--- normalize date for DB
				io_mdateofbirth	= cor.butil.cvUxTime(io_mdateofbirth)
				'
				If strErrmsg = "" Then
					doMemberUpdate()
					cor.str.wri "<script type=""text/javascript"">$('html, body').animate({scrollTop:0}, 3000);</script>"
					Call succesMsg("Thank you, your changes have been saved.","")
					Response.End
				Else
					cor.str.wri  strErrmsg
					cor.str.wri "<script type=""text/javascript"">$('html, body').animate({scrollTop:0}, 3000);</script>"
					Call errorMsg(lngErrorDisplayLine1)
					Response.End
				End If
			end if
			'
		case cor_cDoMemberUpdatePass
		'cor.str.wri "Do Member Update Pass"
			'
			' post form
			'
			cor.str.wri "<script type=""text/javascript"">$('label[class^=errorfrm error]').remove();</script>"
			'
			if cor_bGuest Then 
				call errorMsg(lngNotAuthorized)
				cor.redirm "", cor_sWebRoot
				Response.end
			End If
			'
			if NOT cor_bPostback Then exit Sub
			'
			'--- get additional user data
			if NOT doMemberIOdata(cor_cSelect, cor_cForm1Sql2, "MemberID", io_mid) Then
				cor.str.wri "<script type=""text/javascript"">$('html, body').animate({scrollTop:0}, 3000);</script>"
				Call errorMsg(lngMemberNotFound)
				cor.redirm "", cor_sWebRoot
				Response.End
			End If
			'
			'--- Ensure only admin would update other members
			if io_mid <> cor_lUserID AND NOT cor_bAdmin Then
				cor.str.wri "<script type=""text/javascript"">$('html, body').animate({scrollTop:0}, 3000);</script>"
				Call errorMsg(lngAccessDenied)
				cor.redirm "", cor_sWebRoot
				Response.End
			End If
			'
			' Check if old password box confirmation matches the one on DB (Admin doesn't need to go through this)
			' Also recheck both new passwords are the same
			'
			if  cor_bAdmin Then
				if sNewPass <> sNewPass2 Then 
					cor.str.wri "<script type=""text/javascript"">$('html, body').animate({scrollBottom:0}, 3000);</script>"
					cor.str.wri "<script type=""text/javascript"">$('<label class=""errorfrm error"">" & lngMemberPassMismatch & "</label>').insertAfter('#newpass');</script>"
					Response.End
				End If
			else
				if io_mpass <> cor.sha.enc256(sCurrentPass) Then 
					cor.str.wri "<script type=""text/javascript"">$('html, body').animate({scrollBottom:0}, 3000);</script>"
					cor.str.wri "<span class=""errorfrm error"">" & lngMemberConformOldPassNotMatching & "</span>"
					Response.End
				ElseIf sNewPass <> sNewPass2 Then
					cor.str.wri "<script type=""text/javascript"">$('html, body').animate({scrollBottom:0}, 3000);</script>"
					cor.str.wri "<script type=""text/javascript"">$('<label class=""errorfrm error"">" & lngMemberPassMismatch & "</label>').insertAfter('#newpass');</script>"
					Response.End
				End If
			end if
			'
			'--- match successful, set and store new io_mpass
			io_mpass = cor.sha.enc256(sNewPass)
			'
			doMemberUpdatePass()
			'
			'--- reset password if the updated member is himself (i.e. not admin updating other's profile)
			if io_mid = cor_lUserID Then
				if request.cookies(cor_sCookieName&"login")("mpass") <> "" then
					cor.butil.saveCookieAr "login", "mpass", io_mpass
				end if
				'
				' force relogin with the new password and display message via winWrite
				' (also ensure page is loaded outside iframes)
				cor.str.wri "<script type=""text/javascript"">$('html, body').animate({scrollTop:0}, 3000);</script>"
				Call succesMsg(lngMemberUpdated, cor_sWebRoot & "?lg=" & cor_cLogout & "&amp;top=1&amp;emb=0")
				Response.end
			Else
				cor.str.wri "<script type=""text/javascript"">$('html, body').animate({scrollTop:0}, 3000);</script>"
				Call succesMsg(lngMemberUpdated,"")
				Response.end
			end If
			'
		Case cor_cDoMemberNewPass
		'cor.str.wri "Do Member New Pass"
			'
			if  NOT cor_bPostback Then
				'
				'--- displays registered email, etc. if admin mgmt
				if  cor_bAdmin then
					cor.butil.checkNotVoid("[cor.member:cor_cDoMemberNewPass], io_mid")
					if NOT doMemberIOdata(cor_cSelect, cor_cSql, "MemberID", io_mid) Then 
					Call errormsg(lngMemberNotFound)
					Response.end
					End If
				end if
				'
			else'
				' post form
				'
				'--- get form params
				call doMemberIOdata("", cor_cForm, "", "")
				cor.butil.checkNotVoid("[cor.member:cor_cDoMemberNewPass], io_mmail")
				'--- check if such email exists and populate other fields for sending email
				if NOT doMemberIOdata(cor_cSelect, cor_cForm1Sql2, "mmail", io_mmail) Then 
				call errormsg(lngMemberNoMatchingUser)
				Response.end
				End If
				'
				'--- generate a new member's password and send an email
				doMemberNewPass()
				'
				' (may show a SooP msg while redirecting to default view). mid used when accessed by admin mgmt
				Call succesMsg(lngMemberNewPassSent,cor_sWebroot)
				Response.end
			end if
			'
		case cor_cDoMemberWarn
		'cor.str.wri "Do Member Warn"
			'
			'--- only admins can ban/unban
			if NOT cor_bAdmin Then 
				errorMsg(lngNoAccess)
				Response.End
			End If
			cor.butil.checkNotVoid("[cor.member:cor_cDoMemberWarn], io_mid")
			'
			if  NOT cor_bPostback Then
				'--- get some data of user being warned
				if NOT doMemberIOdata(cor_cSelect, cor_cSql, "MemberID", io_mid) Then 
					Call errorMsg(lngMemberNotFound)
					Response.End
				End If
			else
				cor.butil.checkNotVoid("[cor.member:cor_cDoMemberWarn], io_mid")
				'--- get form results data and populate the rest from DB for notification email
				if NOT doMemberIOdata(cor_cSelect, cor_cForm1Sql2, "MemberID", io_mid) Then 
					Call errorMsg(lngMemberNotFound)
					Response.End
				End If
				'--- cannot warn yourself!
				if io_mid = cor_lUserID Then 
					Call errorMsg(lngMemberCannotDoOnSelf)
					Response.End
				End If
				'--- increment the warn counter and notify member
				io_mwarnings = io_mwarnings+1
				doMemberWarn()
				sendMailWarnBan(intDo)
				call succesMsg(lngMemberWarnedMsg, cor_sWebRoot & "mgmt_members.asp")
				Response.end
			end if
			'
		case cor_cDoMemberBan
		'cor.str.wri "Do Member Ban"
			'
			'--- only admins can ban/unban
			if NOT cor_bAdmin then cor.msg(lngNoAccess)
			cor.butil.checkNotVoid("[cor.member:cor_cDoMemberBan], io_mid")
			'
			if  NOT cor_bPostback Then
				'--- get some data of user being banned/unbanned
				if NOT doMemberIOdata(cor_cSelect, cor_cSql, "MemberID", io_mid) Then 
					Call errorMsg(lngMemberNotFound)
					Response.end
				End If
			else
				cor.butil.checkNotVoid("[cor.member:cor_cDoMemberBan], io_mid")
				'--- get form results data and populate the rest from DB for notification email
				if NOT doMemberIOdata(cor_cSelect, cor_cForm1Sql2, "MemberID", io_mid) Then 
					call errorMsg(lngMemberNotFound)
					Response.End
				End If
				'--- cannot ban yourself!
				if io_mbanned > 0 AND io_mid = cor_lUserID Then 
					call errorMsg(lngMemberCannotDoOnSelf)
					Response.End
				End If
				'--- do ban/unban activity
				if io_mbanned = 0 Then
					doMemberBan()
					sendMailWarnBan(intDo)
					call succesMsg(lngMemberBannedMsg,cor_sWebRoot & "mgmt_members.asp")
					Response.end
				end if
			end if
			'
		case cor_cDoMemberUnban
		'cor.str.wri "Do Member Unban"
			'
			'--- only admins can ban/unban
			if NOT cor_bAdmin then cor.msg(lngNoAccess)
			'
			if NOT cor_bPostback Then
				'--- get some data of user being banned/unbanned
				if NOT doMemberIOdata(cor_cSelect, cor_cSql, "MemberID", io_mid) Then 
					call errorMsg(lngMemberNotFound)
					Response.End
				End If
			else
				'--- get form results data and populate the rest from DB for notification email
				cor.butil.checkNotVoid("[cor.member:cor_cDoMemberUnban], io_mid")
				if NOT doMemberIOdata(cor_cSelect, cor_cForm1Sql2, "MemberID", io_mid) Then 
					call errorMsg(lngMemberNotFound)
					Response.End
				End If
				'--- cannot ban yourself!
				if io_mid = cor_lUserID Then 
					call errorMsg(lngMemberCannotDoOnSelf)
					Response.End
				End If
				'--- do ban/unban activity
				if io_mbanned = 1 Then
					call doMemberUnban()
					sendMailWarnBan(intDo)
					call succesMsg(lngMemberUnbannedMsg,cor_sWebRoot & "mgmt_members.asp")
					Response.End
				end if
			end if
			'
		case cor_cDoMemberAddBuddy
		'cor.str.wri "Do Member Add Buddy"
			'
			'--- only logged members can have buddies
			if NOT cor_bMember Then cor.msg(lngNotAuthorized)
			cor.butil.checkNotVoid("[cor.member:cor_cDoMemberAddBuddy], io_mid")
			'--- cannot be buddy with yourself...
			if io_mid = cor_lUserID Then cor.msg(lngMemberCannotBeBuddyYourself)
			doMemberAddBuddy()
			cor.redirm lngMemberBuddyAdded, "member_form.asp?do="   & cor_cDoMemberView & "&mid=" & io_mid
			'
		case cor_cDoMemberDelBuddy
		'cor.str.wri "Do Member Del Buddy"
			'
			'--- only logged members could drop their buddies off
			if NOT cor_bMember Then cor.msg(lngNotAuthorized)
			cor.butil.checkNotVoid("[cor.member:cor_cDoMemberDelBuddy], io_mid")
			doMemberDelBuddy()
			cor.redirm lngMemberBuddyDeleted, "member_form.asp?do=" & cor_cDoMemberView & "&mid=" & io_mid
			'
		Case cor_cDoMemberDelete
		'cor.str.wri "Do Member Delete"
			'
			'--- only admins can delete
			if Not cor_bAdmin Then 
				Call errorMsg(lngNoAccess)
				Response.end
			End If
			cor.butil.checkNotVoid("[cor.member:cor_cDoMemberDelete], io_mid")
			'
			if  NOT cor_bPostback Then
				'--- get some data of user being deleted
				if NOT doMemberIOdata(cor_cSelect, cor_cSql, "MemberID", io_mid) Then 
					Call errorMsg(lngMemberNotFound)
					Response.End
				End If
			else'
				'--- cannot delete yourself!
				if io_mid = cor_lUserID Then 
					call errorMsg(lngMemberCannotDoOnSelf)
					Response.End
				End If
				'--- cannot delete admin account!
				if io_mid = 1 Then 
					call errorMsg(lngMemberCannotDeleteGuest)
					Response.End
				End If
				'--- cannot delete guest account!
				if io_mid = 2 Then 
					call errorMsg(lngMemberCannotDeleteGuest)
					Response.End
				End If
				'--- delete io_mid member
				if io_mid > 2 Then 
					doMemberDelete()
					'--- member io_mid was deleted and is not valid anymore
					io_mid = 0
					Call succesMsg(lngMemberDeleted,cor_sWebRoot & "mgmt_members.asp")
					Response.End
				End If
			end if
			'
		case cor_cDoMemberTerms 
		'cor.str.wri "Do Member Terms"
			'no menu chosen or 0 was selected.
			if not(cor_bGuest) then						'we shouldn't be here!
				if io_mid=0 Then io_mid = cor_lUserID
				'--- populate profile from DB
				if NOT doMemberIOdata(cor_cSelect, cor_cSql, "MemberID", io_mid) Then cor.msg(lngMemberNotFound)
			end if
			'
		case else
			cor.msg(lngUnknownActivity)
		end select
		'
	end sub
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	' Activities (atomical)
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	private function doMemberIOdata(iActionSql, iFillSrc, whereQry, whereVal)
		dim arrMember, maxMid, sWhereClause
		'response.write "action: " & iActionSql & "<br />iFillSrc: " & iFillSrc & "<br />"
		'response.write "whereQry: " & whereQry & "<br />WhereVal: " & whereVal & "<br />"
		
		'
		'----------------------------------------
		' Query & Param Builder:
		'----------------------------------------
		'
		'-- sql data (source) --------------------- request obj (source) ------ PUBLIC attributes (source/recipient) - data type
		cor.sql.init(iActionSql)
		cor.sql.addio "members.MemberID",			cor.io.f("mid"),			"cor.member.io_mid",			cor_cAut
		cor.sql.addio "members.muser",				cor.io.f("muser"),			"cor.member.io_muser",			cor_cStr
		cor.sql.addio "members.mpass",				cor.io.f("mpass"),			"cor.member.io_mpass",			cor_cStr
		cor.sql.addio "members.mpassraven",			cor.io.f("mpassraven"),		"cor.member.io_mpassraven",		cor_cStr
		cor.sql.addio "members.msaltraven",			cor.io.f("msaltraven"),		"cor.member.io_msaltraven",		cor_cStr
		cor.sql.addio "members.mactivatecode",		cor.io.f("mactivatecode"),	"cor.member.io_mactivatecode",	cor_cStr
		cor.sql.addio "members.mactive",			cor.io.f("mactive"),		"cor.member.io_mactive",		cor_cInt
		cor.sql.addio "members.mname",				cor.io.f("mname"),			"cor.member.io_mname",			cor_cStr
		cor.sql.addio "members.mmail",				cor.io.f("mmail"),			"cor.member.io_mmail",			cor_cStr
		cor.sql.addio "members.mgid",				cor.io.f("mgid"),			"cor.member.io_mgid",			cor_cLng
		cor.sql.addio "members.mskin",				cor.io.f("mskin"),			"cor.member.io_mskin",			cor_cStr
		cor.sql.addio "members.mlanguage",			cor.io.f("mlanguage"),		"cor.member.io_mlanguage",		cor_cStr
		cor.sql.addio "members.mlocation",			cor.io.f("mlocation"),		"cor.member.io_mlocation",		cor_cInt
		cor.sql.addio "members.mlocationname",		cor.io.f("mlocationname"),	"cor.member.io_mlocationname",	cor_cStr
		cor.sql.addio "members.mlocationdomain",	cor.io.f("mlocationdomain"),"cor.member.io_mlocationdomain",cor_cStr
		cor.sql.addio "members.mtitle",				cor.io.f("mtitle"),			"cor.member.io_mtitle",			cor_cStr
		cor.sql.addio "members.mdateofbirth",		cor.io.f("mdateofbirth"),	"cor.member.io_mdateofbirth",	cor_cStr
		cor.sql.addio "members.msign",				cor.io.f_rtf("msign"),		"cor.member.io_msign",			cor_cStr
		cor.sql.addio "members.mreggad",			cor.io.f("mreggad"),		"cor.member.io_mreggad",		cor_cStr
		cor.sql.addio "members.mtimezone",			cor.io.f("mtimezone"),		"cor.member.io_mtimezone",		cor_cDbl
		cor.sql.addio "members.mavatar",			cor.io.f("mavatar"),		"cor.member.io_mavatar",		cor_cStrEmpty
		cor.sql.addio "members.mgender",			cor.io.f("mgender"),		"cor.member.io_mgender",		cor_cStr
		cor.sql.addio "members.mhomepage",			cor.io.f("mhomepage"),		"cor.member.io_mhomepage",		cor_cStr
		cor.sql.addio "members.mmsn",				cor.io.f("mmsn"),			"cor.member.io_mmsn",			cor_cStrEmpty
		cor.sql.addio "members.micq",				cor.io.f("micq"),			"cor.member.io_micq",			cor_cStrEmpty
		cor.sql.addio "members.myahoo",				cor.io.f("myahoo"),			"cor.member.io_myahoo",			cor_cStrEmpty
		cor.sql.addio "members.maim",				cor.io.f("maim"),			"cor.member.io_maim",			cor_cStrEmpty
		cor.sql.addio "members.mmigratedpass",		cor.io.f("mmigratedpass"),	"cor.member.io_mmigratedpass",	cor_cInt
		cor.sql.addio "members.mshowactive",		cor.io.f("mshowactive"),	"cor.member.io_mshowactive",	cor_cSoopBool
		cor.sql.addio "members.mbanned",			cor.io.f("mbanned"),		"cor.member.io_mbanned",		cor_cSoopBool
		cor.sql.addio "members.mwarnings",			cor.io.f("mwarnings"),		"cor.member.io_mwarnings",		cor_cInt
		cor.sql.addio "members.mshowmail",			cor.io.f("mshowmail"),		"cor.member.io_mshowmail",		cor_cSoopBool
		cor.sql.addio "members.mautologin",			cor.io.f("mautologin"),		"cor.member.io_mautologin",		cor_cSoopBool
		cor.sql.addio "members.mshowsig",			cor.io.f("mshowsig"),		"cor.member.io_mshowsig",		cor_cSoopBool
		'cor.sql.addio "members.mricheditor",		cor.io.f("mricheditor"),	"cor.member.io_mricheditor",	cor_cSoopBool
		'as not present in profile form force 1 as value !
		cor.sql.addio "members.mricheditor",		1,							"cor.member.io_mricheditor",	cor_cSoopBool
		cor.sql.addio "members.mhtmlemail",			cor.io.f("mhtmlemail"),		"cor.member.io_mhtmlemail",		cor_cSoopBool
		cor.sql.addio "members.mpmnotify",			cor.io.f("mpmnotify"),		"cor.member.io_mpmnotify",		cor_cSoopBool
		cor.sql.addio "members.mreplynotify",		cor.io.f("mreplynotify"),	"cor.member.io_mreplynotify",	cor_cSoopBool
		cor.sql.addio "members.mnoofposts",			cor.io.f("mnoofposts"),		"cor.member.io_mnoofposts",		cor_cLng
		'
		'--- build where-clause part
		sWhereClause = cor.dal.buildSQL("WHERE " & whereQry & "={0}", array(whereVal))
		'
		'--- get data from query and/or form data and populate class attributtes
		select case iActionSql
			'
		case cor_cSelect
			'
			p_sql = cor.sql.buildSelect("members")
			cor.dal.open arrMember, p_sql & sWhereClause, array()
			if cor.butil.eof(arrMember) then doMemberIOdata = false : exit function
			cor.sql.buildio arrMember, iFillSrc
			doMemberIOdata = true
			'
		case cor_cUpdate
			'
			p_sql = cor.sql.buildUpdate("members")
			'--- populate afields from attributes pre-settings first values and if empty, take from form params - 6
			cor.sql.buildio empty, cor_cAttr1Form2
			'--- exec update
			'if location comes back 0, it should be null.
			if cor.filter.checkInt(cor.sql.oVal.afields(11)) < 1 then cor.sql.oVal.afields(11) = ""
			'if a text value is numeric, then we need to trap that for inserts.
			if isnumeric(cor.sql.oVal.afields(0))  then p_sql = replace(p_sql, "{0}", "'{0}'")		'muser
			if isnumeric(cor.sql.oVal.afields(14))  then p_sql = replace(p_sql, "{14}", "'{14}'")	'mtitle
			if isnumeric(cor.sql.oVal.afields(16))  then p_sql = replace(p_sql, "{16}", "'{16}'")	'msign
			dim xx
			for xx = 22 to 25																		'IM client ids
				if isnumeric(cor.sql.oVal.afields(xx)) then p_sql = replace(p_sql, "{" & trim(cstr(xx)) & "}", "'{" & trim(cstr(xx)) & "}'")
			next
			'response.write "--11:" & cor.sql.oVal.afields(11) & "--<br />"
			'response.write "--12:" & cor.sql.oVal.afields(12) & "--<br />"
			'response.write "--13:" & cor.sql.oVal.afields(13) & "--<br />"
			cor.dal.exec p_sql & sWhereClause, cor.sql.oVal.afields
			doMemberIOdata = true
			'
		case cor_cInsert
			'
			p_sql = cor.sql.buildInsert("members")
			'--- populate afields from attribute pre-condition values and form params
			cor.sql.buildio empty, iFillSrc
			'--- exec insert
			
			cor.dal.exec p_sql, cor.sql.oVal.afields
			maxMid = cor.filter.checkLng(cor.dal.getValue("SELECT MAX(m.MemberID) FROM " & cor_dbpre & "members AS m ", empty))
			doMemberIOdata = maxMid
			'
		case else
			'
			'--- non-query filling only
			cor.sql.buildio empty, iFillSrc
			doMemberIOdata = true
			'
		end select
		'
		' post-processing
		'
		io_mgname = iif(io_mgname<>"", io_mgname, cor.dal.getValue("SELECT g.gname FROM " & cor_dbpre & "groups AS g WHERE g.gid={0}", array(io_mgid)))
		'
	end function
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	'
	'
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	private sub doMemberNew()
		dim maxMid, activateCode
		'
		'--- handle member creation depending on SooP was set to require activation or not
		if  cor.filter.checkBol(cor.cfg.item("requireActivation")) then
			activateCode	= cor.butil.genRandomCode(5)
			io_mactivatecode = activateCode
			maxMid = doMemberIOdata(cor_cInsert, cor_cAttr, "", "")
			'
			'--- add a reference to new new mid into activateCode, so we ensure uniqueness for later retrieval and as an additional mean to check or address the member's record
			activateCode = maxMid & "|" & activateCode
			'
			'--- call mail sender (other needed params already populated during pre-conditions setup)
			call sendMailProfile(activateCode, "")
			'
		else'
			'
			io_mactive = 1
			maxMid = doMemberIOdata(cor_cInsert, cor_cAttr, "", "")
			cor.butil.msg = lngMemberNoNeedActivation
		end if
		'
		' additionally update mlocationname, mlocationdomain from mlocation ID
		' and populate attributes io_mlocationname and io_mlocationdomain for eventual further use
		'
		call getUpdateCountryName(io_mlocation, "", maxMid)
		'
	end sub
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	'
	'
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	private function doReissueActivationCode(byval sMail)
		dim activateCode
		'
		'--- membership already activated. Nothing else to do
		if cor.filter.checkInt(io_mactive) > 0 then doReissueActivationCode = lngMemberAlreadyActivated : exit function
		'
		'--- update email if it was edited (admin)
		if sMail <> "" AND sMail <> io_mmail then io_mmail = sMail
		'
		'--- reissue an activation code and send an email to member
		activateCode = cor.butil.genRandomCode(5)
		p_sql = "UPDATE " & cor_dbpre & "members SET mactivatecode={0}, mmail={1} WHERE MemberID={2}"
		cor.dal.exec p_sql, array(activateCode, io_mmail, io_mid)
		
		'--- add a reference to mid into activation code
		activateCode = io_mid & "|" & activateCode
		'
		call sendMailProfile(activateCode, "")
		'
		doReissueActivationCode = lngMemberActivationReissued
	end function
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	'
	'
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	private function doMemberActivate(activatecode)
		'
		'--- admin could activate other user's account
		if cor_bAdmin OR activatecode<>"" Then
			'
			'--- activate membership and clear mactivatecode, as it's not needed anymore
			cor.dal.exec "UPDATE " & cor_dbpre & "members SET mactive={0}, mactivatecode={1} WHERE MemberID={2}", array(1, "", io_mid)
			doMemberActivate = true
		else
			doMemberActivate = false
		end if
	end function
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	'
	'
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	private sub doMemberUpdate()
		if io_mid = 0 Then exit sub
		'
		if  cor_bAdmin then
			'
			'--- Admin updates member or self, with admin-only attributes
			call doMemberIOdata(cor_cUpdate, cor_cAttr, "MemberID", io_mid)
			'
		else'
			' Member updates self
			'
			'--- ensure some values never get updated by ordinary users
			cor.sql.exclude = "members.muser,members.mgid,members.mtitle"
			call doMemberIOdata(cor_cUpdate, cor_cAttr, "MemberID", io_mid)
		end if
		'
		' additionally update mlocationname, mlocationdomain from mlocation ID
		' and populate attributes io_mlocationname and io_mlocationdomain for eventual further use
		'
		call getUpdateCountryName(io_mlocation,"",io_mid)
	end sub
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	'
	'
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	private sub doMemberUpdatePass()
		cor.dal.exec "UPDATE " & cor_dbpre & "members SET mpass={0} WHERE MemberID={1}", array(io_mpass, io_mid)
	end sub
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	'
	'
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	private sub doMemberNewPass()
		dim newPass
		'
		'--- generate a new password
		newPass = cor.butil.genRandomCode(5)
		'
		'--- save newly generated password
		p_sql = "UPDATE " & cor_dbpre & "members SET mpass={0} WHERE MemberID={1}"
		cor.dal.exec p_sql, array(cor.sha.enc256(newPass), io_mid)
		'
		'--- send new password by email
		call sendMailProfile("", newPass)
	end sub
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	'
	'
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	private sub doMemberWarn()
		cor.dal.exec "UPDATE " & cor_dbpre & "members SET mwarnings = {0} WHERE MemberID={1}", array(io_mwarnings, io_mid)
	end sub
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	'
	'
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	private sub doMemberBan()
		cor.dal.exec "UPDATE " & cor_dbpre & "members SET mbanned={0} WHERE MemberID={1}", array(1, io_mid)
	end sub
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	'
	'
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	private sub doMemberUnban()
		cor.dal.exec "UPDATE " & cor_dbpre & "members SET mbanned={0} WHERE MemberID={1}", array(0, io_mid)
	end sub
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	'
	'
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	private sub doMemberAddBuddy()
		dim arrBuddy
		'
		p_sql = "SELECT b.buddy_id FROM " & cor_dbpre & "buddies AS b WHERE b.bmid={0} AND b.bbmid={1}"
		cor.dal.open arrBuddy, p_sql, array(cor_lUserID, io_mid)
		if  cor.butil.eof(arrBuddy) Then
			p_sql = "INSERT INTO " & cor_dbpre & "buddies (bmid, bbmid, block) values ({0},{1},{2})"
			cor.dal.exec p_sql, array(cor_lUserID, io_mid, 0)
			
			' save buddy to a cookie array			
			p_sql = "SELECT TA.muser, TA.MemberID, TB.bbmid " _
				 & "FROM " & cor_dbpre & "members AS TA, "  & cor_dbpre & "buddies AS TB " _
				 & "WHERE TA.MemberID = TB.bbmid AND TB.bmid = {0} AND TB.bbmid = {1} "
			cor.dal.open arrBuddy, p_sql, array(cor_lUserID, io_mid)
			if NOT cor.butil.eof(arrBuddy) then
				dim i_x, bname, bid
				for i_x = 0 to ubound(arrBuddy,2)
					bname 	= arrBuddy(0,i_x)
					'Address_ID 	= arrBuddy(1,i_x)
					bid 	= arrBuddy(2,i_x)
					cor.butil.saveCookieAr "BuddyList" & cor_lUserID, bid, bname
				next
			end if
		end if
	end sub
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	'
	'
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	private sub doMemberDelBuddy()
		p_sql = "DELETE FROM " & cor_dbpre & "buddies WHERE bmid={0} AND bbmid={1}"
		cor.dal.exec p_sql, array(cor_lUserID, io_mid)
		cor.butil.delCookie cor_sCookieName&"BuddyList"&cor_lUserID
	end sub
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	'
	'
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	private sub doMemberDelete()
		'Change user to a deleted user. By setting group = NULL this user will disappear from mgmt interface.
		'		By not deleting from db, we don't have to track down all the possible hiding places for MemberID and carry out updates.
		'		If an admin wants to REALLY delete, they need to convert all posts and data to guest, then issue a delete from members where mgid is null.
		p_sql = "UPDATE " & cor_dbpre & "members SET muser={0}, mpass='Us3rN0M0r3!',mactive=0,mbanned=1,mname={0},mautologin=0,mshowactive=0,mmail=NULL," & _
				"micq=NULL,mmsn=NULL,msign=NULL,mdateofbirth=0,mreggad=1051147534,mshowmail=0,mpmnotify=0,mshowsig=0,mtitle=NULL,mgender=NULL," & _
				"mavatar=NULL,mhomepage='http://',myahoo=NULL,maim=NULL,mgid=NULL WHERE MemberId={1}"
		'fix 23 April 2009: added io_mid to the newly-deleted member name (muser), since there's a unique index on it
		cor.dal.exec p_sql, array(lngDeletedUser & "-" & io_mid ,io_mid)
		'drop any notify settings for this user
		p_sql = "DELETE FROM " & cor_dbpre & "notify WHERE nuser={0}"
		cor.dal.exec p_sql, array(io_mid)
		'drop any incoming PMs for this user
		p_sql = "DELETE FROM " & cor_dbpre & "pm WHERE pmToMid={0}"
		cor.dal.exec p_sql, array(io_mid)
	end sub
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	' Helpers
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	private sub sendMailWarnBan(intDo)
		dim msgBody
		'
		msgBody = lngHi   & io_muser	& ":"	& vbcrlf
		msgBody = msgBody & lngMemberStatusBody1
		select case intDo
		case cor_cDoMemberWarn
		msgBody = msgBody & lngMemberWarned   & io_mwarnings & lngMemberTimes &	lngMemberStatusBody2
		case cor_cDoMemberBan
		msgBody = msgBody & lngMemberBanned   & lngMemberStatusBody2
		case cor_cDoMemberUnban
		msgBody = msgBody & lngMemberUnbanned
		end select
		'--- send message
		'if  then
		call cor.mail.send(cor_sReplyMail, cor.cfg.item("SenderName"), io_mmail, io_mname, cor.cfg.item("WebsiteTitle") & ": " & lngMemberStatusMsgHeader, msgBody, 0)
		cor.butil.msg  = lngMemberStatusChangedEmailSent
		'else
		'	cor.butil.emsg = lngMemberUnableSendStatusChangedEmail & vbcrlf & "(" & cor.mail.errmsg & ")"
		'end if
	end sub
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	'
	'
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	public function getUpdateCountryName(countryID, strCountry, memberId)
		dim strCdomain, arrCountry
		'
		if  strCountry <> "" Then getUpdateCountryName  = cor.butil.htmlEncode(strCountry) : exit function
		if  cor.filter.checkInt(countryID) = 0 Then	getUpdateCountryName = "" : exit function
		'
		p_sql = "SELECT T1.Country, T1.Cdomain FROM " & cor_dbpre & "country AS T1 WHERE T1.CountryID={0}"
		cor.dal.openPaged arrCountry, 1, 1, p_sql, array(cor.filter.checkInt(countryID))
		if  cor.butil.eof(arrCountry) Then getUpdateCountryName = "" : exit function
		strCdomain = cor.filter.checkStr(arrCountry(1,0))
		'
		'--- update member's data so next time no more dbcall needed!
		' Do this via INNER JOIN!
		if  cor.filter.checkLng(memberId) > 0 Then
			p_sql = "UPDATE " & cor_dbpre & "members SET mlocationname={0}, mlocationdomain={1} WHERE MemberID={2}"
			cor.dal.exec p_sql, array(arrCountry(0,0), strCdomain, memberId)
		end if
		'
		getUpdateCountryName = cor.butil.htmlEncode(arrCountry(0,0))
		'
		'--- also update global attributes of member class
		io_mlocationname	= arrCountry(0,0)
		io_mlocationdomain   = strCdomain
	end function
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	'
	'
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	private sub sendMailProfile(code, pass)
		dim msgBody, msgSend, msgSendErr
		dim strCodeURL
		'
		msgBody = lngHi   & io_muser						& ":<br />"			& vbcrlf
		msgBody = msgBody & lngMemberRegistrationBody						& vbcrlf
		msgBody = msgBody & lngUserName					& ": " & io_muser	& "<br />" & vbcrlf
		'
		'--- customize body message, for new password OR activation code
		if pass <> "" then
		msgBody = msgBody & lngPassword					& ": " & pass		& "<br />" & vbcrlf
		else
		msgBody = msgBody & lngMemberActivationCode		& ": " & code		& "<br />" & vbcrlf
		msgBody = msgBody & lngMemberActivateAccountLink	& ":<br /> "			& vbcrlf
		'msgBody = msgBody & cor_sPortalDomainPath	& "member_form.asp?do="	& cor_cDoMemberActivate & "&ac=" & code
		strCodeURL = cor_sPortalDomainPath	& "member_form.asp?do="	& cor_cDoMemberActivate & "&ac=" & code
		msgBody = msgBody & "<a href=""" & strCodeURL & """>" & strCodeURL & "</a><br />" & vbcrlf
		end if
		'
		'--- customize delivery message
		if pass <> "" then
			msgSend	= lngMemberNewPassSent
			msgSendErr	= lngMemberUnableSendEmail
		else
			msgSend		= lngMemberNeedActivationMsg
			msgSendErr	= lngMemberUnableSendActivationEmail & " <a href=""member_form.asp?do=" & cor_cDoMemberActivate & "&ac=" & code & """ target=top>" & lngMemberFollowActivateAccount & "</a>"
		end if
		'
		'--- send message
		
		'if  then
		call cor.mail.send(cor_sReplyMail, cor.cfg.item("SenderName"), io_mmail, io_mname, cor.cfg.item("WebsiteTitle") & ": " & lngMemberRegistrationMsgHeader, msgBody, 1)
		cor.butil.msg = msgSend
		'else
		'	'--- if cor_cEmailSender is set to false or an email transport error happened, give member the chance to activate in place (should happen very rarely though, and even then psw must never be shown)
		'	cor.butil.emsg = msgSendErr & "<br />(" & cor.mail.errmsg & ")"
		'end if
	end sub
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	'
	'
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	private function extractActivateCodeMid(byVal sActivateCode, byRef imid)
		if instr(sActivateCode, "|") = 0 then exit function
		imid = cor.filter.checkLng(split(sActivateCode,"|")(0))
		extractActivateCodeMid = split(sActivateCode,"|")(1)
	end Function
	'
	'
	Public Function errorMsg(errmsg)
		Dim purr
		set purr = new class_Purr
		purr.isNewPm		= "false"
		purr.CssClasstop 	= "purr-top-warnL3"
		purr.CssClassBody 	= "purr-body-warnL3"
		purr.CssClassBottom = "purr-bottom-warnL3"
		purr.screenPosition = "center-center"
		purr.Image			= "False"
		purr.HeaderTxt		= lngSystemMessage
		purr.MessageTxt		= errmsg
		purr.isSticky		= "false"
		purr.removeTimer	= 5000
		purr.doPurr
		Set purr = Nothing
	End Function
	'
	'
	Public Function succesMsg(btnText,rURL)
		Dim purr
		set purr = new class_Purr
		purr.isNewPm		= "false"
		purr.CssClasstop 	= "purr-top-succes"
		purr.CssClassBody 	= "purr-body-succes"
		purr.CssClassBottom = "purr-bottom-succes"
		purr.screenPosition = "center-center"
		purr.Image			= "True"
		purr.HeaderTxt		= lngSystemMessage
		purr.MessageTxt		= btnText
		purr.isSticky		= "false"
		purr.doPurr
		Set purr = Nothing
		cor.str.wri "<script type=""text/javascript"">$('#register').attr('style', 'disabled:disabled;');</script>"
		cor.str.wri "<script type=""text/javascript"">setTimeout('parent.window.location = """ & rURL & """', 5000);</script>"
	End Function
	'
	'
end class
'
'<#late-binding hook
function boot_class_members : boot_class_members = true : end function
'/>

%>
