﻿<%
'------------------------------------------------------------------------------------------------------------------------------------------
' SOOP 2.0 - Phoenix (TNG)
'
'Revision 2.0001 - initial 13/04/2008
'
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'------------------------------------------------------------------------------------------------------------------------------------------

class class_pm ':: global, class_baseUtils, class_filters, class_dal, class_io, class_sendMail
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	' Attributes
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	public	p_page
	public  p_muser
	public	p_musers
	public	p_mgroups
	public	p_type
	public  p_arId
	'
	public  io_pmID
	public  io_pmFromMid
	public  io_pmToMid
	public  io_pmSubject
	public  io_pmText
	public  io_pmStatus
	public  io_pmNotifyOnRead
	public  io_pmDate
	public  io_pmIdRef
	public  io_muser
	public	io_musers
	public	io_mgroups
	public	io_mtype
	public  io_mshowmail
	'
	public  util			' Utility obj
	'
	private p_sql
	private a_musers, i, x_i
	private arrActivity
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	' Init class: get I/O params and set startup internal environment
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	private sub class_initialize
		set util = new class_pm_utils
	end sub
	'
	public sub init_io()
		'
		' init attributes from GET
		'
		io_pmid			= cor.filter.checkLng(cor.io.q("id"))				' PM's ID
		io_pmFromMid	= cor.filter.checkLng(cor.io.q("from"))				' sender's Member ID
		io_pmToMid		= cor.filter.checkLng(cor.io.q("to"))				' receipient's Member ID
		p_page			= cor.filter.checkInt(cor.io.q("pg"))
		'
		' init attributes from POST
		'
		if cor_bPostback Then
			io_pmid		= cor.filter.checkLng(cor.io.f("id"))
			p_musers	= cor.io.f("musers")								' string array of members to send a new PM to
			p_mgroups	= cor.io.f("pmgroups")								' string array of group id's to send mass pm
			p_type		= cor.io.f("ptype")									' check for mass pm to individual users or group
			p_arId		= cor.butil.deserialize(cor.io.f("arId"), ",")		' array of PM ID's to delete
			p_page		= cor.filter.checkInt(cor.io.f("pg"))
		end if
		'
		' Global pre-conditions
		'
		if NOT cor_bMember Then cor.msg(lngNotAuthorized)
		'
		'--- sender is usually the logged member, but may be another if a reply or an admin is managing other's inbox
		if io_pmFromMid  = 0 then io_pmFromMid = cor_lUserID
	end sub
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	' Event Process (map inbound events to activities)
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	public sub controller(byVal eventIn)
		dim iDo : iDo = cor.filter.checkInt(eventIn) : if iDo = 0 Then exit sub
		'
		select case iDo
			'
		case cor_cDoViewPMIn	' view message coming from Inbox List, option to reply is available
			'
			cor.butil.checkNotVoid("[cor.pm:cor_cDoViewPMIn], io_pmId")
			if NOT doGetPMIOdata("p.pmid", io_pmId) Then cor.msg(lngPMEmptyInbox)
			'--- ensure somebody is not trying to impersonate as somebody else to gain access (but admin)
			if io_pmToMid <> cor_lUserID AND NOT cor_bAdmin then cor.msg(lngNotAuthorized)
			'--- get user name this message was from
			io_muser = cor.dal.getValue("SELECT m.muser FROM " & cor_dbpre & "members AS m WHERE (m.memberid ={0})", array(io_pmFromMid))
			'
			' When member (the recipient) is reading this inbox message, set pmstatus=1 to mark it as read
			' and also notify the sender if he had wished so
			'	
			if  io_pmToMid = cor_lUserID Then
				doSetAsPMStatusRead()
				if io_pmNotifyOnRead<>0 then call sendMail(io_pmFromMid, io_pmSubject, "", 1)
				doSetAsPMNotifyOnReadOff()
			end if
			'
		case cor_cDoViewPMOut	' view message coming from Outbox List
			'
			cor.butil.checkNotVoid("[cor.pm:cor_cDoViewPMOut], io_pmId")
			if NOT doGetPMIOdata("p.pmid", io_pmId) Then cor.msg(lngPMEmptyOutbox)
			'--- ensure somebody is not trying to impersonate as somebody else to gain access (but admin)
			if io_pmFromMid <> cor_lUserID AND NOT cor_bAdmin then cor.msg(lngNotAuthorized)
			'--- get user name this message was to
			io_muser = cor.dal.getValue("SELECT m.muser FROM " & cor_dbpre & "members AS m WHERE (m.MemberID ={0})", array(io_pmToMid))
			'
		case cor_cDoNewPM ' single-user mode
			'
			if NOT cor_bPostback Then
				'
				' INIT form
				'
				'--- if we already have a recipient get their name to populate the form
				if  io_pmToMid > 0 Then
					io_muser = cor.dal.getValue("SELECT m.muser FROM " & cor_dbpre & "members AS m WHERE (m.MemberID ={0})", array(io_pmToMid))
				end if
				'
			else'
				' POST
				'
				'--- get form data
				call doGetPMIOdata("", null)
				cor.butil.checkNotVoid("[cor.pm:cor_cDoNewPM],io_muser,io_pmSubject,io_pmText")
				If len(validatePM())>0 Then '<validate>
					cor.str.wri validatePM()
					call cor.butil.errorMsg(lngErrorDisplayLine1,lngValidationFail,True,3000,false,,0,false)
					response.end
				Else '<validate>
					'
					io_pmToMid = cor.filter.checkLng(cor.dal.getValue("SELECT m.MemberID FROM " & cor_dbpre & "members AS m WHERE m.muser ={0}", array(io_muser)))
					if io_pmToMid = 0 then cor.msg(lngMemberNotFound)
					'
					doNewPM(0)
					'
					'--- send notification via e-mail
					call sendMail(io_pmToMid, io_pmSubject, "", 0)
					'
					'--- go to PM Outbox to show the new message we have sent
					call cor.butil.successMsg(lngSuccessfullMessage,lngValidationSuccess,True,3000,true,"pm_list.asp?do=" & cor_cDoViewPMOut & "&pg=1&rst=1",3500,false)
					response.end
				end if '<validate>
			end if
			'
		case cor_cDoNewPMList ' multi-user mode
			'
			if NOT cor_bPostback Then
				'
				' INIT form
				'
				'--- only admin/mods could use this facility
				if NOT (cor_bAdmin OR cor_bModerator) Then cor.msg(lngAccessDenied)
				'--- if we already have a recipient get their name to populate the form
				if  io_pmToMid > 0 Then
					io_muser = cor.dal.getValue("SELECT m.muser FROM " & cor_dbpre & "members AS m WHERE (m.MemberId ={0})", array(io_pmToMid))
				end if
				'
			else'
				' POST
				'
				'--- get form data
				call doGetPMIOdata("", null)
				If len(validatePM())>0 Then '<validate>
					cor.str.wri validatePM()
					call cor.butil.errorMsg(lngErrorDisplayLine1,lngValidationFail,True,3000,false,,0,false)
					response.end
				Else '<validate>
					if lcase(p_type) = "true" then
						cor.butil.checkNotVoid("[cor.pm:cor_cDoNewPMList],p_musers,io_pmSubject,io_pmText")
						'
						a_musers = cor.butil.deserialize(p_musers, ",")
						for i = 0 to ubound(a_musers)
							dim sqlStatement, arrMuser, arrMgrpid	'cleaning up the syntax a bit here and fixing a SQL error in line below.
							sqlStatement = "SELECT m.MemberID FROM " & cor_dbpre & "members AS m WHERE " & cor_dbLC & "(m.muser)={0}"
							arrMuser = array(lcase(trim(a_musers(i))))
							io_pmToMid = cor.filter.checkLng(cor.dal.getValue(sqlStatement, arrMuser))
							if  io_pmToMid > 0 then
								doNewPM(0)
								call sendMail(io_pmToMid, io_pmSubject, "", 0)
							else
								cor.butil.emsg = lngMemberNotFound & " " & a_musers(i)
							end if
						next
						'
						'--- go to PM Outbox to show the new message(s) we have sent
						call cor.butil.successMsg(lngSuccessfullMessage,lngValidationSuccess,True,3000,true,"pm_list.asp?do=" & cor_cDoViewPMOut & "&pg=1&rst=1",3500,false)
						response.end
					else
						a_musers = cor.butil.deserialize(p_mgroups, ",")
						for i = 0 to ubound(a_musers)
							cor.str.wri a_musers(i) & "<br />"
							sqlStatement = "SELECT m.MemberID FROM " & cor_dbpre & "members AS m WHERE m.mgid = {0}"
							cor.dal.open arrMgrpid, sqlStatement, array(a_musers(i))
							for x_i = 0 to ubound(arrMgrpid,2)
								io_pmToMid = arrMgrpid(0,x_i)
								if  io_pmToMid > 0 then
									cor.str.wri io_pmToMid & "<br />"
									doNewPM(0)
									call sendMail(io_pmToMid, io_pmSubject, "", 0)
								else
									cor.butil.emsg = lngMemberNotFound & " " & a_musers(i)
								end if
							next
						next
						call cor.butil.successMsg(lngSuccessfullMessage,lngValidationSuccess,True,3000,true,"pm_list.asp?do=" & cor_cDoViewPMOut & "&pg=1&rst=1",3500,false)
						response.end
					end if
				end if
			end if
			'
		case cor_cDoNewPMReply
			'
			if  NOT cor_bPostback Then
				'
				' INIT form
				'
				'--- get data from the message we're replying to
				if NOT doGetPMIOdata("p.pmid", io_pmId) then cor.msg(lngPMNoMsgsFound)
				'--- ensure somebody is not trying to impersonate as somebody else
				if io_pmToMid <> cor_lUserID then cor.msg(lngNotAuthorized)
				io_muser	 = cor.dal.getValue("SELECT m.muser FROM " & cor_dbpre & "members AS m WHERE (m.MemberID = {0})", array(io_pmFromMid))
				io_pmText	 = "<p></p><p></p>" & "-- " & lngPMPrevMsg & " --<p></p><b>" & lngPMSentBy & "</b> : " & io_muser & "<br /><b>" & lngPMSentAt & "</b> : " & cor.butil.cvLcidTime(io_pmdate) & "<br /><br />" & io_pmtext
				io_pmSubject = lngPMShortReply & ": " & io_pmsubject
				'
				' When member (the recipient) is reading this inbox message, set pmstatus=1 to mark it as read
				' and also notify the sender if he had wished so
				'
				if  io_pmToMid = cor_lUserID Then
					doSetAsPMStatusRead()
					if io_pmNotifyOnRead<>0 then
						call sendMail(io_pmFromMid, io_pmSubject, "", 1)
						doSetAsPMNotifyOnReadOff()
					end if
				end if
				'
				'---[!] Sender becomes now the recipient!
				io_pmToMid   = io_pmFromMid
				'
			else'
				' POST
				'
				'--- get form data
				call doGetPMIOdata("", null)
				cor.butil.checkNotVoid("[cor.pm:cor_cDoNewPMReply], io_pmId, io_pmToMid, io_pmSubject, io_pmText")
				If len(validatePM())>0 Then '<validate>
					cor.str.wri validatePM()
					call cor.butil.errorMsg(lngErrorDisplayLine1,lngValidationFail,True,3000,false,,0,false)
					response.end
				Else '<validate>
					'
					'--- create a new PM storing a reference to the replying-to message
					doNewPM(io_pmId)
					'
					'--- send notification via e-mail
					call sendMail(io_pmToMid, io_pmSubject, "", 0)
					'
					'--- go to PM Outbox to show the new reply we have sent
					call cor.butil.successMsg(lngSuccessfullMessage,lngValidationSuccess,True,3000,true,"pm_list.asp?do=" & cor_cDoViewPMOut & "&pg=1&rst=1",3500,false)
					response.end
				end if
			end if
			'
		case cor_cDoEditPM
			'
			if NOT cor_bPostback Then
				'--- INIT form
				cor.butil.checkNotVoid("[cor.pm:cor_cDoEditPM], io_pmId")
				if NOT doGetPMIOdata("p.pmid", io_pmid) then cor.msg(lngPMNoMsgsFound)
				'--- ensure somebody is not trying to impersonate as somebody else
				if io_pmFromMid <> cor_lUserID then cor.msg(lngNotAuthorized)
				io_muser = cor.dal.getValue("SELECT m.muser FROM " & cor_dbpre & "members AS m WHERE (m.MemberID = {0})", array(io_pmToMid))
			else'
				' POST
				'
				If len(validatePM())>0 Then '<validate>
					cor.str.wri validatePM()
					call cor.butil.errorMsg(lngErrorDisplayLine1,lngValidationFail,True,3000,false,,0,false)
					response.end
				Else '<validate>
					'--- get form data
					call doGetPMIOdata("", null)
					cor.butil.checkNotVoid("[cor.pm:cor_cDoEditPM], io_pmid, io_pmSubject, io_pmText")
					'
					doEditPM()
					'--- go back to outbox context
					call cor.butil.successMsg(lngSuccessfullMessage,lngValidationSuccess,True,3000,true,"pm_list.asp?do=" & cor_cDoViewPMOut & "&pg=" & p_page,3500,false)
					response.end
				end if
			end if
			'	
		case cor_cDoDelPM
			'
			'--- POST
			if NOT cor_bPostback Then exit sub
			'--- passed checkbox array was empty (should never happen)
			if ubound(p_arId) = -1 then cor.msg(lngPMNoMsgsFound)
			'--- by default, only PMs which recipient is the logged member would be deleted
			if io_pmToMid = 0 then io_pmToMid = cor_lUserID
			'--- only an admin could delete PMs from other members
			if io_pmToMid > 0 AND io_pmToMid <> cor_lUserID AND NOT cor_bAdmin then cor.msg(lngAccessDenied)
			'
			doDelPM(p_arId)
			'
			'--- go back to inbox context
			cor.redirm lngPMDeletedOk, "pm_list.asp?do=" & cor_cDoViewPMIn & "&pg=" & p_page
			'
		case cor_cDoDelPMAll
			'
			'--- POST
			if NOT cor_bPostback Then exit sub
			'--- by default, only PMs which recipient is the logged member would be deleted
			if io_pmToMid = 0 then io_pmToMid = cor_lUserID
			'--- only an admin could delete PMs from other members
			if io_pmToMid > 0 AND io_pmToMid <> cor_lUserID AND NOT cor_bAdmin then cor.msg(lngAccessDenied)
			'
			doDelPMAll()
			'
			'--- go back to (empty) inbox context
			cor.redir "pm_list.asp?do=" & cor_cDoViewPMIn & "&pg=" & p_page
			'
		case cor_cDoNewEmail ' single-user mode
			'
			if NOT cor_bPostback Then
				'
				' INIT form
				'
				'--- check if we have a recipient, check if it allows e-mail communications (admin always allowed) and get their name to populate the form
				if io_pmToMid > 0 Then
					p_sql = "SELECT m.muser, m.mshowmail FROM " & cor_dbpre & "members AS m WHERE (m.memberid ={0})"
					cor.dal.open arrActivity, p_sql, array(io_pmToMid)
					if cor.butil.eof(arrActivity) Then cor.msg(lngMemberNotFound)
					io_muser		= arrActivity(0,0)
					io_mshowmail	= cor.filter.checkInt(arrActivity(1,0))
					if io_mshowmail = 0 AND NOT cor_bAdmin Then cor.msg(lngPMNotAuthorizedEmailContact)
				end if
				'
			else'
				' POST
				'
				If len(validatePM())>0 Then '<validate>
					cor.str.wri validatePM()
					call cor.butil.errorMsg(lngErrorDisplayLine1,lngValidationFail,True,3000,false,,0,false)
					response.end
				Else '<validate>
					'--- get form data
					call doGetPMIOdata("p.pmid", io_pmId)
					cor.butil.checkNotVoid("[cor.pm:cor_cDoNewEmail], io_muser, io_pmSubject, io_pmText")
					'
					io_pmToMid = cor.filter.checkLng(cor.dal.getValue("SELECT m.memberid FROM " & cor_dbpre & "members AS m WHERE m.muser ={0}", array(io_muser)))
					if io_pmToMid = 0 then cor.msg(lngMemberNotFound)
					'
					response.write io_pmToMid & " " & io_pmSubject & " " & io_pmText
					doNewEmail()
					call sendMail(io_pmToMid, io_pmSubject, io_pmText, 2)
					'
					call cor.butil.successMsg(lngSuccessfullMessage,lngValidationSuccess,True,3000,true,"pm_list.asp?do=" & cor_cDoViewPMOut & "&pg=1&rst=1",3500,false)
					response.end
				end if
			end if
			'
		case cor_cDoNewEmailList ' multi-user mode
			'
			if NOT cor_bPostback Then
				'
				' INIT form
				'
				'--- only admin/mods could use this facility
				if NOT (cor_bAdmin OR cor_bModerator) Then cor.msg(lngAccessDenied)
				'--- if we already have a recipient get their name to populate the form
				if  io_pmToMid > 0 Then
					io_muser = cor.dal.getValue("SELECT m.muser FROM " & cor_dbpre & "members AS m WHERE (m.MemberID ={0})", array(io_pmToMid))
				end if
				'
			else
				' POST
				'
				'--- get form data
				call doGetPMIOdata("", null)
				If len(validatePM())>0 Then '<validate>
					cor.str.wri validatePM()
					call cor.butil.errorMsg(lngErrorDisplayLine1,lngValidationFail,True,3000,false,,0,false)
					response.end
				Else '<validate>
					if lcase(p_type) = "true" then
						cor.butil.checkNotVoid("[cor.pm:cor_cDoNewPMList],p_musers,io_pmSubject,io_pmText")
						'
						a_musers = cor.butil.deserialize(p_musers, ",")
						for i = 0 to ubound(a_musers)
							sqlStatement = "SELECT m.memberid FROM " & cor_dbpre & "members AS m WHERE " & cor_dbLC & "(m.muser)={0}"
							arrMuser = array(trim(a_musers(i)))
							io_pmToMid = cor.filter.checkLng(cor.dal.getValue(sqlStatement, arrMuser))
							if io_pmToMid > 0 then
								doNewPM(0)
								call sendMail(io_pmToMid, io_pmSubject, "", 0)
							else
								cor.butil.emsg = lngMemberNotFound & " " & a_musers(i)
							end if
						next
						call cor.butil.successMsg(lngSuccessfullMessage,lngValidationSuccess,True,3000,true,"pm_list.asp?do=" & cor_cDoViewPMOut & "&pg=1&rst=1",3500,false)
						response.end
					else
						a_musers = cor.butil.deserialize(p_mgroups, ",")
						for i = 0 to ubound(a_musers)
							'cor.str.wri a_musers(i) & "<br />"
							sqlStatement = "SELECT m.memberid FROM " & cor_dbpre & "members AS m WHERE m.mgid = {0}"
							cor.dal.open arrMgrpid, sqlStatement, array(a_musers(i))
							for x_i = 0 to ubound(arrMgrpid,2)
								io_pmToMid = arrMgrpid(0,x_i)
								if  io_pmToMid > 0 then
									cor.str.wri io_pmToMid & "<br />"
									doNewEmail(0)
									call sendMail(io_pmToMid, io_pmSubject, "", 0)
								else
									cor.butil.emsg = lngMemberNotFound & " " & a_musers(i)
								end if
							next
						next
						call cor.butil.successMsg(lngSuccessfullMessage,lngValidationSuccess,True,3000,true,"pm_list.asp?do=" & cor_cDoViewPMOut & "&pg=1&rst=1",3500,false)
						response.end
					end if
				end if '<validate>
			end if
			'
		case else
			 cor.msg lngUnknownActivity
		end select
		'
	end sub
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	' Activities (atomical)
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	private function doGetPMIOdata(paramName, paramVal)
		dim arrPM
		'
		p_sql = ""
		'--------------------------0-------1------------2----------3------------4---------5----------6-----------7-----------------8-----------
		p_sql = p_sql   & "SELECT p.pmID, p.pmFromMid, p.pmToMid, p.pmSubject, p.pmText, p.pmIdRef, p.pmStatus, p.pmNotifyOnRead, p.pmDate " _
						& "FROM " & cor_dbpre & "pm AS p WHERE " & paramName & "={0}"
		'
		'--- check if DB query was disabled
		if  paramName <> "" AND NOT isnull(paramVal) Then
			cor.dal.open arrPM, p_sql, array(paramVal)
		end if
		'
		' if query returns nothing we shall populate the array anyways with empty params;
		' this is necessary to get eventual form POST params populated
		if cor.butil.eof(arrPM) Then redim arrPM(8,0)
		'
		' ---------------
		' DB-form Mapping
		' ---------------
		' ensure that DB data does not eventually overwrite already collected IO data,
		' so only remaining uninitialized fields will get initialized from DB
		'
		io_pmID				= cor.io.fv("pmID",				arrPM(0,0),  cor_cLng)
		io_pmFromMid		= cor.io.fv("pmFromMid",		arrPM(1,0),  cor_cLng)
		io_pmToMid			= cor.io.fv("pmToMid",			arrPM(2,0),  cor_cLng)
		io_pmSubject		= cor.io.fv("pmSubject",		arrPM(3,0),  cor_cStr)
		io_pmText			= cor.io.fv_rtf("pmText",		arrPM(4,0),  cor_cStr)
		io_pmIdRef			= cor.io.fv("pmIdRef",			arrPM(5,0),  cor_cInt)
		io_pmStatus			= cor.io.fv("pmStatus",			arrPM(6,0),  cor_cInt)
		io_pmNotifyOnRead	= cor.io.fv("pmNotifyOnRead",	arrPM(7,0),  cor_cInt)
		io_pmDate			= cor.io.fv("pmDate",			arrPM(8,0),  cor_cLng)
		io_muser			= cor.io.f("muser")
		io_musers			= cor.io.f("musers")
		io_mgroups			= cor.io.f("pmgroups")
		io_mtype			= cor.io.f("ptype")
		'
		doGetPMIOdata = true
	end function
	'
	private sub doNewPM(pmIdRef)
		p_sql = "INSERT INTO " & cor_dbpre & "pm (pmFromMid, pmToMid, pmSubject, pmText, pmIdRef, pmNotifyOnRead, pmStatus, pmDate) VALUES ({0},{1},{2},{3},{4},{5},{6},{7})"
		cor.dal.exec p_sql, array(cor_lUserID, io_pmToMid, io_pmSubject, io_pmText, pmIdRef, io_pmNotifyOnRead, 0, cor.butil.cvUxTime(Now()))
	end sub
	'
	private sub doEditPM()
		p_sql = "UPDATE " & cor_dbpre & "pm SET pmsubject = {0}, pmtext = {1} WHERE pmid = {2}"
		cor.dal.exec p_sql, array(io_pmSubject, io_pmText, io_pmid)
	end sub
	'
	private sub doDelPM(arToDel)
		dim x_i
		for x_i = 0 to ubound(arToDel)
			p_sql = "DELETE FROM " & cor_dbpre & "pm WHERE pmID={0} AND pmToMid={1}"
			cor.dal.exec p_sql, array(trim(arToDel(x_i)), io_pmToMid)
		next
	end sub
	'
	private sub doDelPMAll()
		p_sql = "DELETE FROM " & cor_dbpre & "pm WHERE pmToMid={0}"
		cor.dal.exec p_sql, array(io_pmToMid)
	end sub
	'
	private sub doSetAsPMStatusRead()
		'added feb 9, 2009 to try to stop the multiple emails on notification bug.  --Charles
		p_sql = "UPDATE " & cor_dbpre & "pm SET pmNotifyOnRead=0 WHERE pmid={0}"
		cor.dal.exec p_sql, array(io_pmId)
	end sub
	'
	private sub doNewEmail()
		p_sql = "INSERT INTO " & cor_dbpre & "pm (pmFromMid, pmToMid, pmSubject, pmText, pmNotifyOnRead, pmStatus, pmDate) VALUES ({0},{1},{2},{3},{4},{5},{6})"
		cor.dal.exec p_sql, array(cor_lUserID, io_pmToMid, io_pmSubject, io_pmText, 0, 2, cor.butil.cvUxTime(Now()))
	end sub
	private sub doSetAsPMNotifyOnReadOff()
		p_sql = "UPDATE " & cor_dbpre & "pm SET pmstatus=1 WHERE pmid={0}"
		cor.dal.exec p_sql, array(io_pmId)
	end sub 
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	' Helpers
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	private sub sendMail(mmid, pmSubject, pmText, istatus)
		dim arrMail, msgBody, msgHeader
		'
		'-----------------0-------1--------2------------3---------
		p_sql = "SELECT m.muser, m.mmail, m.mpmnotify, m.mhtmlemail FROM " & cor_dbpre & "members AS m WHERE m.memberid={0}"
		cor.dal.open arrMail, p_sql, array(mmid)
		'
		select case istatus
		case 0 ' sent
		msgHeader	= lngPMmsgHeader
		msgBody		= lngHi	& arrMail(0,0)				& ":"  & vbcrlf
		msgBody		= msgBody	& lngPMEmailNewStart	& cor_sLoggedInUsername
		msgBody		= msgBody	& lngPMEmailNewSent		& "'"  & pmSubject & "'"
		msgBody		= msgBody	& lngPMEmailNewEnd		& cor.cfg.item("WebsiteTitle") & ". "
		msgBody		= msgBody	& lngPMViewInbox		& cor_sPortalDomainPath & "pm_list.asp?do=" & cor_cDoViewPMIn
		case 1 ' received
		msgHeader	= lngPMmsgHeader
		msgBody		= lngHi		& arrMail(0,0)			& ":"  & vbcrlf
		msgBody		= msgBody	& lngPMEmailNewStart	& cor_sLoggedInUsername
		msgBody		= msgBody	& lngPMNewEmailReceived	& "'" & pmSubject & "'"
		msgBody		= msgBody	& lngPMEmailNewEnd		& cor.cfg.item("WebsiteTitle") & ". "
		case 2 ' send email
		msgHeader = lngPMMailMsgHeader
		msgBody		= lngHi		& arrMail(0,0)			& ":"  & vbcrlf
		msgBody		= msgBody	& lngPMEmailNewStart	& cor_sLoggedInUsername
		msgBody		= msgBody	& lngPMNewEmailSent		& vbcrlf & vbcrlf & lngPMSubject & ": " & pmSubject & vbcrlf
		msgBody		= msgBody							& lngMessage & ": " & vbcrlf & pmText
		end select
		'
		'--- send message
		Call cor.mail.send(cor.cfg.item("ReplyAddress"), cor.cfg.item("SenderName"), arrMail(1,0), arrMail(0,0), cor.cfg.item("WebsiteTitle") & ": " & msgHeader, msgBody, 0)
		'cor.butil.emsg = lngPMUnableToSendEmail & "<br />(" & cor.mail.errmsg & ")"
	end sub
	'
	private Function validatePM()
		dim valid_subject,valid_body,valid_toid,valid_frommid
		dim valid_muser,valid_musers,valid_mgroups,validatePmTest
		'
		dim iDo : iDo = cor.filter.checkInt(cor.io.f("do"))
		'
		if len(io_pmSubject) <= 2 then valid_subject = true else valid_subject = false
		if len(io_pmText) <= 8 then valid_body = true else valid_body = false
		if len(io_muser) <= 1 then valid_muser = true else valid_muser = false
		if len(io_musers) <= 1 then valid_musers = true else valid_musers = false
		if len(io_mgroups) <= 1 then valid_mgroups = true else valid_mgroups = false
		'
		'
		Select Case iDo
			case cor_cDoNewPM, cor_cDoNewEmail, cor_cDoNewPMReply
				if valid_muser 		then cor.str.add "$('<label class=""errorfrm error"">" & lngPMrecipientrequired & "</label>').insertAfter('#labmuser');"
				if valid_subject 	then cor.str.add "$('<label class=""errorfrm error"">" & lngPMsubjectrequired & "</label>').insertAfter('#labpmsubject');"
				if valid_body 		then cor.str.add "$('<label class=""errorfrm error"">" & lngPMtextrequired & "</label>').insertBefore('#pmText');"
				'
			case cor_cDoNewPMList, cor_cDoNewEmailList
				select case io_mtype
					case "true"
						if valid_musers		then cor.str.add "$('<label class=""errorfrm error"">" & lngPMrecipientrequired & "</label>').insertAfter('#labmusers');"
					case "false"
						if valid_mgroups 	then cor.str.add "$('<label class=""errorfrm error"">" & lngPMgrouprequired & "</label>').insertAfter('.chkAll');"
				end select
				if valid_subject 	then cor.str.add "$('<label class=""errorfrm error"">" & lngPMsubjectrequired & "</label>').insertAfter('#labpmsubject');"
				if valid_body 		then cor.str.add "$('<label class=""errorfrm error"">" & lngPMtextrequired & "</label>').insertBefore('#pmText');"
				'
			case cor_cDoEditPM
				if valid_subject 	then cor.str.add "$('<label class=""errorfrm error"">" & lngPMsubjectrequired & "</label>').insertAfter('#labpmsubject');"
				if valid_body 		then cor.str.add "$('<label class=""errorfrm error"">" & lngPMtextrequired & "</label>').insertBefore('#pmText');"
				'
		End Select
		'
		validatePmTest=cor.str.build
		'
		If len(validatePmTest)=0 Then
			exit function
		Else
			response.write "<script type=""text/javascript""><!-- <[CDATA["&vbcrlf&"$(document).ready(function(){$('label[class^=errorfrm error]').remove();});"&vbcrlf&"// ]]> --></script>"&vbcrlf
			cor.str.add "<script type=""text/javascript""><!-- <[CDATA["
			cor.str.add "try{"
			cor.str.add validatePmTest
			cor.str.add "	$('form#pm button span').text('" & lngReply & "');"
			cor.str.add "	$('form#pm button').attr('disabled', false);"
			cor.str.add "} catch(e){}"
			cor.str.add "// ]]> --></script>"
			validatePM = cor.str.build
		End If
	End Function
	'
end class
'
'------------------------------------------------------------------------------------------------------------------------------------------
'
' Utility class
'
'------------------------------------------------------------------------------------------------------------------------------------------
class class_pm_utils
	'
	public function checkNewPM()
		dim countPM, arrNewPMs, i_x
		dim pm_ID, pmFrom_ID, pmFrom, pmSubject, pmDate
		dim purr, purrMsgText
		'----------------- 0 ------- 1 -------- 2 -------- 3 --------- 4 ------
		p_sql = "SELECT p.pmId, p.pmFromMid, m.muser, p.pmSubject, p.pmDate " _
			& "FROM " & cor_dbpre & "pm AS p INNER JOIN " & cor_dbpre & "members AS m ON p.pmFromMid = m.MemberID " _
			& "WHERE p.pmToMid={0} AND p.pmStatus={1} " _
			& "ORDER BY p.pmDate DESC"
		cor.dal.open arrNewPMs, p_sql, array(cor_lUserID,0)
		if not cor.butil.eof(arrNewPMs) then
			countPM = ubound(arrNewPMs,2) + 1
			for i_x = 0 to ubound(arrNewPMs,2)
				pm_ID		= arrNewPMs(0,i_x)
				pmFrom_ID	= arrNewPMs(1,i_x)
				pmFrom		= arrNewPMs(2,i_x)
				pmSubject	= arrNewPMs(3,i_x)
				pmDate		= cor.butil.cvLcidTime(arrNewPMs(4,i_x))
				cor.str.adn"<a class=""doModal"" rel=""750:500"" href=""pm_form.asp?do=1&id=" & pm_ID & "&pg=1&rst=1"">" & pmSubject & "</a><br /><span class=""purrPmDate"">" & pmFrom & "<br />" & pmDate & "</span><br />&nbsp;<br />"
			next'purrMsgText	= purrMsgText & 
			
			set purr = new class_Purr
			purr.isNewPm		= "true"
			purr.screenPosition	= "top-right"
			purr.Image			= "NewPM"
			purr.HeaderTxt		= "<a href=""" & cor_sWebroot & "pm_list.asp?do=" & cor_cDoViewPMIn & "&pg=1"">" & cor.lng.GetKey("cor_xmlPM","lngPMInbox") & ": " & countPM & "</a>"
			purr.MessageTxt		= cor.str.build 'purrMsgText
			purr.isSticky		= "true"
			purr.doPurr
			set purr = nothing
		end if
	end function
	'
	private p_sql
end class
'
'<#late-binding hook
function boot_class_pm : boot_class_pm = true : end function
'/>

%>
