﻿<%
'------------------------------------------------------------------------------------------------------------------------------------------
' SOOP 2.0 - Phoenix (TNG)
'
' Revision 2.00 - initial 15/02/2008
'
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'------------------------------------------------------------------------------------------------------------------------------------------

class class_sendmail ':: global, class_baseUtils, class_filters, class_config
	'
	'---  exposes the nature of the error if the e-mail was not sent succesfully 
	public property get errmsg()
		errmsg = p_errDescription
	end property

	public function send(from, fromname, toadress, toname, byref subject, byref body, iUseHTML)
		On error resume next
		'
		dim sType
		dim oMsg, oMsgCfg
		'
		'--- disables this facility from text configuration 
		if NOT cor_cEmailSender Then exit function
		'
		if cor.butil.isEmptyStr(from) Then p_errDescription = "[class_sendmail] No 'from' address" : exit function
		
		'Reverse any &...; codes back to their ASCII equivalent and remove SQLFilter safety values
		subject = cor.filter.ReverseHTMLCode(cor.filter.ReverseHTMLAmpCodes(subject))
		'
		' important to understand is that if the setting is for plain body, 
		' e-mail clients like OE shall display hyperlinks, but NOT if setting is for HTML body
		iUseHTML = cor.filter.checkInt(iUseHTML)
		'
		'Fix improper URL to substitute for relative paths
		'added by charles 26 june 2009 to fix a problem where the cor_sWebRoot was inserted twice into the absolute path.
		dim strPortalURL
		strPortalURL = replace(cor_sPortalDomainPath, cor_swebroot, "", 1, -1, 1)
		if right(strPortalURL,1) <> "/" then strPortalURL = strPortalURL & "/"
		'--- convert relative paths to absolute
		body = replace(body, " src=""/",  " src="""  		& strPortalURL, 1,-1, 1)
		body = replace(body, " href=""/", " href=""" 		& strPortalURL, 1,-1, 1)
		
'		body = replace(body,"src=""","src=""" & cor_sPortalDomainPath,1,-1,1)
		'--- additional formatting depending if plain text or html output requested
		'body = iif(iUseHTML>0, body, cor.filter.stripHTMLTags(body))
		
		'Remove any SQL Filter safety values:
		Body = cor.filter.ReverseHTMLCode(Body)
		'sTitle = cor.filter.ReverseHTMLCode(sTitle)
		if iUseHTML = 0 then	'sending ascii email rather than HTML
			body = cor.filter.StripHTMLTags(Body)		'strip any <> html tags
			cor.filter.ReverseHTMLAmpCodes(subject)		'convert &...; codes to ASCII
		end if
		'
		sType = lcase(cor.cfg.item("EmailComponent"))
		select case sType
				'
			case "cdonts"
				'
				'------------------------------------------
				'		MS CDONTS mail component
				'------------------------------------------
				'
				set  oMsg		 = server.createObject("CDONTS.NewMail")
				with oMsg
					.setLocaleIDs(65001)
					.To			= cstr(toadress)
					.From		= cstr(from & "<"& fromname &">")
					.Subject	= cstr(subject)
					'--- body format is (0=HTML 1=Text)
					if iUseHTML>0 Then
					 .BodyFormat	= 0
					else
					 .BodyFormat	= 1
					end if
					.Body		= cstr(body)
					.Send
				end with
				'
				'--- dispose
				set oMsg = nothing
				'
			case "cdosys", "cdosys_local", "cdosys_pickup", "cdosys_remote"
				'
				'------------------------------------------
				'		MS CDOSYS mail component
				'------------------------------------------
				' credits: http://www.powerasp.com/content/new/sending_email_cdosys.asp
%>
<!--METADATA TYPE="typelib" UUID="CD000000-8B95-11D1-82DB-00C04FB1625D" NAME="CDO for Windows Library" -->
<!--METADATA TYPE="typelib" UUID="00000205-0000-0010-8000-00AA006D2EA4" NAME="ADODB Type Library" --> 
<%
				set oMsg	= server.createObject("CDO.Message") 
				const cdo	= "http://schemas.microsoft.com/cdo/configuration/"
				'
				select case sType
					'
				case "cdosys", "cdosys_local"
					'
					set  oMsgCfg = server.createObject("CDO.Configuration") 
					with oMsgCfg.fields
					.item(cdoSendUsingMethod)			= 2 'cdoSendUsingPort
					.item(cdoSMTPServer)				= trim(cor.cfg.item("SMTPServer"))
					.item(cdoSMTPServerPort)			= trim(cor.cfg.item("SMTPServerPort"))
					.item(cdoSMTPConnectionTimeout)		= 10
					.update
					end with
					'
				case "cdosys_pickup"
					'
					set  oMsgCfg = server.createObject("CDO.Configuration") 
					with oMsgCfg.fields
					.item(cdo&"sendusing")					= 1 'cdoSendUsingPickup
					.item(cdo&"smtpserverpickupdirectory")	= trim(cor.cfg.item("SMTPServerPickupDirectory"))
					.update
					end with
					'
				case "cdosys_remote"
					'
					 with oMsg.configuration.fields
					'--- SendUsingPort. Send the message using the network (SMTP over the network)
					.item(cdo&"sendusing")				= 2 'cdoSendUsingPort
					.item(cdo&"smtpserver")				= trim(cor.cfg.item("SMTPServer"))
					.item(cdo&"smtpserverport")			= trim(cor.cfg.item("SMTPServerPort"))
					.item(cdo&"smtpconnectiontimeout")	= 60
					'--- Use SSL for the connection (True or False)
					.item(cdo&"smtpusessl")				= false
					if  trim(cor.cfg.item("EmailUsername"))	= "" then
						'---  anonymous
						.item(cdo&"smtpauthenticate")	= 0
					else
						'---  basic (clear-text) authentication
						.item(cdo&"smtpauthenticate")	= 1
						.item(cdo&"sendusername")		= trim(cor.cfg.item("EmailUsername"))
						.item(cdo&"sendpassword")		= trim(cor.cfg.item("EmailPassword"))
					end if
					.update
					end with
					'
				end select
				'
				if isObject(oMsgCfg) then set oMsg.Configuration = oMsgCfg 
				with oMsg
					.bodyPart.charset		= "UTF-8" 
					'.Sender				= cstr(from)
					.from					= cstr(from)
					.To						= cstr(toadress)
					'--- set the e-mail body format
					if iUseHTML>0 Then
					'--- HTML is displayed by default, but plain text is displayed whenever HTML is not supported
						.subject				= cstr(subject)
						.htmlBody				= cstr(body)
						.autoGenerateTextBody = true
					else
						.subject				= cstr(subject)
						.textBody				= cstr(body)
					end if
					if cor.cfg.item("SMTPServer") <> "" then .send 
				end with
				'
				'--- dispose
				if isObject(oMsgCfg) then set oMsgCfg = nothing : oMsgCfg = empty
				set oMsg = nothing 
				'
			case "aspemail"
				'
				'-----------------------------------------------------------
				'	Persits AspEmail mail component http://www.aspemail.com/
				'-----------------------------------------------------------
				'This uses Many Permium Options and ensures the mail is sent in UTF-8 format.
				'--- Create the e-mail server object
				set  oMsg = server.createObject("Persits.MailSender")
				with oMsg
					'--- Out going SMTP mail server address
					.Host		= trim(cor.cfg.item("SMTPServer"))
					If trim(cor.cfg.item("SMTPServerPort")) <> "" Then .Port.value = trim(cor.cfg.item("SMTPServerPort"))
					'--- Who the e-mail is from
					.From		= trim(cstr(from))
					.FromName	= trim(.EncodeHeader(cstr(fromname),cor_sCharset))
					'--- Who the e-mail is sent to
					.AddAddress cstr(toadress),cstr(toname)
					'--- The subject of the e-mail
					.Subject	= .EncodeHeader(cstr(subject),cor_sCharset)
					'--- set the e-mail body format
					if iUseHTML>0 Then
						.IsHTML	= true
					end if
					if trim(cor.cfg.item("Emailusername")) <> "" then
						.username	= trim(cor.cfg.item("Emailusername"))
						.password	= trim(cor.cfg.item("EmailPassword"))
					end if
					'--- The main body of the e-mail
					.CharSet		= uCase(cor_sCharset)
					.ContentTransferEncoding = "Quoted-Printable"
					.Body		= cstr(body)
					'--- Send the e-mail
					'cor.str.wri .Host & "<br />"
					'cor.str.wri .From & "<br />"
					'cor.str.wri .FromName & "<br />"
					'cor.str.wri .AddAddress & "<br />"
					'cor.str.wri .Subject & "<br />"
					'cor.str.wri .username & "<br />"
					'cor.str.wri .password & "<br />"
					'cor.str.wri .CharSet & "<br />"
					'cor.str.wri .ContentTransferEncoding & "<br />"
					'cor.str.wri .Body & "<br />"
					.send
				end with
				'
				'--- dispose
				set oMsg = nothing
				'
			case "aspemailfree"
				'
				'-----------------------------------------------------------
				'	Persits AspEmail mail component http://www.aspemail.com/
				'-----------------------------------------------------------
				' This doesn't use any Premium Version Options to avoid and invalid key error.
				'--- Create the e-mail server object
				set  oMsg = server.createObject("Persits.MailSender")
				with oMsg
					'--- Out going SMTP mail server address
					.Host		= trim(cor.cfg.item("SMTPServer"))
					If cor.cfg.item("SMTPServerPort") <> "" Then .Port = trim(cor.cfg.item("SMTPServerPort"))
					'--- Who the e-mail is from
					.From		= cstr(from)
					.FromName	= cstr(fromname)
					'--- Who the e-mail is sent to
					.AddAddress cstr(toadress),cstr(toname)
					'--- The subject of the e-mail
					.Subject	= str(subject)
					'--- set the e-mail body format
					if iUseHTML>0 Then
						.IsHTML	= true
					end if
					'--- The main body of the e-mail
					.Body		= cstr(body)
					'--- Send the e-mail
					.send
				end with
				'
				'--- dispose
				set oMsg = nothing
				'
		case "w3jmail"
				'
				'-------------------------------------------------------------------------------------------------------------------
				'	w3 JMail mail component    http://www.dimac.net/default2.asp?M=Products/MenuCOM.asp&P=Products/w3JMail/start.htm
				'-------------------------------------------------------------------------------------------------------------------
				'This 
				set oMsg		= server.createObject("JMail.Message")
				with oMsg
					.Logging	= true
					.silent		= true
					.From		= cstr(from)
					.FromName	= cstr(fromname)
					.AddRecipient cstr(toadress), cstr(toname)
					.Subject	= cstr(subject)
					.Charset	= cor_sCharset
					'--- set the e-mail body format (BodyHTML=HTML Body=Text)
					if iUseHTML>0 Then
						.HTMLBody	= cstr(body)
					else
						.Body		= cstr(body)
					end if
					if trim(cor.cfg.item("Emailusername")) <> "" then
						.MailServeruserName = trim(cor.cfg.item("Emailusername"))
						.MailServerPassword = trim(cor.cfg.item("EmailPassword"))
					end if
					'--- Importance of the e-mail
					.Priority	= 3
					'--- Send the e-mail
					'.execute
					.send(trim(cor.cfg.item("SMTPServer")))
				end with
				'
				'--- dispose
				set oMsg = nothing
				'
			case else
				'
				err.clear
				err.raise vbObjectError+1, "[class_sendmail]", "Unsupported mail component [" & cor.cfg.item("EmailComponent") &"]. Check SooP configuration"
		end select
		'
		'--- if no errors return success as true
		if  err.number <> 0 Then 
			p_errDescription = err.description
			send = false 
		else 
			send = true
		end if
		err.clear
		On error goto 0
	end function
	'
	private p_errDescription
	'
end class

'<#late-binding hook
function boot_class_sendmail : boot_class_sendmail = true : end function
'/>

%>
