<%
'------------------------------------------------------------------------------------------------------------------------------------------
' SOOP 2.0 - Phoenix (TNG)
'
' Revision 2.00 - initial 15/02/2008
'
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'------------------------------------------------------------------------------------------------------------------------------------------
%>
<%
class class_sqlbuilder ':: global, class_filters, (class_string)
	'
    '------------------------------------------------------------------------------------------------------------------------------------------
    '
    ' SQL builder, for easing complex sql statement and element array creation for SELECT, INSERT and UPDATE operations
	' 
    '------------------------------------------------------------------------------------------------------------------------------------------
	'
	' public attributes
	'
	public  oLov
	public  oSql
	public  oVal
	'
	private str 
	private i, imax
	private p_iSize
	private p_exclude
	private p_iActionSql
	'	
	public property get exclude()
		exclude = p_exclude
	end Property
	'
	public property let exclude(byVal field)
		dim afield, i
		'
		'--- normalize
		field  = replace(field, " ", "")
		afield = split(field, ",")
		field  = "||"
		for i = 0 to ubound(afield)
			field = field & afield(i) & "||"
		next	
		p_exclude = field
	end Property
	'	
	public property let growSize(size)
		p_iSize   = size
	end Property
	'
	private sub class_initialize
		set str   = new class_string
		p_iSize   = 10
	end sub
	'
	private sub class_terminate
		if isObject(oLov) then set oLov = nothing : oLov = empty
		set str   = nothing
	end sub
	'	
	public sub init(iActionSql)
		if NOT isObject(oLov) then set oLov = server.createObject("scripting.dictionary") else oLov.removeAll
		set oSql 	 = new class_sqlbuilder_util
		set oVal 	 = new class_sqlbuilder_util
		oSql.sz	 	 = p_iSize
		oVal.sz	 	 = p_iSize
		p_iActionSql = iActionSql
		str.clear
	end sub
	'
	public sub addio(sqlparam, fval, ioparam, typ)
		'
		'--- exclude desired fields
		if instr(lcase(exclude), "||" & lcase(sqlparam) & "||") >0 then exit sub
		'--- also exclude autoincrement fields for insert/update operations
		if p_iActionSql <> cor_cSelect AND typ = cor_cAut then exit sub
		'
		' add to array to build sql query later
		' e.g. "Members.MemberID"
		'
		oSql.add sqlparam
		'
		' add to collection to populate class attributes later
		' e.g. cor.members.io_mid||cor_cLng, cor.io.f("mid")
		'
		oLov.add ioparam&"||"&typ, fval
	end sub
	'
	public sub buildio(aDataSet, iFillSrc)
        dim aKeys, aItems, i
        dim ioparam, typ, fval, ioval
        '
        aKeys  = oLov.keys	'ioparam||typ
        aItems = oLov.items	'fval
        '
        '--- if passed array was empty recreate as an empty one to allow a balanced loop
        if cor.butil.eof(aDataSet) Then redim aDataSet(ubound(aKeys),0)
        if ubound(aDataSet) <> ubound(aKeys) then cor.stopper("[ERR:class_sqlbuilder] arrays do not match")	
        '
        for i=0 to ubound(aKeys)
        	ioparam = split(aKeys(i),"||")(0)
        	typ		= split(aKeys(i),"||")(1)
        	fval	= aItems(i)
        	'
        	'--- get current value (if any) of class attribute
        	execute("ioval = " & ioparam) 
        	'
        	' choose from where to populate class param
        	' e.g. execute("cor.member.io_mid") = (typed) fval OR arr OR self 
        	'
        	'On error resume next
        	select case iFillSrc
        	case cor_cForm
        		ioval = cor.filter.iift(fval, "", typ)
        	case cor_cSql
        		ioval = cor.filter.iift(aDataSet(i,0), "", typ)
        	case cor_cAttr
        		ioval = cor.filter.iift(ioval, "", typ)
        	case cor_cForm1Sql2
        		ioval = cor.filter.iift(fval, aDataSet(i,0), typ)
        	case cor_cSql1Form2
        		ioval = cor.filter.iift(aDataSet(i,0), fval, typ)
        	case cor_cAttr1Form2
        		ioval = cor.filter.iift(ioval, fval, typ)
        	case cor_cAttr1Sql2
        		ioval = cor.filter.iift(ioval, aDataSet(i,0), typ)
        	case cor_cForm1Attr2
        		ioval = cor.filter.iift(fval, ioval, typ)
        	case cor_cSql1Attr2
        		ioval = cor.filter.iift(aDataSet(i,0), ioval, typ)
        	end select
        	'
        	'--- populate class attribute back
        	execute(ioparam & " = ioval") 
        	'
        	' also populate the value's array for the sql query in the same loop, 
        	' to ensure SQL and value array indexes are in-sync
        	'
			oVal.add ioval
			'
			if err.number <>0 then cor.stopper("[ERR:class_sqlbuilder] " & err.description & ": '" & ioparam & "'" )
			On error goto 0
    	next
	end sub
	'
	public function buildSelect(tblName)
		'This is only used by class_members.asp!
        dim tmp
        '
        '--- create SELECT SQL statement
        imax = oLov.count-1
        str.adn "SELECT "
        for i = 0 to imax
			str.adn cor_dbpre
			str.adn oSql.aFields(i)
			str.adn ","
        next
        '--- get rid of last element's comma
        tmp = str.build
        tmp = left(tmp, len(tmp)-1)
        str.adn tmp
        str.adn " FROM "
        str.adn cor_dbpre
        str.adn tblname
        str.adn " "
		'
        buildSelect = str.build
	end function
	'
	public function buildInsert(tblName)
        'This is only used by class_members.asp!
        '--- create INSERT SQL statement
        imax = oLov.count-1
        str.adn "INSERT INTO " 
        str.adn cor_dbpre 
        str.adn tblname 
        str.adn " ("
        for i = 0 to imax-1
        	'--- get rid of dot notation if present
			str.adn nodot(oSql.aFields(i)) & ","
        next
        '--- add last element with no comma
        str.adn nodot(oSql.aFields(imax))
		'
		str.adn ") VALUES ("
        for i = 0 to imax-1
			str.adn "{" 
			str.adn i 
			str.adn "},"
        next
        '--- add last element with no comma
        str.adn "{" 
        str.adn imax
        str.adn "}) "						
        '
        buildInsert = str.build
	end function	
	'
	public function buildUpdate(tblName)
	'This is only used by class_members!
        '
        '--- create UPDATE SQL statement and array
        imax = oLov.count-1
        str.adn "UPDATE " 
        str.adn cor_dbpre 
        str.adn tblname 
        str.adn " SET "
        for i = 0 to imax-1
			str.adn nodot(oSql.aFields(i)) 
			str.adn "={" 
			str.adn i 
			str.adn "},"
        next
        '--- add last element with no comma
        str.adn nodot(oSql.aFields(imax))
        str.adn "={" 
        str.adn imax
        str.adn "} "	
		'
		buildUpdate = str.build
	end function	
	'
	' add table prefix when required
	'
	public function prefixTable(byref ssql)
    	regEx.ignoreCase  = true
    	regEx.global 	  = true	
		regEx.pattern 	  = "([\s\t])((?!"&cor_dbpre&")[a-z]*?\.[a-z])"
    	prefixTable	  	  = regEx.replace(ssql, "$1"&cor_dbpre&"$2$3")
	end function		
	'
	'--- get rid of table fields dot notation (cannot use iif here)
	private function nodot(fieldname)
		if instr(fieldname, ".") > 0 then nodot = split(fieldname, ".")(1) else nodot = fieldname
	end function
	'
end class
'
class class_sqlbuilder_util
	public afields
	public sz
	public cnt
	'
	public sub add(byref field)
		if  cnt >= ubound(afields) then
			'--- for performance reasons we resize the array on sz
			redim preserve afields(ubound(afields) + sz)
		end if
		afields(cnt) = field	' e.g. "Members.mid"
		cnt = cnt + 1			' counter of the number of fields already into the query
	end sub
	'
	private sub class_initialize
		sz  = 10
		redim afields(sz)
		cnt = 0
	end sub
	'
end class
'
'<#late-binding hook
function boot_class_sqlbuilder : boot_class_sqlbuilder = true : end function
'/>
%>
