/* =========================================================================
JavaScript Source File -- Created with SAPIEN Technologies PrimalScript 4.1

NAME: Inline edit init

AUTHOR: Ph4nt0m ,
DATE  : 15/09/2008

COMMENT: Inline edit init script for SooP Phoenix
============================================================================ */

$(document).ready(function() {
	$.fn.tinymce = function(options){
		return this.each(function(){
			tinyMCE.execCommand("mceAddControl", true, this.id);
		});
	}

	function initMCE(){
		tinyMCE.init({
			mode : "none",
			theme : "advanced",
			theme_advanced_toolbar_location : "top",
			theme_advanced_toolbar_align : "left",
			theme_advanced_statusbar_location : "bottom",
			theme_advanced_buttons1 : "bold,italic,underline,strikethrough,separator,bullist,numlist,undo,redo,link,unlink,image,code",
			theme_advanced_buttons2 : "",
			theme_advanced_buttons3 : "",
			content_css: cor_sSkinPath+"boodata.rtf.css",
			theme_advanced_resize_horizontal: false,
			paste_use_dialog: true,
			paste_auto_cleanup_on_paste: true,
			convert_fonts_to_styles: false,
			remove_linebreaks: false,
			inline_styles: true,
			accessibility_warnings: false,
			accessibility_focus: false,
			apply_source_formatting: false,
			forced_root_block: false,
			entity_encoding: "raw",
			dialog_type: "modal",
			extended_valid_elements: "td[class|align|width],tr[class|align|width],a[name|href|target|title|onclick],img[class|src|border=0|alt|title|hspace|vspace|width|height|align|onmouseover|onmouseout|name|obj|param|embed],font[face|size|color]",
			theme_advanced_resizing : true
			});
		}
	
	initMCE();

	$.editable.addInputType('mce', {
		element : function(settings, original) {
			var textarea = $('<textarea id="'+$(original).attr("id")+'_mce"/>');
			if (settings.rows) {
				textarea.attr('rows', settings.rows);
			} else {
				textarea.height(settings.height);
			}
			if (settings.cols) {
				textarea.attr('cols', settings.cols);
			} else {
				textarea.width(settings.width);
			}
			$(this).append(textarea);
				return(textarea);
			},
		plugin : function(settings, original) {
			tinyMCE.execCommand("mceAddControl", true, $(original).attr("id")+'_mce');
			},
		submit : function(settings, original) {
			tinyMCE.triggerSave();
			tinyMCE.execCommand("mceRemoveControl", true, $(original).attr("id")+'_mce');
			},
		reset : function(settings, original) {
			tinyMCE.execCommand("mceRemoveControl", true, $(original).attr("id")+'_mce');
			original.reset();
		}
		});
	});

$(document).ready(function() {
$(function(){
	$('#edittopic').tinymce();
	$(".edittopic").editable('fora_postback.asp',{
		type : "mce",
		submit : "<input type='submit' class='frmButton' value='Submit' />",
		cancel : "<input type='reset' class='frmButton' value='Cancel' />",
		indicator : "<img src='<%= cor_sSkinImg %>loading.gif' width='15' border='0'/>",
		tooltip : "Double click to edit...",
		width : "100%",
		submitdata : {type : "t"},
		height : "250px",
		cssclass : "inherit",
		event : "dblclick"
		});
});
$(function(){
	$('#editpost').tinymce();
	$(".editpost").editable('fora_postback.asp', {
		type : "mce",
		submit : "<input type='submit' class='frmButton' value='Submit' />",
		cancel : "<input type='reset' class='frmButton' value='Cancel' />",
		indicator : "<img src='<%= cor_sSkinImg %>loading.gif' width='15' border='0'/>",
		tooltip : "Double click to edit...",
		width : "100%",
		submitdata : {type : "p"},
		height : "250px",
		cssclass : "inherit",
		event : "dblclick"
		});
});
$(function(){
	$(".edittitle").editable('fora_postback.asp', {
		indicator : "<img src='<%= cor_sSkinImg %>loading.gif' width='15' border='0'/>",
		tooltip : "Double click to edit...",
		submitdata : {type : "tt"},
		cssclass : "frmText",
		submit : "<input type='submit' class='frmButton' value='Submit' />",
		cancel : "<input type='reset' class='frmButton' value='Cancel' />",
		event : "dblclick"
		});
});
});