﻿<!--#include file="db/_soop_pageglobal.asp" -->
<!--#include file="common.asp" -->
<%
'----------------------------------------------------------------------------------------------------------------------------------------
' SOOP 2.0 - Phoenix (TNG)
'
' Revision 2.00 - initial 15/02/2008
'
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'----------------------------------------------------------------------------------------------------------------------------------------
'----------------------------------------------------------------------------------------------------------------------------------------
' variables - SQL statement and initialisation
'
if NOT cor_bAdmin Then cor.redir "./"
'
call cor.tpl.init("mgmt")
call cor.tpl.header(lngMgmtConfiguration,"")								'header and surrounding MOD boxes, CSS, javascripts etc...
dim blnFullText		:	blnFullText = false
dim arrTables(10,4)	: 	DoFillTables
'arrTables(x, 0) = table name, 1 = pk, 2 = columns to index, 3 = index name
cor.modbox.printBoxTop
call mgmt_doBuild()										'content - via function
cor.modbox.printBoxBottom
call cor.tpl.footer()									'closing MOD boxes and footer
call cor.off()

sub mgmt_doBuild
	select case lcase(cor_sDatabaseType)
	case "mysql"
		DoMySQL
	case "mssql"
		doMSSQL
	case else			'"access"
		'	sql = replace(sql, "SELECT", "SELECT TOP "& rows, 1,-1, 1)
	end select

end sub

sub DoFillTables
	'These tables reflect the tables and columns we will be searching on.
	arrTables(0,0) = cor_dbpre & "doc"
	arrTables(0,1) = "doc_id"
	arrTables(0,2) = "doc_content, doc_display"
	
	arrTables(1,0) = cor_dbpre & "documents"
	arrTables(1,1) = "Page_ID"
	arrTables(1,2) = "page_name, Page_Main_Heading, Page_Second_Heading, Page_Content, Page_Bottom_Text"

	arrTables(2,0) = cor_dbpre & "faq"
	arrTables(2,1) = "faqid"
	arrTables(2,2) = "faqQuestion, faqAnswer"
	
	arrTables(3,0) = cor_dbpre & "faqcomments"
	arrTables(3,1) = "fcoCommentsID"
	arrTables(3,2) = "fcoComments"
	
	arrTables(4,0) = cor_dbpre & "gh_headlines"
	arrTables(4,1) = "Headline_ID"
	arrTables(4,2) = "Article, Title"
	
	arrTables(5,0) = cor_dbpre & "guestbook"
	arrTables(5,1) = "ID"
	arrTables(5,2) = "Comments"
	
	arrTables(6,0) = cor_dbpre & "polls"
	arrTables(6,1) = "poid"
	arrTables(6,2) = "poquestion, poanswer"	

	arrTables(7,0) = cor_dbpre & "topics"
	arrTables(7,1) = "tid"
	arrTables(7,2) = "ttitle, tbody"	
	
	arrTables(8,0) = cor_dbpre & "posts"
	arrTables(8,1) = "pid"
	arrTables(8,2) = "pbody"
end sub
'-----------------------------
'	This sub sets up MySQL to perform full-text searches.  Notice how much easier this is than MS-SQL?! ;-)
'-----------------------------
sub doMySQL
	on error resume next
	dim x 
	dim sql
	cor.str.wri "<p>Generating Full Text Indexes on tables.</p>"
	for x = 0 to ubound(arrTables,1)
		if len(arrTables(x,0)) > 1 and not isnull(arrTables(x,0)) then
			sql = "ALTER TABLE " & 	arrTables(x,0) & " ADD FULLTEXT(" & arrTables(x,2) & ") "
			cor.dal.exec sql, array()
		end if
	next
	cor.str.wri "<p>done!</p>"
end sub
'-----------------------------
'	These subs all form the MS SQL setup commands.
'-----------------------------
sub doMSSQL			'test to see if MS SQL will support full-text searches.		If so, set it up.
	on error resume next
	cor.str.wri "<p>Testing to see if your MS SQL database allows full-text indexing.</p>"
	dim arrResults, sql
	sql = "SELECT DATABASEPROPERTY('" & cor_sSqlDbName  & "', 'IsFullTextEnabled')"
	cor.dal.open arrResults, sql, array()	' Returns 1 if engine allows full text.
	if isnumeric(arrResults(0,0)) then
		if cint(arrResults(0,0)) = 1 then
			blnFullText = true
		end if
	end if
	'	can we continue?
	if blnFullText = false then
		cor.str.wri "<p><em>Contact your ISP to have them enable full-text indexing for efficient searches.</em>/p>"
		exit sub	'we can't do full-text queries
	end if
	'
	cor.str.wri "<p> - Building full-text catalog.</p>"
	cor.dal.exec "CREATE FULLTEXT CATALOG ftc_" & cor_dbPre & "PhoenixSearchCatalog", array()
	cor.str.wri "<p> - - Finding Primary Key indexes from searchable tables.</p>"
	GetMSSQLIndexName
	cor.str.wri "<p> - - - Generating Full Text Indexes on tables.</p>"
	MakeMSSQLIndexes
	cor.str.wri "<p>Done!</p>"

end sub
sub GetMSSQLIndexName()
	'for each table to index, we need the the PK Index name
	dim x
	dim sql
	dim ar
	sql = "	SELECT DISTINCT SI.name AS IndexName, SC.name, SI.type " & _
			"  FROM sys.indexes SI WITH (NOLOCK) " & _
			" INNER JOIN sys.columns SC WITH (NOLOCK)  ON  SI.object_id = SC.object_id " & _
			" INNER JOIN sys.index_columns SIC WITH (NOLOCK)  ON SI.index_id = SIC.index_id AND SC.column_id = SIC.column_id " & _
			" WHERE SC.object_id = (SELECT object_ID({0})) " & _
			"   AND SI.type = 1 " & _
			"   AND SC.name = {1} "
	'response.write "<hr />" & sql & "<br />" & arrTables(x,0)& "<br />" & arrTables(x,1)
	'response.flush
	'arrTables(x, 0) = table name, 1 = pk, 2 = columns to index, 3 = index name
	for x = 0 to ubound(arrTables,1)
		If len(arrTables(x,0)) > 1 AND not isnull(arrTables(x,0)) then
			cor.dal.open ar, sql, array(arrTables(x,0), arrTables(x,1) )
			arrTables(x,3) = ar(0,0)
		end if
	next
end sub
sub MakeMSSQLIndexes()
	on error resume next
	'create indexes from arrTables(x,4)
	'	arrTables(x, 0) = table name, 1 = pk, 2 = columns to index, 3 = index name
	'CREATE FULLTEXT INDEX ON aDoc (doc_content) KEY INDEX PK__aDoc__3118447E ON ftc_PhoenixSearchCatalog WITH CHANGE_TRACKING AUTO;
	dim sql, X
	
	For x = 0 to Ubound(arrTables,1)
		If len(arrTables(x,0)) > 1 AND not isnull(arrTables(x,0)) then
			sql = "CREATE FULLTEXT INDEX ON  " & arrTables(x,0) & "(" & arrTables(x,2) & _
				") KEY INDEX " & arrTables(x,3) & " ON ftc_" & cor_dbPre & "PhoenixSearchCatalog WITH CHANGE_TRACKING AUTO"
			cor.dal.exec sql, array( )
		end if
	next
end sub	


%>