﻿<%
'------------------------------------------------------------------------------------------------------------------------------------------
' SOOP 2.0 - Phoenix (TNG)
'
' Revision 2.00 - initial 15/02/2008
'
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'------------------------------------------------------------------------------------------------------------------------------------------

class class_calendar ':: global, class_string, class_filters, class_utils

	public CalendarCellSize
	public LargeCellHeight
	public CalendarType
	public weekStartDay
	public BlankDayCSS
	public TodayCSS
	public WeekDayCSS
	public WeekEndCSS
	public PastDayCSS
	public EventCSS
	public HoverCSS
	public currentDate
	public currentDay
	public currentMonth
	public currentYear
	public cor_cGlobalLCID
	public cor_cCalendarLCID
	public CalendarFooter
	public CalendarHeader
	public CalendarFooterText
	public CalendarHeaderText
	public mediaObjectType
	public mediaObjectWidth
	public mediaObjectHeight
	public MediaPath
	public mediaObjectURL
	public useMedia
	public dayLink
	public withLinks
	public useFlashClock
	public srcFlashClock
	public widthFlashClock
	public heightFlashClock
	public drawMainBorder
	public MainBorderColor
	public paddRows
	public blnEnableEvents
	public eventType
	public strCalendar
	'
	private Location
	private printMonth
	private dayEvents
	private blnEvents

	private sub class_initialize()
		CalendarCellSize 	= 25
		LargeCellHeight 	= 25
		CalendarType 		= "small"
		weekStartDay 		= 1
		BlankDayCSS 		= "noDay"
		TodayCSS 			= "CurrentDay"
		WeekDayCSS 			= "FutureDay"
		WeekEndCSS 			= "WeekendDay"
		PastDayCSS 			= "PastDay"
		EventCSS 			= "EventDay"
		HoverCSS 			= "hoverDay"
		cor_cGlobalLCID 	= cor_cGlobalLCID
		cor_cCalendarLCID 	= cor_cCalendarLCID
		Location 			= trim(cor_sScriptName)
		currentDate 		= Now()
		currentDay 			= Day(now())
		currentMonth 		= Month(now())
		currentYear 		= Year(now())
		CalendarFooter 		= false
		CalendarHeader 		= false
		mediaObjectType 	= empty
		mediaObjectURL 		= empty
		mediaObjectWidth 	= "0"
		mediaObjectHeight 	= "0"
		dayLink 			= "calendar.asp?mode=list"
		withLinks 			= true
		useFlashClock 		= false
		useMedia 			= false
		drawMainBorder 		= false
		paddRows 			= false
		MediaPath 			=	"/uploads/assets/calendar/"
		blnEvents 			= false
		blnEnableEvents 	= false
		eventType 			= "small"
		'
		set str = new class_string
	end sub

	public property get cellHeight()
		select case CalendarType
			case "large"
				cellHeight = LargeCellHeight 
			case else
				cellHeight = CalendarCellSize
		end select
	end property

	public property get FirstDayLocation()
		FirstDayLocation = FirstDayPos(currentMonth, currentYear)
	end property

	public property get NextMonth()
		NextMonth = DateSerial(currentYear, currentMonth + 1, 1)
	end property

	public property get PreviousMonth()
		PreviousMonth = DateSerial(currentYear, currentMonth - 1, 1)
	end property

	public property get DaysInCurrMonth()
		DaysInCurrMonth = DaysInMonth(currentMonth,currentYear)
	end property

	public property get NextYear()
		NextYear = currentYear + 1
	end property

	public property get PreviousYear()
		PreviousYear = currentYear -1
	end property

	public sub PrintCalendar()
		CalendarType = Lcase(CalendarType)
		if isValid(currentDay,1,31) Then
			currentDay = cor.filter.checkInt(currentDay)
		else
			currentDay = Day(now())
		end if
		if isValid(currentMonth,1,12) Then
			currentMonth = cor.filter.checkInt(currentMonth)
		else
			currentMonth = Month(now())
		end if
		currentYear = cor.filter.checkInt(currentYear)
		if currentYear = 0 Then
			currentYear = year(now())
		end if
		if isValid(weekStartDay,1,7) Then
			weekStartDay = cor.filter.checkInt(weekStartDay)
		else
			weekStartDay = 1
		end if
		if Not isDate(dateserial(currentYear,currentMonth,currentDay)) Then
			currentMonth = month(now())
			currentDay = day(now())
			currentYear = year(now())
		end if
		select case CalendarType
			case "large"
				if calendarHeader then call PrintCalendarHeader()
				str.add "<dl class=""Calendar"">"
				'call PrintLargeCalTopHeader(currentMonth, currentYear)
				call PrintCalTopHeader(currentMonth, currentYear, true)
				call printCalDayNames()
				call PrintCalDays()
				str.add "</dl>"
				strCalendar = str.build
			case else
				if calendarHeader then call PrintCalendarHeader()
				str.add "<dl class=""soop Calendar smCalendar"">"
				'call PrintsmallCalTopHeader(currentMonth, currentYear)
				call PrintCalTopHeader(currentMonth, currentYear, False)
				call printCalDayNames()
				call PrintCalDays()
				'str.add "</dl>"
				if useFlashClock Then call printClock()
				if CalendarFooter Then call PrintSmallCalBotHeader()
				str.add "</dl>"
				strCalendar = str.build
		end select
	end sub

	private sub PrintCalTopHeader(iMonth, iYear, isLarge)
		session.LCID = cor_cCalendarLCID
		if not isLarge then
			dim largeTable, colAlign
			if useMedia Then printMedia()
		end if
		str.add "<dt>"
		str.add MonthName(iMonth)
		str.add " &nbsp;"
		str.add iYear
		str.add "</dt>"
		session.LCID = cor_cGlobalLCID
	end sub

'	private sub PrintSmallCalTopHeader(iMonth, iYear)
'		session.LCID = cor_cCalendarLCID
'		dim largeTable, colAlign
'		if useMedia Then printMedia()
'		str.add "<dt>"
'		str.add MonthName(iMonth)
'		str.add " &nbsp;"
'		str.add iYear
'		str.add "</dt>"
'		session.LCID = cor_cGlobalLCID
'	end sub
'
'	private sub PrintLargeCalTopHeader(iMonth, iYear)
'		session.LCID = cor_cCalendarLCID
'		str.add "<dt>"
'		str.add MonthName(iMonth)
'		str.add "&nbsp;"
'		str.add iYear
'		str.add "</dt>"
'		session.LCID = cor_cGlobalLCID
'	end sub

	private sub PrintSmallCalBotHeader
		str.add "<dt class=""footer"">"
		str.add CalendarFooterText
		str.add "</dt>"
		'str.add "<dl class=""Calendar""><dt>"
		'str.add CalendarFooterText
		'str.add "</dt></dl>"
	end sub
	
	private sub PrintCalendarHeader
		if usemedia then
			str.add "<dl class=""Calendar""><dt>"
			str.add CalendarHeaderText
			str.add "</dt></dl>"
		end if
	end sub

	private sub printMedia()
		if Not isempty(mediaObjectType) Then
			'response.write mediaObjectType & "-" & mediaPath & "-" & mediaObjectURL & "-" & cor_bFsoEnable
			select case mediaObjectType
				case "swf"
					'str.add "<div class=""center"">"
					str.add cor.util.displayFlash(mediaPath & mediaObjectUrl,mediaObjectHeight,mediaObjectWidth,true)
					'str.add "</div>"
				case else
					str.add "<dd class=""img center"">"
					str.adn "<img alt=""Calendar"" src="""
					str.adn mediaPath
					str.adn mediaObjectUrl
					str.adn """ /></dd>"
			end select
		end if
	end sub

	private sub printClock()
		if Not isempty(srcFlashClock) Then
			str.adn "<dd class=""clock"">"
			str.adn cor.util.displayFlash(mediaPath & srcFlashClock,heightFlashClock,widthFlashClock,true)
			str.add "</dd>"
		end if
	end sub

	private sub printCalDayNames()
		dim DayCount, calAbbr : calAbbr = false
		if CalendarType = "small" then calAbbr = true
		session.LCID = cor_cCalendarLCID
		for DayCount = 1 to 7
			str.add "<dd class=""days"">"
			str.add WeekDayName(DayCount, calAbbr, weekStartDay)
			str.add "</dd>"
		Next
		session.LCID = cor_cGlobalLCID
	end sub

	private sub PrintCalDays()
		session.LCID = cor_cCalendarLCID
		dim eventCount : eventCount = 0
		dim countDays  : countDays	= 0
		dim colCount   : colCount	= 0
		dim rowCount   : rowCount	= 0
		dim dayclass   : dayclass	= WeekDayCSS
		dim hoverDay   : hoverDay	= HoverCSS
		While countDays < DaysInCurrMonth
			for colCount = 1 to 7
				countDays = countDays + 1
				if countDays > DaysInCurrMonth then
					if colCount > 1 then
						call pad(7-colCount+1)
					end if
					exit for
				else
					if countDays <= 1 then
						call pad(FirstDayLocation -1)
						colCount = colCount + FirstDayLocation -1
					end if
					if isWeekend(countDays, currentMonth, currentYear) Then
						dayclass = WeekEndCSS
						hoverDay = HoverCSS
					else
						dayclass = WeekDayCSS
						hoverDay = HoverCSS
					end if
					if isToday(countDays,	currentMonth, currentYear) Then
						dayclass = TodayCSS
						hoverDay = TodayCSS
					elseif dayclass = WeekDayCSS And countDays < day(now()) And currentMonth = Month(now()) And currentYear = Year(now()) Then
						dayclass = PastDayCSS
						hoverDay = HoverCSS
					end if
					if blnEnableEvents and eventType = "year" Then
						if Not blnEvents Then initDayEvents()
						if dayEvents.Exists(countDays) then dayclass = EventCSS
					end if
					if withLinks Then
						str.add "<dd class=""day "
						str.adn dayClass
						str.adn """><a href="""
						str.adn dayLink
						str.adn "&amp;qday="
						str.adn countDays
						str.adn "&amp;qmonth="
						str.adn currentMonth
						str.adn "&amp;qyear="
						str.adn currentYear
						str.adn """>"
						str.adn paddDays(countDays)
						str.add "</a></dd>"
					else
						str.adn "<dd class=""day "
						str.adn dayClass
						str.add """>"
						str.adn paddDays(countDays)
						str.add "</dd>"
					end if
					if blnEnableEvents and eventType = "small" Then
						if Not blnEvents Then initDayEvents()
						if dayEvents.Exists(countDays) Then str.add dayEvents.item(countDays)
					end if
				end if
			Next
			rowCount = rowCount + 1
		Wend
		if rowCount = 4 and paddRows Then
			call pad(7)
			call pad(7)
		elseif rowCount < 6 and	paddRows Then
			call pad(7)
		end if
		session.LCID = cor_cGlobalLCID
	end sub

	private function FirstDayPos(iMonth, iYear)
		FirstDayPos = weekday(MonthName(iMonth) & " " & 01 & ", " & iYear, weekStartDay)
	end function

	sub pad(ipad)
		dim counter
		for counter = 1 to ipad
			str.adn "<dd class="""
			str.adn BlankDayCSS
			str.add """>&nbsp;</dd>"
		Next
	end sub

	private function isWeekend(iDay,iMonth,iYear)
		select case weekday(MonthName(iMonth) & " " & iDay & ", " & iYear)
			case 1,7
				isWeekend = true
			case else
				isWeekend = false
		end select
	end function

	private function isToday(iDay,iMonth,iYear)
		select case dateDiff("d", day(now()) & "-" & Month(now()) & "-" & Year(now()), iDay & "-" & iMonth & "-" & iYear)
			case 0
				isToday = true
			case else
				isToday = false
		end select
	end function

	private function DaysInMonth(iMonth,iYear)
		DaysInMonth = Day(DateAdd("d", -1, DateSerial(iYear, iMonth + 1, 1)))
	end function

	private function isValid(sDate,vLow,vHigh)
		if (Not isNumeric(sDate)) Or (len(trim(sDate)) = 0) Then
			isValid = false
			exit function
		end if
		if (cor.filter.checkInt(sDate) < vlow) Or (cor.filter.checkInt(sDate) > vHigh) Then
			isValid = false
			exit function
		end if
		isValid = true
	end function

	private function paddDays(whichDay)
		select case whichDay < 10
			case true
				paddDays = "0" & cstr(whichDay)
			case else
				paddDays = whichDay
		end select
	end function
	
	private sub initDayEvents()
		set dayEvents = server.createObject("Scripting.Dictionary")
		blnEvents = true
	end sub

	public sub AddDayEvents(thisEvent,thisDay)
		if Not blnEvents Then initDayEvents()
		if dayEvents.Exists(thisDay) Then
			dayEvents.item(thisDay) = dayEvents.item(thisDay) + thisEvent
		else
			dayEvents.Add thisday, thisEvent
		end if
	end sub
	'
	private sub class_terminate()
		if  isObject(dayEvents) Then
			dayEvents.RemoveAll()
			set dayEvents = nothing
		end if
		set str = nothing
	end sub
	'
	private str	
end class

'<#late-binding hook
function boot_class_calendar : boot_class_calendar = true : end function
'/>

%>
