<%
'------------------------------------------------------------------------------------------------------------------------------------------
' SOOP 2.0 - Phoenix (TNG)
'
' Revision 2.00 - initial 15/02/2008
'
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'------------------------------------------------------------------------------------------------------------------------------------------
%>
<%
'*************************************
'***
'*** CLIB Library v1.4 [11/Oct/04] 
'*** by Alex Campbell (alx359)
'***

'***
'*** Definitions
'***
'----------------------------------------------------------------------------
dim clib  : set clib  = new class_common : clib.init()
dim cg_dyn : set cg_dyn = new class_dynMod

'* if SooP server is behind a proxy or firewall you must configure it
'* to allow class_cache tunneling to external links
'* Format:
'* clib.cache.proxySettings	= "<PROXY_IP:PROXY_PORT>"

'clib.cache.proxySettings 	= "192.168.0.1:80"

'* Relative path from SooP root to store your cache files 
'* (R/W permission required. Add last / slash)

clib.cache.directory = "_cache/"

'* recache (repopulate cache) if server restarts (default false)

clib.cache.recache = false

'* stops all time/CPU consuming scheduled activities

clib.debug = false

'****************************************************************************
'*** 
'*** Libraries
'*** 

'***
'*** ADO 2.5 DLL constants 
'*** (Could be added to global.asa instead)
'***
%><!-- METADATA TYPE="typelib" UUID="00000205-0000-0010-8000-00AA006D2EA4"' NAME="ADODB Type Library" --><%

'* CLIB namespace

class class_common

	public utils
	public cache
	public thumbs

	'* library debug mode
	public property let debug(s)
		cache.debug = s
		thumbs.debug = s
		ldebug = s
	end property

	public property get debug
		debug = ldebug
	end property
	

	public sub init()
		set utils = new class_utils
		set cache = new class_cache
		set thumbs = new class_thumbs
	end sub


	private sub class_initialize()
		ldebug = false
	end sub

	private sub class_terminate() 
		set utils = nothing
		set cache = nothing
		set thumbs = nothing
	end sub

	private ldebug

end class

class class_utils

'***
'*** class_utils v1.2 [14/Oct/04]
'***

	public browserVersion, browserType, browserOK
	public objRS, stream, CharSet


	public function npath(path) 	'* returns path always witn an ending slash
		if instr(path, "/" ) AND Right(path, 1) <> "/" Then 
			npath = lcase(path & "/")
		elseif instr(path, "\" ) AND Right(path, 1) <> "\" Then 
			npath = lcase(path & "\")
		else 
			npath = path
		end if
	end function


	'* get root when SooP cor_sWebroot is not defined yet
	'* (won't work right however if root is not set as an IIS app.)
	public property get root
		if lroot <> "" Then 
			'* Do nothing
		elseif session(cor_pre&"cor_sWebroot") <> "" Then 
			lroot = session(cor_pre&"cor_sWebroot")
		else
			'* get /portal from e.g. /LM/W3SVC/2/Root/portal
			dim AppPath: AppPath = lcase(request.serverVariables("APPL_MD_PATH"))
			dim pos: pos = instr(AppPath, "root")+4
			lroot = npath(mid(AppPath, pos, len(AppPath)))
		end if
		root = lroot
	end property

	public property let root (r)
		lroot = r
	end property


	public function domain			'* returns the current domain name
		if ldomain = "" Then ldomain = "http://" & cor_sServerName
		domain = ldomain
	end function


	public function basepath			'* return the current path from the root
		if lbasepath = "" Then lbasepath = request.serverVariables("SCRIPT_NAME")
		basepath = lbasepath
	end function

	'* http://www.psacake.com/web/func/htmldecode_function.htm
	public function HTMLdecode(byVal encodedstring)
		dim tmp, i
		tmp = encodedstring
		tmp = replace( tmp, "&quot;", chr(34) )
		tmp = replace( tmp, "&lt;" , chr(60) )
		tmp = replace( tmp, "&gt;" , chr(62) )
		tmp = replace( tmp, "&amp;" , chr(38) )
		tmp = replace( tmp, "&nbsp;", chr(32) )
		for i = 1 to 255
		tmp = replace( tmp, "&#" & i & ";", chr( i ) )
		Next
		HTMLdecode = tmp
	end function


	'* Convert binary data to text
	'* http://www.4guysfromrolla.com/aspfaqs/ShowFAQ.asp?FAQID=128

	public function BinToText(varBinData, intDataSizeInBytes) 
		objRS.Fields.append "txt", adVarChar, intDataSizeInBytes, adFldLong
		objRS.Open
		objRS.AddNew
		objRS.Fields("txt").appendChunk varBinData
		BinToText = objRS("txt").Value
		objRS.close '* reuse
	end function


	public function dyninc(vpath, inctype)
		'On error resume next
		dim objPath : objPath = server.mappath(vpath)
		if lcase(inctype) = "aspfile" Then
			call executeGlobal(aspTagStrip(readBinAsTextFile(objPath)))
			if Err.number<>0 Then response.write _
				"[ERR] An undefined language string was found at: " & vpath & _
				"<br /> Please check syntax or move the language #include file at the beginning of the file<br /><br />"
		elseif lcase(inctype) = "htmlfile" Then
			response.write cstr(readBinAsTextFile(objPath))
			if Err.number<>0 Then response.write "[ERR] no file found"
		end if
		'On error goto 0
	end function


	public function aspTagStrip(byRef sContent)
		sContent = replace(sContent, "<" & "%", "")
		sContent = replace(sContent, "%" & ">", "")
		aspTagStrip = sContent
	end function


	'* Read binary as text file
	'* http://www.motobit.com/tips/detpg_read-write-binary-files.htm

	public function readBinAsTextFile(FileName)
		stream.Type = cor_cTypeText
		'* Specify charset for the source text (unicode) data.
		stream.Charset = CharSet
		stream.Open
		stream.loadFromFile FileName
		readBinAsTextFile = stream.ReadText
		stream.close
	end function

	'* Save binary to text
	public sub saveBinAsTextFile(FileName, Text)
		stream.Type = cor_cTypeText
		stream.Charset = CharSet
		stream.Open
		stream.writeText Text
		stream.SaveToFile FileName, adSaveCreateOverWrite
		stream.close
	end sub

	private sub class_initialize() 
		set objRS = server.createObject("ADODB.Recordset")
		set stream = CreateObject("ADODB.Stream")
		Charset = "ascii"
	end sub

	private sub class_terminate() 
		set objRS = nothing
		set stream = nothing
	end sub

	private lroot, ldomain, lbasepath

end class

'*************************************

class class_cache

'***
'*** class_cache v1.3 [11/Oct/04]
'***
'*** Caching facility for html/text, xml and image files.
'*** Usage:
'*** clib.cache.write <cache lifespan in hours>, <friendly name>, <remote URL to fetch>, <response file extension>
'*** clib.cache.fetched = <true/false>. Tells if remote fetching and cache refresh was succesful or not
'*** Example:
'*** - grab external resource and populate the cache. (Note the <response file extension> is not the 
'*** extension of the called page but of the returned object after the external query is processed)
'*** call clib.cache.grab(1, "holder1", "http://www.quirit.com/quiritmatic/quiritmatic.asp?lang=en", ".jpg")
'*** 
'*** - returns the cached (local) URL for the already grabbed resource 
'*** clib.cache.grabbed_url
'*** 
'*** - returns the cached file contents for the already grabbed resource (e.g. html output) 
'*** clib.cache.grabbed_src
'*** 
'*** (FSO and ADO 2.5+ required)
'***

	public directory		'* relative path from SooP root to store your cache files 	
	public proxySettings	'* set proxy settings if server behind a proxy/firewall
	public fetched			'* shows if fetching of remote resource was succesful
	public debug			'* if debug true stops fetching (useful to avoid delays of short-term items while debugging other mods)	
	public recache			'* recache (repopulate cache) if server restarts
	public updated			'* shows when the cache was updated
	public timeout			'* (sec) give more time to cache script to finish as fetching might take long
	public charset			'* the locale of the fetched information. Useful for non-English alphabets 

	'* grab a remote file and put it to the cache repository
	'* grab(<when to fetch it in hours>, <friendly name>, 
	'* <URL from being fetched>, <expected extension of the fetched obj>)

	public sub grab(fetchTime, handler, remoteURL, remoteExt)
		dim streamType,	remoteData, ilapse
		'On error resume next

		'* virtual and physical paths to the local cached version
		localURL = clib.utils.root & directory & handler & remoteExt	
		localFolder = clib.utils.npath(server.mappath(clib.utils.root & directory))
		localFile = localFolder & handler & remoteExt
		if NOT debug then fetched = true else fetched = false	'* try always to fetch if not in debug mode
		updated = false 									'* returns true if the cache was just updated

		'* Get how long the handler obj has been cached 
		'* When fetchTime < 1 caching timer is turned off for this handler
		if fetchTime > 0 Then ilapse = lapse(handler) else ilapse = 0

		'* fetch remote file only if:
		'* - cache overdue
		'* - cache is empty
		'* - and fetch is not disable (debug-mode)
		if ((ilapse >= fetchTime) OR NOT objFSO.FileExists(localFile)) AND NOT debug Then

			'* Create local cache dir if not already existent
			if NOT objFSO.FolderExists(localFolder) Then objFSO.CreateFolder(localFolder)

			'* Initialize extra libraries only when needed to refresh cache
			call Init()

  			stream.Open

			'* get remote file contents, store them to remoteData, set the streamType
			call getRemoteFile(remoteData, remoteURL, streamType, fetched)

			'* fill stream obj depending on type of data received
			if fetched Then
				if streamType = "bin" Then stream.write remoteData else stream.writeText remoteData
				'* save stream obj as a cache file
				stream.SaveToFile localFile, adSaveCreateOverWrite
				'* the cache was updated
				updated = true
			end if
			stream.close
				
			if Err.number<>0 Then 
				fetched = false
				exit sub
			end if

			'* reset the fetch timer for this object
			if fetchTime > 0 Then call reset(handler)
		end if
	end sub 

	'------------- 	
	'* Short-hands. Use them only AFTER call ing a grab()

	'* returns the local URL to the cached version of a remote file
	public function grabbed_url : grabbed_url = localURL : end function

	'* returns the full content of the cached version of a remote file	
	public sub grabbed_src 	
		if localURL <> "" Then server.execute localURL	
	end sub
	'------------- 


	'* reset cache timer for handler
	public sub reset(handler)
		application.lock
		application(cor_pre & "clib_cache#" & handler) = Now()
		application.unlock
	end sub


	'* returns time lapse for handler (int hours) after the last cache refresh 
	public function lapse(handler)
		'* if application was restarted, reset the timer
		'* for this handler
		if application(cor_pre & "clib_cache#" & handler) = "" Then
			application.lock
			if recache Then 
				'* recache if app restarted to fetch inmediately
				application(cor_pre & "clib_cache#" & handler) = Now() - 365
			else
				application(cor_pre & "clib_cache#" & handler) = Now()
			end if
			application.unlock
		end if
		'* Calculate the time lapse since last update
		lapse = cint(dateDiff("h", application(cor_pre & "clib_cache#" & handler) , Now()))
	end function


	'* returns true/false if an object already exists in cache
	
	public function exist(handler, remoteExt)
		exist = objFSO.FileExists(directoryPhy & handler & remoteExt) 
	end function



	'* returns a data-block (remoteData) with the contents of the remote object 
	'* returns streamType with the type of the remote object (xml, text, image)
	'* returns true/false if fetching was successful

	public sub getRemoteFile(byRef remoteData, remoteURL, ByRef streamType, ByRef lfetched)
		'On error resume next
		dim lResolve, lConnect, lSend, lReceive
		dim objRegExp, ContenType

		'* set max. allowed times for getRemoteFile to fetch
		server.scriptTimeout = timeout
		lResolve = 5 * 1000
		lConnect = 5 * 1000
		lSend 	 = 15 * 1000
		lReceive = 15 * 1000
		objhttp.setTimeouts lResolve, lConnect, lSend, lReceive

		'* if server is behind a proxy or firewal you must configure it
		'* to allow objHTTP functioning
		if proxySettings <> "" Then objhttp.setProxy 2, proxySettings

		'* get remote object
		objhttp.Open "GET", remoteURL, false
		call objhttp.Send
		
		'* determine from remote headers the type of file returned
		'* (one might request text/html, but finally get redirected to an image/jpeg)
		ContenType = lcase(objhttp.getResponseHeader("Content-Type")) 
		if instr(ContenType, "xml" ) Then '* text/xml file. Saves as bin to handle foreign chars
			streamType = "bin"
			stream.Type = cor_cTypeBinary
		elseif instr(ContenType, "text") Then 	'* text/html file
			streamType = "text"
			stream.Type = cor_cTypeText
			stream.Charset = Charset		'* depends on portal settings by default
	 	else streamType = "bin"			'* image/jpeg, image/gif or any other file type
			stream.Type = cor_cTypeBinary
		end if
			stream.Position = 0	 			'* ensure cursor at the beginning of file
		'* get remote file 
	 	if streamType = "bin" Then
 			remoteData = objhttp.responseBody
		elseif streamType = "xml" Then 
			set objRegExp = New Regexp
			objRegExp.Ignorecase = true
			objRegExp.Global = true 
			objRegExp.Pattern = "<!DOCTYPE(.|\n)+?>" 
			remoteData = objRegExp.replace(cstr(objhttp.ResponseText),"")
			set objRegExp = nothing
		else 
			remoteData = cstr(objhttp.ResponseText)
		end if

		'* if fetching was unsuccesful probably a timeout ocurred
		if isEmpty(remoteData) OR isNull(remoteData) OR Err.number<>0 Then lfetched = false
		'On error goto 0
	end sub

	'* 2nd-phase initialize for libraries only when needed
	private sub Init()
		'On error resume next
		'* Choose the most up-to-date library supported by your server:
		'* New WinHTTP API (heavy-dutty server apps)
		set objhttp = server.createObject("WinHttp.WinHttprequest.5.1")
		'set objhttp = server.createObject("WinHttp.WinHttprequest")
		'* New WinHTTP API. Mostly tested (recommended)
		'set objhttp = server.createObject("MSXML2.ServerXMLHTTP.4.0")
		'set objhttp = server.createObject("MSXML2.ServerXMLHTTP.3.0")
		'set objhttp = server.createObject("MSXML2.ServerXMLHTTP")
		'* Old WinINET API (suitable for client-side apps only)
		'set objhttp = server.createObject("Microsoft.XMLHTTP")
	end sub


	private sub class_initialize() 
		'On error resume next
		set objFSO = server.createObject("Scripting.FileSystemObject")
		set stream = server.createObject("ADODB.Stream")
		directory = "_cache/"
		directoryPhy = clib.utils.npath(server.mappath(clib.utils.root & directory))
		recache = false
		timeout = 1800		'* (sec) 
		updated = false
		debug = clib.debug
		Charset = clib.utils.CharSet
	end sub

	private sub class_terminate()
		set objhttp = nothing
		set objFSO = nothing
		set stream = nothing
	end sub

	private objhttp, objFSO, stream, objFolders
	private localURL, localFolder, localFile, directoryPhy

end class

'*************************************

class class_thumbs

'***
'*** class_thumbs v2.0 [31/Aug/04]
'***
'*** Make thumbnails w/o using any DLL component but simply ASP.NET build-in graphic library
'*** Usage:
'*** thumbs.create(<absolute image file path>, <thumbnail size>)
'*** 
'******
'***
'*** Uses :: .NET Connector
'*** 

	public directory			'* (str) directory where images are found and to put generated thumbnails
	public maxWidth				'* (int) Max. width of being resized to. set to 0 not to resize
	public maxWidthPrefix		'* (str) how resized images are named <prefix><original image>
	public maxThumbWidth		'* (int) Max. width of generated thumbnail. set to 0 not to create thumbnail
	public ThumbPrefix			'* (str) how the thumnails are named <prefix><original image>
	public OverlayText			'* (str) overlays on top left of image (empty to disable)
	public debug 				'* (bol) if false the class is pass-through and doesn't make anything (debug-mode)


	'* create a new thumb using .NET Image lib
	public function create(pathFile, Overwrite)
		dim filename

		'* get source image to work on or exit with default thumbnail if not existent
		if objFSO.FileExists(server.mappath(pathFile)) Then 
			filename = objFSO.GetFileName(server.mappath(pathFile)) 
		else 
			create = clib.utils.root & "images/noimage.gif" 
			exit function
		end if

		'* if thumb already exist or retry threshold reached or in debug-mode return existing thumb
		if ThumbExists(filename) AND (NOT Overwrite OR debug) Then
			create = clib.utils.npath(directory) & ThumbPrefix & filename
			call resetToken
			exit function
		end if

		'* create thumb is mandatory
		if Overwrite Then call resetToken

		'* thumbnail not yet created. aspxImageLib shall do it (multiple tries supported)
		'* Note aspxImageLib redirects to another page and then returns back here 
		'* (as reloading the page that calls this function again)
		if NOT GetRetVal AND tryAgain(filename, true) Then call aspxImageLib(filename, true) else create = clib.utils.root & "images/noimage.gif" 
	end function


	'* check if an image exists in image directory
	public function ImageExists(filename) 
		ImageExists = objFSO.FileExists(clib.utils.npath(directoryPhy) & filename)
	end function


	'* check if a thumbnail exists in image directory
	public function ThumbExists(filename)
		ThumbExists = objFSO.FileExists(clib.utils.npath(directoryPhy) & ThumbPrefix & filename)
	end function


	'* check if a resized image exists in image directory
	public function ResizedExists(filename)
		ResizedExists	= objFSO.FileExists(clib.utils.npath(directoryPhy) & maxWidthPrefix & filename)
	end function


	'*** .NET Connector
	'*** create a new thumbnail and resize image	

	private sub aspxImageLib(filename, Overwrite)
		With response
		'On error resume next
		'************************************************************
		'*** .NET Connector :: Send Token
		'************************************************************	
		'*** Populate Transport params
		.cookies("clibThumbsToken")("retVal") = ""
		.cookies("clibThumbsToken")("errVal") = ""
		.cookies("clibThumbsToken")("call Back") = clib.utils.basepath
		.cookies("clibThumbsToken")("tryAmount") = tryAmount
		.cookies("clibThumbsToken")("tryNum") = cokTryNum
		
		'*** Populate Data fields:
		.cookies("clibThumbsToken")("fileName") = filename
		.cookies("clibThumbsToken")("filePathVir") = clib.utils.root & Directory
		.cookies("clibThumbsToken")("maxWidth") = maxWidth
		.cookies("clibThumbsToken")("maxWidthPrefix") = maxWidthPrefix
		.cookies("clibThumbsToken")("maxThumbWidth") = maxThumbWidth
		.cookies("clibThumbsToken")("thumbPrefix") = thumbPrefix
		.cookies("clibThumbsToken")("overlayText") = overlayText
		.cookies("clibThumbsToken")("Overwrite") = Overwrite
		'* Store Token
		.cookies("clibThumbsToken").Path = "/"
		.cookies("clibThumbsToken").Expires = Now() +1

		'* call asp.net 
		.redirect(clib.utils.root & "tools/" & "thumbs.aspx")
		End With
		'************************************************************
	end sub


	private function getRetVal
		dim RetVal : RetVal = request.cookies("clibThumbsToken")("RetVal")
		if RetVal = "" Then RetVal = false
		getRetVal = RetVal
	end function


	private sub resetToken
		if request.cookies ("clibThumbsToken") <> "" Then 
			response.cookies("clibThumbsToken") = "" 
			response.cookies("clibThumbsToken").Expires	= Now() -2	
		end if
			session(cor_pre&"clib_thumbs#tryNum") 		= 0
	end sub


	'* Until true thumbs.aspx still tries to perform a thumb-making query
	'* if bIncrement is false only the current counter state w/o increment is returned
	
	private function tryAgain(filename, bIncrement) 
		dim lfilename, sesTryNum 

		lfilename = request.cookies("clibThumbsToken")("fileName")
		cokTryNum = cint( "0" & request.cookies("clibThumbsToken")("tryNum"))
		sesTryNum = session(cor_pre&"clib_thumbs#tryNum")

		if bIncrement Then
			'* thumbs.aspx is not already called or there might be a problem setting the transport cookie
			'* keep track of this with a session backup to avoid infinite back and forths
			if (lfilename = "" OR cokTryNum = 0) Then sesTryNum = sesTryNum +1 else sesTryNum = 0 :
			session(cor_pre&"clib_thumbs#tryNum") = sesTryNum
			'* initialize retry counter
			if lfilename <> filename Then cokTryNum = 0
			'* increment retry counter
			if lfilename = filename AND cokTryNum < tryAmount Then cokTryNum = cokTryNum +1
		end if
		if 	cokTryNum <= tryAmount AND sesTryNum <= tryAmount Then tryAgain = true else tryAgain = false
	end function

	
	private sub class_initialize() 
		'On error resume next
		set objFSO = server.createObject("Scripting.FileSystemObject")
		directoryPhy = server.mappath(clib.cache.directory)
		directory = clib.cache.directory	'* (str) virtual path to image repository
		maxWidth = 0						'* (pix) Max width of image to resize to. set 0 to not resize 
		maxWidthPrefix = "r_"
		maxThumbWidth = 100					'* (pix) max thumbnail width 
		ThumbPrefix = "s_"
		OverlayText = ""					'* (str) Will be overlayed on top left of image, leave empty to not overlay
		tryAmount = 3						'* (int) number of redirection retries to thumbs.aspx
		debug = clib.debug					'* (bol) do no processing if true
	end sub

	private sub class_terminate()
		set objFSO = nothing
	end sub

	private objFSO, directoryPhy, cokTryNum, tryAmount
end class

'*** CLIB
'*************************************


'****************************************************************************
'*** RSSfeedsC mod v1.3.1 (11/Oct/04) for SooP 1.6 (Raven)
'*** XML Newsfeeds with XML/HTML caching (CLIB)
'*** By Alex Campbell (alx359)
'***
'*** (Portions based on the original RSSfeeds module found in SooP 1.6 Raven)

class class_RSSfeedsCache

'***
'*** Uses :: CLIB
'***

	public fileXSLpath, displaySource
	public debug


	public function grabXML(fetchTime, handler, xmlTitle, remoteURL)
		With Response
		.write("<table summary='' border=0 cellspacing=0 cellpadding=4 width=""100%""><tr>" & vbcrlf)
		.write("	<td bgcolor=""" & strTableTitleColour2 & """ class=""tiHeading"" background=""" & strTableTitleBgImage2 & """>")
		.write("&nbsp;&nbsp;")
		.write(xmlTitle)
		.write("</td>" & vbcrlf)
		.write("	<td align=""right"" bgcolor=""" & strTableTitleColour2 & """ class=""tiHeading"" background=""" & strTableTitleBgImage2 & """>")
		if displaySource Then
		.write("<a href="""& remoteURL & """ target=_blank title=""RSS"">")
		end if
		.write("<img border=0 title=""RSS"" alt=""RSS"" style='text-align:center' src=""" & cor_sSkinImg & "rss_button.gif"" />")
		if displaySource Then
		.write("</a>")
		end if
		.write("</td>" & vbcrlf)
		.write("</tr><tr>" & vbcrlf)
		.write("	<td class=text bgcolor=""" & strTableColour & """ colspan=2>")
		.write(write(fetchTime, handler, xmlTitle, remoteURL))
		.write("</td>" & vbcrlf)
		.write("</tr></table>" & vbcrlf)
		End With
	end function


	public function parseXML(handler) 
		dim xsl, xml
		dim errorXSL, errorXML
		'On error resume next
		set xsl = server.createObject("Msxml2.DomDocument.4.0") 
		set xml = server.createObject("Msxml2.DomDocument.4.0") 
		xml.async = false 
		xml.resolveExternals = false
		xml.validateOnParse = false
		xsl.async = false
		xsl.resolveExternals = false
		xsl.validateOnParse = false
		xsl.load(cor.butil.getWebRoot() & fileXSLpath)
		xml.load(localPathPhy & handler & ".xml")
		errorXSL = xsl.parseError.errorCode
		errorXML = xml.parseError.errorCode
		if errorXSL <> 0 Then parseXML = parseXML & lngRSSstyleError & "<br />"
		if errorXML = 0 Then parseXML = xml.transformNode(xsl) else parseXML = lngRSSFeedError
		set xsl = nothing
		set xml = nothing
	end function 


	'* fetches a file locall y every fetchTime hours
	'* (Initial inspiration @ http://authors.aspalliance.com/andyb/articles/rssaggrigator.aspx)

	private function write(fetchTime, handler, xmlTitle, remoteURL)

		dim getHTMLtext

		'On error resume next
		'* Fetch remote XML and parse it only if:
		'* - time lapse overdue
		'* - or cache is empty
		'* - debug mode is disabled
		if ((clib.cache.lapse(handler) >= fetchTime) _
		OR NOT clib.cache.exist(handler, ".xml") _
		OR NOT clib.cache.exist(handler, ".html") ) _
		AND NOT debug _
		Then
			'* populate local cache with remote XML file
			call clib.cache.grab(fetchTime, handler, remoteURL, ".xml")

			'* Transform to HTML from local cache (XML+XLS->HTML) 
			getHTMLtext = clib.utils.HTMLdecode(parseXML(handler))

			'* Save HTML text copy to the cache. So we avoid call ing the slow parser on each page load
			'* We also save as stream obj to keep eventual non-English data
			call clib.utils.saveBinAsTextFile(localPathPhy & handler & ".html", getHTMLtext)

			'* reset the fetch timer
			clib.cache.reset(handler)
		end if

		'* Get the plain HTML cached version
		if clib.cache.exist(handler, ".html") Then write = clib.utils.readBinAsTextFile(localPathPhy & handler & ".html")
	end function 


	private sub class_initialize() 
		'On error resume next
		localPathVir = cor_sWebroot & clib.cache.directory 	
		localPathPhy = server.mappath(cor_sWebroot & clib.cache.directory)
		if Right(localPathPhy, 1) <> "\" Then localPathPhy = localPathPhy & "\"
		debug = clib.debug
		'*** Path to the XSL template
		fileXSLpath = "forum\functions\other\RSSfeeds.xsl"
		'*** Display link to the original RSS resource (in RSS icon)
		displaySource = true
	end sub


	private localPathVir, localPathPhy

end class


'****************************************************************************
'*** Dynamic Module Invocation 1.01 [07/Oct/04]
'*** Written by Alex Campbell (alx359)
'****************************************************************************

class class_dynMod

	public ModParam

	public function getMod(modName)
		dim Module_Name, modPerm
		const showToggle = false

		modPerm = getModPerm(modName)
		if ModPerm Then 
			Module_Name = modName & "(" & showToggle & "," & ModPerm & ")"
			'* Get params, if any defined
			Mod_Param = ModParam
			ModBox_hideModBox = true
			'On error resume next
			getMod = eval(Module_Name)
			ModBox_hideModBox = false
		else
			getMod = "<br /><br /><div style=""text-align:center""class=Text>" & lngUnavailable & "</div>" & vbcrlf
		end if
	end function


	public function getModPerm(modName)
		dim adoRec, ssql
		dim arrMods, modPerm, countMods
		dim lModule_name, lModule_Permission, lModule_Parameters, totalRows
		
		'* forum is closed
		if blnForumClosed Then getModPerm = "0" : exit function
		
		'* get permission from appl cache
		if application(cor_pre & "DynMod_" & modName) <> "" Then 
			'* map mod permission with the User's Group ID 
			'* already extracted from the user's cookie (strLoggedInUserCode) 
			'* and thereafter pulled from the DB for matching (common.asp)
			if cor.butil.checkPerm(application(cor_pre & "DynMod_" & modName), cor_iGroupID) Then 
				ModParam = application(cor_pre & "DynMod_" & modName & "_param")
				getModPerm = "1"
			else 
				getModPerm = "0"
			end if
			exit function
		end	if
		'* if appl cache doesn't exist (or a fresh installed/uncached mod was requested), 
		'* populate cache first and return the requested mod permission with the same SQL request
		ssql = "SELECT T1.Module_name, T1.Module_Permission, T1.Module_Parameters, T1.Module_Type " _
				& " FROM " & cor_dbpre & "modules AS T1 WHERE T1.Module_Type = 1"
		'if NOT blnUseApplicationVariables Then 
			ssql = ssql & " AND T1.Module_name = '" & modName &"'"
		'end if
		cor.dal.exec ssql, array()
	 	if NOT cor.dal.rs.EOF Then arrMods = cor.dal.rs.GetRows
		'* release DB connection early as it's already loaded in memory via GetRows
		

		'if isarray(arrMods) AND blnUseApplicationVariables Then
		'	application.lock
		'	totalRows = ubound(arrMods, 2)
		'	application(cor_pre & "DynMod_totalRows") = totalRows
		'	for countMods = 0 to totalRows
		'		lModule_name = arrMods(0, countMods)
		'		lModule_Permission = arrMods(1, countMods)
		'		lModule_Parameters = arrMods(2, countMods) 
		'		'* cache module permissions
		'		application(cor_pre & "DynMod_" & lModule_name) = lModule_Permission
		'		'* cache module parameters, if any
		'		if lModule_Parameters <> "" Then application(cor_pre & "DynMod_" & lModule_name & "_param") = lModule_Parameters
		'		'* get the requested mod permissions
		'		if strComp(lcase(trim(modName)), lcase(trim(lModule_name))) = 0 Then modPerm = lModule_Permission
		'	Next
		'	application.unlock
		'elseif isarray(arrMods) Then
		if isarray(arrMods) Then
			'* get module params, if any
			ModParam = arrMods(2, 0)
			'* get the matching mod permissions
			modPerm = arrMods(1, 0)
		else
			'* mod not found
			modPerm = ""
		end if
		'if cor.butil.checkPerm(modPerm, cor_iGroupID) Then getModPerm = "1" else getModPerm = "0"
		if cor.butil.checkPerm(modPerm, cor_iGroupID) Then getModPerm = 1 else getModPerm = 0
	end function


	public function getMenuPerm(Menu_ID)
		dim ssql
		dim arrMods, menuPerm, countMods
		dim lmenu_ID, lMenu_Perm, totalRows

		'* forum is closed
		if blnForumClosed Then getMenuPerm = "0" : exit function
		
		'* get permission from appl cache
		if application(cor_pre & "DynMenu_" & menu_ID) <> "" Then 
			'* map mod permission with the User's Group ID 
			'* already extracted from the user's cookie (strLoggedInUserCode) 
			'* and thereafter pulled from the DB for matching (common.asp)
			if cor.butil.checkPerm(application(cor_pre & "DynMenu_" & menu_ID), cor_iGroupID) Then getMenuPerm = "1" else getMenuPerm = "0"
			exit function
		end	if
		'* if appl cache doesn't exist (or a fresh installed/uncached mod was requested), 
		'* populate cache first and return the requested mod permission with the same SQL request
		ssql = "SELECT T1.Menu_ID, T1.Menu_Perm, T1.Menu_Active, T1.Menu_sub " _
				& " FROM "  & cor_dbpre & "menu AS T1 " _
				& " WHERE T1.Menu_Active = 1 AND T1.Menu_sub = 0"
		'if NOT blnUseApplicationVariables Then 
			ssql = ssql _
				& " AND T1.Menu_ID = '" & Menu_ID & "'"
		'end if
		cor.dal.exec ssql, array()
		if NOT cor.dal.rs.EOF Then arrMods = cor.dal.rs.GetRows
		'* release DB connection early as it's already loaded in memory via GetRows
		

		'if isarray(arrMods) AND blnUseApplicationVariables Then
		'	application.lock
		'	totalRows = ubound(arrMods, 2)
		'	application(cor_pre & "DynMenu_totalRows") = totalRows
		'	for countMods = 0 to totalRows
		'		lmenu_ID = arrMods(0, countMods)
		'		lMenu_Perm = arrMods(1, countMods)
		'		'* cache module permissions
		'		application(cor_pre & "DynMenu_" & lmenu_ID) = lMenu_Perm
		'		'* get the requested mod permissions
		'		if cint(menu_ID) = cint(lmenu_ID) Then menuPerm = lMenu_Perm
		'	Next
		'	application.unlock
		'elseif isarray(arrMods) Then
		if isarray(arrMods) Then
			'* get the matching mod permissions
			menuPerm = arrMods(1, 0) 
		else
			'* mod not found
			menuPerm = ""
		end if
		'if cor.butil.checkPerm(menuPerm, cor_iGroupID) Then getMenuPerm = "1" else getMenuPerm = "0"
		if cor.butil.checkPerm(menuPerm, cor_iGroupID) Then getMenuPerm = 1 else getMenuPerm = 0
	end function	
	

	public function getSubMenuPerm(SubMenu_ID)
		dim ssql
		dim arrMods, SubMenuPerm, countMods
		dim lSubMenu_ID, lSubMenu_Perm, totalRows

		'* forum is closed
		if blnForumClosed Then getSubMenuPerm = "0" : exit function

		'* get permission from appl cache
		if application(cor_pre & "DynSubMenu_" & SubMenu_ID) <> "" Then 
			'* map mod permission with the User's Group ID 
			'* already extracted from the user's cookie (strLoggedInUserCode) 
			'* and thereafter pulled from the DB for matching (common.asp)
			if cor.butil.checkPerm(application(cor_pre & "DynSubMenu_" & SubMenu_ID), cor_iGroupID) Then getSubMenuPerm = "1" else getSubMenuPerm = "0"
			exit function
		end if
		'* if appl cache doesn't exist (or a fresh installed/uncached mod was requested), 
		'* populate cache first and return the requested mod permission with the same SQL request
		ssql = "SELECT T1.SubMenu_ID, T1.SubMenu_Perm, T1.SubMenu_Active " _
				& " FROM "  & cor_dbpre & "menusub As T1 " _
				& " WHERE T1.SubMenu_Active = 1"
		'if NOT blnUseApplicationVariables Then 
			ssql = ssql & " AND " & cor_dbpre & "menusub.SubMenu_ID = '" & SubMenu_ID & "'"
		'end if
		cor.dal.exec ssql, array()
		if NOT cor.dal.rs.EOF Then arrMods = cor.dal.rs.GetRows
		'* release DB connection early as it's already loaded in memory via GetRows
		
		'if isarray(arrMods) AND blnUseApplicationVariables Then
		'	totalRows = ubound(arrMods, 2)
		'	application.lock
		'	application(cor_pre & "DynSubMenu_totalRows") = totalRows
		'	for countMods = 0 to totalRows
		'		lSubMenu_ID	= arrMods(0, countMods)
		'		lSubMenu_Perm = arrMods(1, countMods)
		'		'* cache module permissions
		'		application(cor_pre & "DynSubMenu_" & lSubMenu_ID) = lSubMenu_Perm
		'		'* get the requested mod permissions
		'		if cint(SubMenu_ID) = cint(lSubMenu_ID) Then SubMenuPerm = lSubMenu_Perm
		'	Next
		'	application.unlock
		'elseif isarray(arrMods) Then
		if isarray(arrMods) Then
			'* get the matching mod permissions
			SubMenuPerm = arrMods(1, 0) 
		else
			'* mod not found
			SubMenuPerm = ""
		end if
		if cor.butil.checkPerm(SubMenuPerm, cor_iGroupID) Then getSubMenuPerm = "1" else getSubMenuPerm = "0"
	end function

end class



'****************************************************************************
'***
'*** Common CLIB Disposal
'***

sub common_dispose()
	set clib  = nothing
	set cg_dyn = nothing
end sub

%>
