﻿<%
'------------------------------------------------------------------------------------------------------------------------------------------
' SOOP 2.0 - Phoenix (TNG)
'
' Revision 2.00 - initial 15/02/2008
'
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'------------------------------------------------------------------------------------------------------------------------------------------

'
'------------------------------------------------------------------------------------------------------------------------------------------
'
' Utility (partial) class 
'
'------------------------------------------------------------------------------------------------------------------------------------------
class class_forum_notif ':: global, class_string, class_baseUtils, class_filters, class_DAL, class_io, class_languageParser
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	' intType: 1 topic - 2 forum
	' intUserID: concerned member ID
	' intID: ID either of forum either of topic depending which one we're looking for
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	public function isNotified(intType, intUserID, intID)
		dim arrNotify
		select case intType
			'
		case cor_cNotifyForum
			'
			cor.dal.open arrNotify, "SELECT n.nid FROM " & cor_dbpre & "notify AS n WHERE n.nuser={0} AND n.nforumid={1} AND (n.ntopicid=0 OR n.ntopicid IS NULL)", array(intUserID, intID)
			isNotified = iif(cor.butil.eof(arrNotify), false, true)
			'
		case cor_cNotifyTopic
			'
			cor.dal.open arrNotify, "SELECT n.nid FROM " & cor_dbpre & "notify AS n WHERE n.nuser={0} AND n.nTopicID={1}", array(intUserID, intID)
			isNotified = iif(cor.butil.eof(arrNotify), false, true)
			'
		end select
	end function  
	'
	'--- short-hand
	public function prnNotify()
		if isNotified(cor_cNotifyForum,cor_lUserID,cor.forum.fid) _
		OR isNotified(cor_cNotifyTopic,cor_lUserID,cor.forum.tid) _
		then prnNotify = " checked='checked'"
	end function
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	' determine if member has forum-level or topic-level notification set
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	public sub moveNotify(tid_src, tid_des)
		p_sql = "UPDATE " & cor_dbpre & "notify SET ntopicid={0} WHERE ntopicid={1}"
		cor.dal.exec p_sql, array(tid_des, tid_src)	
	end sub   
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	' determine if member has forum-level or topic-level notification set
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	public function hasNotify(fid, tid, uid)
		dim notif
		'
		'ML if coming from RAVEN notifications we don't have a forum ID, only a topic ID
		'if cor.filter.checkLng(fid) = 0 then cor.msg(lngInvalid & " fid")
		if cor.filter.checkLng(fid) = 0 then
			p_sql = "SELECT COUNT(*) FROM " & cor_dbpre &  "notify AS n WHERE n.ntopicid={0} AND n.nuser={1}"
			'--- check for explitit topic-level notification 
			if  cor.filter.checkInt(tid) > 0 AND cor.filter.checkInt(cint(cor.dal.getValue(p_sql, array(tid, uid)))) > 0 then
				notif = "p"
			end if
		else
			p_sql = "SELECT COUNT(*) FROM " & cor_dbpre &  "notify AS n WHERE n.nforumid={0} AND (n.ntopicid = 0 OR n.ntopicid IS NULL) AND n.nuser={2}"
			if isnumeric(tid) then
				if clng(tid) > 0 then
					p_sql = "SELECT COUNT(*) FROM " & cor_dbpre &  "notify AS n WHERE n.nforumid={0} AND n.ntopicid={1} AND n.nuser={2}"
				end if
			end if 
			'--- check for forum-level notifications
			notif = iif(cor.filter.checkInt(tid) = 0 AND cor.filter.checkInt(cint(cor.dal.getValue(p_sql, array(fid, 0, uid)))) > 0, "f", "")
			'--- check for explitit topic-level notification 
			if  cor.filter.checkInt(tid) > 0 AND cor.filter.checkInt(cint(cor.dal.getValue(p_sql, array(fid, tid, uid)))) > 0 then
				notif = iif(notif<>"", "fp", "p")
			end if
		end if
		hasNotify = notif
	end function
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	' add forum-level subscription or topic-level notification
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	public sub addnotify(fid, tid, uid)
		
		dim strTid, notif : notif = hasnotify(fid, tid, uid) 
		if  notif = "" OR notif = "f" then		'make sure this doesn't fail the Topics FK.
			if clng(tid) < 1 or len(tid) < 1 then 
				strTid = ""						'this will convert to a Null in BuildSQL. 
			else
				strTid = tid					'This will pass along any non-zero, non-negative, non-empty value
			end if
			p_sql = "INSERT INTO " & cor_dbpre & "notify (nforumid,ntopicid,nuser,nseen,tunsub) VALUES ({0},{1},{2},{3},{4})"
			cor.dal.exec p_sql, array(fid, strTid, uid, 1, 0)
		end if
	end sub
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	' resets nseen=0 on an (existing) topic-level notification. If forum subscription add such notification first.
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	public sub resetnotify(fid, tid, uid)
		'addnotify fid, tid, uid
   		p_sql = "UPDATE " & cor_dbpre & "notify SET nseen=0 WHERE nforumid={0} AND ntopicid={1} AND nuser={2}"
   		cor.dal.exec p_sql, array(fid, tid, uid)
	end sub
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	' deletes forum-level subscription or existing topic-level notification, 
	' or set topic-level notification as unsub=1 if forum-level notification exists	
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	public sub delnotify(fid, tid, uid)
	
		dim notif : notif = hasnotify(fid, tid, uid)
		'--- del forum subscription and its related topic subscriptions and unsubscriptions
		'sometimes topicid is null rather than 0.
		if  notif = "f" AND tid = 0 then 
			p_sql = "DELETE FROM " & cor_dbpre & "notify WHERE nforumid={0} AND (ntopicid={1} OR ntopicid is null) AND nuser={2}"
			cor.dal.exec p_sql, array(fid, tid, uid)	
		'--- forum subscription does exist, so we can't just delete topic subscription but unsubscribe as tunsub=1
		elseif  notif = "fp" then 
			p_sql = "UPDATE " & cor_dbpre & "notify SET tunsub=1 WHERE nforumid={0} AND ntopicid={1} AND nuser={2}"
			cor.dal.exec p_sql, array(fid, tid, uid)	
		'--- forum subscription doesn't exis,t so we can just delete topic subscription
		elseif notif = "p" Then
'ML			p_sql = "DELETE FROM " & cor_dbpre & "notify WHERE nforumid={0} AND ntopicid={1} AND nuser={2}"
			p_sql = "DELETE FROM " & cor_dbpre & "notify WHERE ntopicid={0} AND nuser={1}"
			cor.dal.exec p_sql, array(tid, uid)	
		end if
	end sub
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	' notify by e-mail all topic-level subscribers	
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	public sub sendnotify(fid, tid, byval typ)
		dim arrMailList, arrTopic, arrPost
		dim sTitle, dDate, sBody, forumId, sForumName, sPostedBy, pid, i
		dim sMemberNoSend, msgBody
		'
		' Build mailist of forum and topic subscribers
		' order them by language so we avoid XML loads as much as possible
		'
		'--------------- 0 ------ 1 ------ 2 ---- 3 -------4--------------5----------
		p_sql = "SELECT n.nseen, m.mmail, m.MemberID, m.muser, m.mhtmlemail, m.mlanguage " _
			  & "FROM " & cor_dbpre & "notify AS n " _
			  & "INNER JOIN " & cor_dbpre & "members AS m ON (n.nuser = m.MemberID) " _
			  & "WHERE n.nforumid={0} AND n.tunsub={2} AND (n.ntopicid IS NULL OR n.ntopicid={1}) ORDER BY m.mlanguage" 
		cor.dal.open arrMailList, p_sql, array(fid, tid, 0)
		if cor.butil.eof(arrMailList) Then exit sub
		'
		' Get topic data
		'
		'--------------- 0 ------- 1 -----------2--------3------------4-------------5------------
		p_sql = "SELECT t.ttitle, t.tdatelast, t.tbody, t.tlastpid, t.tforumid, m.muser FROM " & cor_dbpre & "topics AS t " & _
		"INNER JOIN " & cor_dbpre & "members AS m ON t.tlastmid = m.MemberID "  & _
		"WHERE t.tid ={0}"
		cor.dal.open arrTopic, p_sql, array(tid)
		'	
		if cor.butil.eof(arrTopic) then exit sub
		sTitle  	= arrTopic(0,0)
		dDate   	= cor.butil.cvLcidTime(arrTopic(1,0))
		sBody   	= arrTopic(2,0)
		pid	 	= cor.filter.checkLng(arrTopic(3,0))
		forumId		= cor.filter.checkLng(arrTopic(4,0))
		sForumName 	= cor.util.getForumColVal(arrTopic(4,0), 18, cor_cStr)
		sPostedBy	= arrTopic(5,0)
		'
		' Get post data (body)
		'
	 	typ = lcase(typ)
	 	if typ = "newpost" Then
			'--------------- 0 -----------  
		 	p_sql = "SELECT p.pbody FROM " & cor_dbpre & "posts AS p WHERE p.pid={0}"  
		 	cor.dal.open arrPost, p_sql, array(pid)
		 	if cor.butil.eof(arrPost) then exit sub
		 	'--- Overwrite topic body with post body
		 	sBody = arrPost(0,0)	
		end if
		'
		'
		' Send message to each maillist subscriber, but:
		' - avoid sending duplicates if forum AND topic subscriber
		' - do not send to Guest and currently logged-in user
		' (TODO: may be handled more elegantly with just a smarter sql query)
		'
		Dim strUserLng
		Dim strActualLng
		'
		strUserLng = trim(cor_sLanguage)
		strActualLng = trim(cor_sLanguage)
		'
		sMemberNoSend = "||2||" & cor_lUserID & "||"
		for i = 0 to ubound(arrMailList,2)
			''response.write arrMailList(3,i) & "-" & arrMailList(5,i) & "-" & cor_sLanguage & "<br />"
			if  instr(sMemberNoSend, "||" & arrMailList(2,i) & "||")=0 then
				'
				'if different language
				if not trim(arrMailList(5,i)) = strActualLng then 
					strActualLng = trim(arrMailList(5,i))
					call cor.lng.includeSectionForced("mod_xmlForum",strActualLng)
				end if
				'
				' Prepare message body
				'
				if  cor.filter.checkInt(arrMailList(4,i)) > 0 Then
					'--- html
					msgBody = lngHi & arrMailList(3,i)		& ":" & "<br /><br />"
					msgBody = msgBody & lngForaNewMsgPosted		& " """ & cor.cfg.item("WebsiteTitle") & """" & "<br /><br />"
					msgBody = msgBody & lngForum		& ": " & "<a href=""" & cor_sPortalDomainPath  & "fora_forum.asp?fid=" & forumId 					& """>" & sForumName & "</a><br />"
					msgBody = msgBody & lngTopic		& ": " & "<a href=""" & cor_sPortalDomainPath  & "fora_topic.asp?tid=" & tid	& """>" & sTitle 	 & "</a><br />"
					msgBody = msgBody & lngForaPostedBy & ": " & sPostedBy 	& "<br />"
					msgBody = msgBody & lngForaOnDate 	& ": " & dDate 		& "<br />"
					msgBody = msgBody & "<hr />"
					msgBody = msgBody & sBody
					msgBody = msgBody & "<hr />"
					'--- unsubscribe option
					msgBody = msgBody & "<a href="""	& cor_sPortalDomainPath & "fora_topic.asp?tid=" & tid & iif(pid>0, "|" & pid & "#a" & pid, "") & """>" & lngForaViewLastPost & "</a>"
					msgBody = msgBody & " | "
					msgBody = msgBody & "<a href="""	& cor_sPortalDomainPath & "fora_topic.asp?do=" & cor_cDoUnsubscribeTopic & "&tid=" & tid & """>" & lngForaClickToUnsubscribe & "</a>"
				else
					'--- plain
					msgBody = lngHi   & arrMailList(3,i)		& ":"			& vbcrlf  & vbcrlf
					msgBody = msgBody & lngForaNewMsgPosted		& " """			& cor.cfg.item("WebsiteTitle") & """" & vbcrlf & vbcrlf
					msgBody = msgBody & lngForum		& ": "	& sForumName	& vbcrlf
					msgBody = msgBody & lngTopic		& ": "	& sTitle 		& vbcrlf
					msgBody = msgBody & lngForaPostedBy	& ": "	& sPostedBy 	& vbcrlf
					msgBody = msgBody & lngForaOnDate	& ": "	& dDate 		& vbcrlf
					msgBody = msgBody & vbcrlf & vbcrlf
					msgBody = msgBody & sBody
					msgBody = msgBody & vbcrlf & vbcrlf
					'--- unsubscribe option
					msgBody = msgBody & lngForaViewLastPost 		& ": "
					msgBody = msgBody & cor_sPortalDomainPath 	& "fora_topic.asp?tid="  & tid & iif(pid>0, "|" & pid & "#a" & pid, "") 
					msgBody = msgBody & vbcrlf & vbcrlf 		& lngForaClickToUnsubscribe  & ": "
					msgBody = msgBody & cor_sPortalDomainPath 	& "fora_topic.asp?do="& cor_cDoUnsubscribeTopic & "&tid=" & tid
				end if
				'move this reversal to cor.mail:
				'msgBody = cor.filter.ReverseHTMLCode(msgBody)
				'sTitle = cor.filter.ReverseHTMLCode(sTitle)
				'--- reset nseen=0 to all maillist subscribers, as they are receiving new stuff now 
				if cor.filter.checkInt(arrMailList(0,i)) = 1 then resetnotify fid, tid, arrMailList(2,i)
				'--- send message
				cor.mail.send cor_sReplyMail, cor.cfg.item("SenderName"), arrMailList(1,i), arrMailList(3,i) , cor.cfg.item("WebsiteTitle") & ": " & sTitle, msgBody, arrMailList(4,i)
				'--- add this member to the no-send buffer
				sMemberNoSend = sMemberNoSend & arrMailList(2,i) & "||"
			end if
			'
			'switch back to members language
			call cor.lng.includeSectionForced("mod_xmlForum",strUserLng)
			'
		next
	end sub
	'
	private p_sql
end class

%>
