﻿<%
'------------------------------------------------------------------------------------------------------------------------------------------
' SOOP 2.0 - Phoenix (TNG)
'
'Revision 2.0001 - initial 13/04/2008
'
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'------------------------------------------------------------------------------------------------------------------------------------------

class class_guestbook ':: global, class_baseUtils, class_filters, class_dal, class_io, class_template
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	' Attributes
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	' GET params
	'
	public iPage
	public iId
	'
	' POST/State params
	'
	public sName
	public iCountry
	public iMember
	public sEmail
	public shomepage
	public sComments
	Public sSecurityCode
	Public sessionName
	'
	' State params
	'
	public  bAuthor
	public  bCaptcha
	public  bDisabled
	private sDate
	private sMsg
	private p_sql
	'
	public util			' Utility obj 
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	' Init class: get I/O params and set startup internal environment
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	private sub class_initialize
		set util = new class_guestbook_utils
		bCaptcha = true
	end sub
	'
	public sub init_io()
		'
		' init attributes from GET
		'
		iPage	= cor.filter.checkInt(cor.io.fq("pg")) : if iPage = 0 Then iPage = 1
		iId		= cor.filter.checkLng(cor.io.fq("id"))
		'
		' init attributes from POST or init state attributes from GET
		'
		if cor_bPostback Then
			sName			= cor.util.textField(cor.io.f("name"))
			sEmail			= cor.util.linkField(cor.io.f("email"))
			shomepage		= cor.util.linkField(cor.io.f("homepage"))
			iCountry		= cor.filter.checkInt(cor.io.f("country"))
			iMember			= cor.filter.checkLng(cor.io.f("member"))
			sComments		= cor.io.f_rtf("comments")
			sSecurityCode	= cor.io.f("securityCode")
			sessionName		= cor.io.f("sessionName")
		Else
			call init_guestbook()
		end If
		'
		'------------------------------------
		' Global pre-conditions
		'------------------------------------
		'
		' init state attributes
		sDate = cor.butil.cvUxTime(Now())
		'
		' check if author is inspecting its own comment
		if  iId >0 Then 
			if lcase(cor.dal.getValue("SELECT gb.name FROM " & cor_dbpre & "guestbook AS gb WHERE gb.id={0} AND gb.name <> 'Guest'", array(iID))) = cor_sLoggedInUsername Then bAuthor = true else bAuthor = false
		end if
		'
		' disable captcha if criteria met
		if cor.filter.checkInt(cor.cfg("guestbook")) =0 OR cor_bMember Then bCaptcha = false
		'
		' system input fields are disabled for members (but not admins)
		if iMember=1 AND NOT cor_bAdmin Then bDisabled = true
		'
		' guestbook language
		cor.lng.includeSection("mod_xmlGuestbook")
	end sub
	'	
	private sub init_guestbook()
		dim arrGB
		'
		select case iId
		case 0
			' a guest
			if  cor_bGuest Then 
				iCountry	= cor.cfg.item("DefaultLocationID")
				sEmail		= ""
				shomepage	= ""
				iMember		= 0 
				 '
			else 'already a member
				 '
				sName		= cor_sLoggedInUsername
				iCountry	= cor.filter.checkInt(cor.guestbook.util.getCountryByUserID(cor_lUserID))
				if iCountry = 0 then iCountry = "-1"
				sEmail		= cor.dal.getValue("SELECT m.mmail FROM " 	  & cor_dbpre & "members AS m WHERE (m.MemberID={0})", array(cor_lUserID))
				shomepage	= cor.dal.getValue("SELECT m.mhomepage FROM " & cor_dbpre & "members AS m WHERE (m.MemberID={0})", array(cor_lUserID))
				iMember		= 1
			end if
			'
		case else
			'
			p_sql = "SELECT gb.id, gb.name, gb.country_id, gb.email, gb.gbdate, gb.homepage, gb.comments, gb.ip, gb.member FROM " & cor_dbpre & "guestbook AS gb WHERE gb.id = {0}"
			cor.dal.open arrGB, p_sql, array(iId)
			if cor.butil.eof(arrGB) Then
				' invalid id
				cor.redir cor_sWebroot & "guestbook.asp?pg=1"
			else
				sName		= arrGB(1,0)
				iCountry	= arrGB(2,0)
				sEmail		= arrGB(3,0)
				sDate		= cor.butil.cvLcidTime(arrGB(4,0))
				shomepage	= arrGB(5,0)
				sComments	= arrGB(6,0)
				iMember		= arrGB(8,0)
			end if
		end select
	end sub
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	' Event Process (map inbound events to activities)
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	public sub controller(byVal eventIn)
		dim iDo : iDo = cor.filter.checkInt(eventIn) : if iDo = 0 Then exit sub
		'
		select case iDo
		'
		case cor_cDoNew
			'
			' post form
			'
			if NOT cor_bPostback Then
				exit sub
			else
				' remove any old validation error messages
				cor.str.wri "<script type=""text/javascript"">$('label[class^=errorfrm error]').remove();</script>"
				'Check Captcha is valid
				If bCaptcha Then call filterTextCaptcha
				If len(validateGBEntery)>0 Then
					cor.str.wri validateGBEntery
					call cor.butil.errorMsg(lngErrorDisplayLine1,lngValidationFail,True,3000,false,,0,false)
				else
					doAddComment()
					call cor.butil.successMsg(lngGuestBookEmailTitle,"Validation Successful",true,2000,true,cor_sWebroot & "guestbook.asp?pg=1",4000,false)
				end if
				response.end
			end if
				'
		case cor_cDoEdit
			'
			' post form
			'
			if NOT cor_bPostback Then
				exit sub
			else
				' remove any old validation error messages
				cor.str.wri "<script type=""text/javascript""><!-- <[CDATA[$('label[class^=errorfrm error]').remove();// ]]> --></script>"
				If bCaptcha Then call filterTextCaptcha
				If len(validateGBEntery)>0 Then
					cor.str.wri validateGBEntery
					call cor.butil.errorMsg(lngErrorDisplayLine1,lngValidationFail,True,3000,false,,0,false)
				else
					if iId > 0 Then
						doEditComment()
					end if
					call cor.butil.successMsg(lngGBSuccessfulEditMessage,"Validation Successful",true,2000,true,cor_sWebroot & "guestbook.asp?pg=" & iPage,4000,false)
				end if
				response.end
			end if
			'
		case cor_cDoDelete
			'
			' Only author and admin can perform deletions
			if (cor_bAdmin OR bAuthor) AND iId > 0 Then
				doDelComment()
				cor.redir cor_sWebroot & "guestbook.asp?pg=" & iPage
			end if
			'
		case else
			 cor.msg lngUnknownActivity
		end select
		'
	end sub
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	' Activities (atomical)
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	private sub doAddComment()
		'
		' Normalize url
		if left(lcase(shomepage),7) <> "http://" AND len(shomepage) > 7 Then shomepage = "http://" & shomepage
		' 
		' Insert new comment into DB and send email to members	
		'
		sName = cor.filter.BadWordFilter(sName)
		sComments = cor.filter.BadWordFilter(sComments)
		if iCountry < 1 then
			p_sql = "INSERT INTO " & cor_dbpre & "guestbook (name,email,homepage,comments,IP,gbdate,member) VALUES ({0},{1},{2},{3},{4},{5},{6})"
			cor.dal.exec p_sql, array(sName,sEmail,shomepage,sComments,request.serverVariables("REMOTE_ADDR"),sDate,iMember)
		else
			p_sql = "INSERT INTO " & cor_dbpre & "guestbook (name,country_ID,email,homepage,comments,IP,gbdate,member) VALUES ({0},{1},{2},{3},{4},{5},{6},{7})"
			cor.dal.exec p_sql, array(sName,iCountry,sEmail,shomepage,sComments,request.serverVariables("REMOTE_ADDR"),sDate,iMember)
		end if
		'
		if cor_bMember Then 'send email
			cor.str.add lngGuestBookEmailTitle & ": " & sName 		& "<br />"
			if len(sEmail)	> 0 Then cor.str.add lngGuestBookEmail 		& ": " & sEmail 	& "<br />"
			if len(shomepage) > 0 Then cor.str.add lngGuestBookHomePage 	& ": " & shomepage  & "<br />"
			cor.str.add lngGuestBookComments   & ": " & sComments
			call cor.mail.send(sEmail, sName, cor_sReplyMail, cor.cfg.item("SenderName"), cor.cfg.item("WebsiteTitle") & ": " & lngGuestbookMsgHeader, cor.str.build, 1)
		end if
	end sub
	'
	private sub doEditComment()
		sName = cor.filter.BadWordFilter(sName)
		sComments = cor.filter.BadWordFilter(sComments)
		p_sql = "UPDATE " & cor_dbpre & "guestbook SET name={0}, country_ID={1}, comments={2}, email={3}, homepage={4} WHERE id={5}"
		cor.dal.exec p_sql, array(sName, iCountry, sComments, sEmail, shomepage, iId)
	end sub
	'
	private sub doDelComment()
		p_sql = "DELETE FROM " & cor_dbpre & "guestbook WHERE id={0}"
		cor.dal.exec p_sql, array(iId)
	end sub
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	' Class Helpers
	'
	'------------------------------------------------------------------------------------------------------------------------------------------

	private Function filterTextCaptcha()
		if cor_bPostback Then 
			if bCaptcha Then
				if NOT cor.butil.checkSecurityCode(sSecurityCode, sessionName) Then
					call cor.butil.errorMsg(lngReenterCaptcha,lngValidationFail,True,3000,false,,0,false)
					cor.str.wri "<script type=""text/javascript"">$('<label class=""errorfrm error"">" & lngReenterCaptcha & "</label>').insertAfter('#securityCode');</script>"
'					response.end
					exit function
				end if
			end If
			filterTextCaptcha = true
		end if
	end function

	Private Function validateGBEntery()
		' added for server side validation
		if len(cor.io.f("name")) <3 _ 
			OR len(cor.io.f("email")) <= 8 _
			OR instr(1,cor.io.f("email"),"@",1)=0 _
			OR instr(1,cor.io.f("email"),".",1)=0 _
			OR len(cor.io.f_rtf("comments")) <=5  then cor.str.add "<script type=""text/javascript""><!-- <[CDATA["
		if len(cor.io.f("name")) <3 then cor.str.add "$('<label class=""errorfrm error"">" & lngGBErrNoName & "</label>').insertAfter('#name');"
		if len(cor.io.f("email")) <= 8 OR instr(1,cor.io.f("email"),"@",1)=0 OR instr(1,cor.io.f("email"),".",1)=0 then cor.str.add "$('<label class=""errorfrm error"">" & lngGBErrBadEmail & "</label>').insertAfter('#email');"
		if len(cor.io.f_rtf("comments")) <=5 then cor.str.add "$('<label class=""errorfrm error"">" & lngGBErrComment & "</label>').insertBefore('#comments');"
		if len(cor.io.f("name")) <3 _
			OR len(cor.io.f("email")) <= 8 _
			OR instr(1,cor.io.f("email"),"@",1)=0 _
			OR instr(1,cor.io.f("email"),".",1)=0 _
			OR len(cor.io.f_rtf("comments")) <=5 then cor.str.add "// ]]> --></script>"
		validateGBEntery = cor.str.build
	End Function
	'
end class
'
'------------------------------------------------------------------------------------------------------------------------------------------
'
' Utility class 
'
'------------------------------------------------------------------------------------------------------------------------------------------
class class_guestbook_utils
	'
	public function getCountryByUserID(userID)
		dim arrUserCountry
		'
		if cor.filter.checkLng(userID) = 0 Then
			getCountryByUserID = Empty
			exit function
		end if
		p_sql = "SELECT T1.CountryID, T1.Country FROM " & cor_dbpre & "country AS T1 LEFT JOIN " & cor_dbpre & "members AS T2 ON T2.mlocation = T1.CountryID " _
			& "WHERE T2.MemberID={0}" 
		cor.dal.open arrUserCountry, p_sql, array(cor_lUserID)
		'
		if cor.butil.eof(arrUserCountry) Then
			getCountryByUserID = empty
		else
			getCountryByUserID = arrUserCountry(0,0)
		end if
	end function
	'	
	private p_sql
end class
'
'<#late-binding hook
function boot_class_guestbook : boot_class_guestbook = true : end function
'/>

%>
