﻿<%
'--------------------------------------------------------------------------------------------------------------------------------------
' SOOP 2.0 - Phoenix (TNG)
'
' Revision 2.00 - initial 15/02/2008
'
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'--------------------------------------------------------------------------------------------------------------------------------------
%>
<% 
'********************************************************************
'** geckoHeadlines for SooP 2.0
'** Initially written for SooP 1.x by Dan Bodenstein 
'** http://www.scriptgecko.com
'******************************************************************** 
'
class SGMOD_RSSFeed_Out
	public Title
	public Link
	public Description
	public TTL
	public Language
	public Copyright
	public ManagingEditor
	public Webmaster
	public PublicationDate
	public LastBuildDate
	public Category
	public Generator
	public TimeOffset
	public Docs
	public Entries()
	public EntryCount
	public ImageURL
	public ImageTitle
	public ImageLink
	public ImageWidth
	public ImageHeight
	private iEntryCount
	private CurrentEntry

	private sub class_initialize()
		Title 		= ""
		Link 		= ""
		Description = ""
		TTL			= 60
		EntryCount	= 0
		redim Entries(0)
		TimeOffset 	= "-5"   ' <-----------  You must set this to the servers GMT difference.
		ImageURL	= ""
		ImageTitle  = ""
		ImageLink   = ""
		ImageWidth  = "0"
		ImageHeight = "0"
	end sub


	public sub AddItem(rssItem)
		if iEntryCount > 0 then 
			redim preserve Entries(ubound(Entries)+1)
		end if
		iEntryCount = iEntryCount + 1
		EntryCount  = iEntryCount
		'set Entries(ubound(Entries)) = NEW SGMOD_RSSItem_Out 
		set Entries(ubound(Entries)) = RssItem
	end sub
'	
	public function BuildFeed()
		dim x,sTitle, sXMLContent
		cor.str.clear
		cor.str.growSize = 1000
		'
		cor.str.add "<?xml version=""1.0"" encoding=""UTF-8"" ?>"
		cor.str.add "<rss version=""2.0"">"
		cor.str.add "<channel>"
		cor.str.add "<title>" & Title & "</title> "
		cor.str.add "<link>" & Link & "</link>"
		cor.str.add "<description>" & Description & "</description> "
		cor.str.adn GetParameter("language", Language, false)
		cor.str.adn GetParameter("copyright", cor.butil.htmlEncode(Copyright), false)
		cor.str.adn GetParameter("managingEditor", ManagingEditor, false)
		cor.str.adn GetParameter("webMaster", Webmaster, false)
		cor.str.adn GetParameter("pubDate", PublicationDate, true)
		cor.str.adn GetParameter("lastBuildDate", LastBuildDate, true)
		cor.str.adn GetParameter("category", cor.butil.htmlEncode(Category), false)
		cor.str.adn GetParameter("generator", cor.butil.htmlEncode(Generator), false)
		cor.str.adn GetParameter("docs", Docs, false)
		cor.str.adn GetParameter("ttl", TTL, false)
		if ImageURL <> "" then 
			cor.str.add "<image>" 
			cor.str.adn GetParameter("title", ImageTitle, false)
			cor.str.adn GetParameter("url", ImageURL, false)
			cor.str.adn GetParameter("link", ImageLink, false)
			cor.str.adn GetParameter("width", ImageWidth, false)
			cor.str.adn GetParameter("height", ImageHeight, false)
			cor.str.add "</image>"
		end if

		for x = 0 to EntryCount -1
			With Entries(x)
			cor.str.add "<item>"
			cor.str.adn GetParameter("title", cor.butil.htmlEncode(.Title), false)
			cor.str.adn GetParameter("link", .Link, false) &  vbcrlf
			cor.str.adn GetParameter("description", cor.butil.htmlEncode(.Description), false)
			cor.str.adn GetParameter("author", .Author, false)
			cor.str.adn GetParameter("category", cor.butil.htmlEncode(.Category), false)
			cor.str.adn GetParameter("comments", .Comments, false)
			cor.str.adn GetParameter("guid", .GUID, false)
			cor.str.adn GetParameter("pubDate", .PublicationDate, true)
			if lenB(.EnclosureURL) > 0 then
				cor.str.add "<enclosure url=""" & .EnclosureURL & """ length=""" & .EnclosureLength &""" type=""" & .EnclosureType & """ />"
			end if
			if lenB(.SourceURL) > 0 then
				cor.str.adn "<source url=""" & .SourceURL & """>" & cor.butil.htmlEncode(.SourceTitle) &"</source>"
			end if
			cor.str.adn  ("</item>")
			end with
		next
		cor.str.adn "</channel>"
		cor.str.adn "</rss>"
		'
		BuildFeed = cor.str.build
	end function

	private function GetParameter(Name,Content,ContentisDate)
		if len(Content) > 0 then
			if ContentisDate then Content = ConvertDate(DateAdd("h",TimeOffset,Content))
			GetParameter = "<" & Name & ">" & Content & "</" & Name & ">" & vbcrlf
		else
			GetParameter = vbNullString
		end if
	end function	

	private function ConvertDate(OriginalDate)
		dim sDatePart,sTimePart

		sDatePart = WeekdayName(Weekday(OriginalDate), true, vbSunday) & ", " & AddLeadingZero(Day(OriginalDate)) & " " & MonthName(Month(OriginalDate), true) & " " & Year(OriginalDate)
		sTimePart = cor.butil.datetime(OriginalDate, vbShortTime) & ":" & AddLeadingZero(Second(OriginalDate)) & " GMT"

		ConvertDate = sDatePart & " " & sTimePart
	end function

	private function AddLeadingZero(Number)
		if lenB(cstr(Number)) = 2 then
			AddLeadingZero = "0" & cstr(Number)
		else
			AddLeadingZero = cstr(Number)
		end if
	end function
	
end class
'
'------------------------------------------------------------------------------------------------------------------------------------------
'
'
'
'------------------------------------------------------------------------------------------------------------------------------------------
class SGMOD_RSSItem_Out
	public Description
	public Link
	public publicationDate
	public Title
	public Comments
	public GUID
	public Category
	public SourceURL
	public SourceTitle
	public EnclosureURL
	public EnclosureLength
	public EnclosureType
	public Author
end class 

%>
